2012-08-10  Mario Sanchez Prada  <msanchez@igalia.com>

        [GTK] Broken implementation of AtkText and AtkEditableText for password fields
        https://bugs.webkit.org/show_bug.cgi?id=93621

        Rubber-stamped by Ryosuke Niwa.

        Fix Apple Win build, by avoiding to generate unreachable sections
        of code in AccessibilityRenderObject::passwordFieldValue().

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::passwordFieldValue):

2012-08-10  Mario Sanchez Prada  <msanchez@igalia.com>

        [GTK] Broken implementation of AtkText and AtkEditableText for password fields
        https://bugs.webkit.org/show_bug.cgi?id=93621

        Reviewed by Chris Fleizach.

        Fix broken implementation of AtkText and AtkEditableText
        interfaces in the GTK port for password input fields.

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::stringValue): Call the new
        function passwordFieldValue() for password input fields.
        (WebCore::AccessibilityRenderObject::text): Ditto.
        (WebCore::AccessibilityRenderObject::textLength): Return the
        actual length of the password in the field for GTK, return -1
        otherwise (not to break current behavior in other platforms).
        (WebCore::AccessibilityRenderObject::doAXStringForRange): Don't
        early return for password fields in GTK (will rely on text()).
        (WebCore::AccessibilityRenderObject::passwordFieldValue): New, it
        returns the text being actually rendered for a password input
        field (normally a masked string) in GTK. It returns String() in
        the rest of platforms, to ensure we don't break anything there.
        (WebCore):
        * accessibility/AccessibilityRenderObject.h:
        (AccessibilityRenderObject):
        * accessibility/AccessibilityObject.h:
        (WebCore::AccessibilityObject::passwordFieldValue): Default
        implementation of this new method, returning an empty string.
        (AccessibilityObject):

        Ensure the 'text-insert' and 'text-remove' signals for the AtkText
        interface are properly emitted for password input fields.

        * accessibility/gtk/AXObjectCacheAtk.cpp:
        (WebCore::AXObjectCache::nodeTextChangePlatformNotification): Make
        sure we never emit the password value for an input field in plain
        text when inserting or removing text. Emit the masked text instead.

2012-08-09  Mario Sanchez Prada  <msanchez@igalia.com>

        REGRESSION (r124997): Flaky crashes in two tests
        https://bugs.webkit.org/show_bug.cgi?id=93501

        Reviewed by Martin Robinson.

        Add missing null check to make sure we early return if the
        accessibility object does not have a valid parent exposed in the
        accessibility hierarchy.

        * accessibility/gtk/AXObjectCacheAtk.cpp:
        (WebCore::emitTextChanged): Add missing null check.

2012-08-08  Mario Sanchez Prada  <msanchez@igalia.com>

        REGRESSION(r65062): out of bound access in TextIterator (5 editing tests) on GTK
        https://bugs.webkit.org/show_bug.cgi?id=63611

        Reviewed by Ryosuke Niwa.

        Ensure document's layout is up-to-date before using TextIterator
        to properly calculate the offset for a text change when emitting
        accessibility related signals in GTK.

        * accessibility/gtk/AXObjectCacheAtk.cpp:
        (WebCore::AXObjectCache::nodeTextChangePlatformNotification): Call
        to document->updateLayout() before using TextIterator.

2012-06-21  Kalev Lember  <kalevlember@gmail.com>

        [GTK] Fix NPAPI plugins on Windows
        https://bugs.webkit.org/show_bug.cgi?id=54531

        Reviewed by Martin Robinson.

        Switch to using PluginPackageWin.cpp and PluginViewWin.cpp on Windows
        platform, and leave plugins/gtk/ only for XP_UNIX platforms. With this
        we can share a lot of code with other ports and don't have to
        reimplement all the Windows-specific code in plugins/gtk/.

        * GNUmakefile.am:
        * GNUmakefile.list.am:
        * platform/FileSystem.h:
        (WebCore):
        * platform/graphics/GraphicsContext.h:
        (GraphicsContext):
        * platform/graphics/cairo/GraphicsContextPlatformPrivateCairo.h:
        (WebCore::GraphicsContextPlatformPrivate::GraphicsContextPlatformPrivate):
        (GraphicsContextPlatformPrivate):
        * platform/graphics/transforms/TransformationMatrix.h:
        (TransformationMatrix):
        * platform/graphics/win/GraphicsContextCairoWin.cpp:
        (WebCore):
        * platform/graphics/win/GraphicsContextWin.cpp:
        (WebCore):
        * platform/gtk/FileSystemGtk.cpp:
        (WebCore::unloadModule):
        * plugins/PluginView.h:
        (PluginView):
        * plugins/win/PluginViewWin.cpp:
        (windowHandleForPageClient):
        (WebCore::registerPluginView):
        (WebCore::PluginView::paint):
        (WebCore::PluginView::handleMouseEvent):
        (WebCore::PluginView::platformStart):
        (WebCore::PluginView::snapshot):

2012-06-28  Kalev Lember  <kalevlember@gmail.com>

        [GTK][Win]: Fix plugin drawing to an offscreen buffer
        https://bugs.webkit.org/show_bug.cgi?id=89499

        Reviewed by Brent Fulgham.

        Take into account that the GTK+ port draws to a backing store and adjust
        the target rectangle calculation accordingly.

        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::paint):
        (WebCore::PluginView::setNPWindowRect):

2012-02-28  Nikolas Zimmermann  <nzimmermann@rim.com>

        Integrate SVGUseElement within the new shadow root concept
        https://bugs.webkit.org/show_bug.cgi?id=78902

        Reviewed by Zoltan Herczeg.

        Replace SVG shadow tree implementation with the new, modern #shadow-root implementation.

        Current situation in trunk:
        SVGUseElement doesn't create/hold the shadow tree, unlike its expected in
        the modern #shadow-root concept, but its renderer RenderSVGShadowTreeRootContainer.
        That creates a cycle, as the actual DOM tree is stored as RefPtr<SVGGElement> inside
        a renderer - that's weak conceptually, and has lead to sublte security bugs in the past.

        Whenever a target element of a <use> element changed, invalidateShadowTree() is called
        which calls setNeedsStyleRecalc(), and sets m_needsShadodwTreeRecreation to true.
        Once style recalculation happens, the RenderSVGShadowTreeRootContainer then eventually
        built the shadow tree, by cloning the target node, building the SVGElementInstance tree
        etc, -- all within the render tree.

        To easy reviewing, here's a dump of the current render tree for a simple <use> example:
        <defs><rect id="rect"/></defs><use xlink:href="#rect"/>

        Dump of render tree:
        RenderSVGHiddenContainer {defs}        // <defs> (SVGDefsElement)
            RenderSVGRect {rect}               // <rect> (SVGRectElement)
        RenderSVGShadowTreeRootContainer {use} // <use> (SVGUseElement)
            RenderSVGContainer {g}             // <g> (SVGShadowTreeRootElement)
                RenderSVGRect {rect}           // <rect> (SVGRectElement, clone of <rect> in <defs>)

        The SVGShadowTreeRootElement is created & stored by RenderSVGShadowTreeRootContainer,
        the renderer of the <use> element. The RenderSVGTransformableContainer renderer created
        for the SVGShadowTreeRootElement stores the x/y translation induced by the <use> attributes.

        There are lots of places all over WebCore that assume the existance of a <g> renderer
        as first child of the <use> element, representing the "SVG shadow tree root".

        Summary of this patch:
        Let SVGUseElement create&maintain a #shadow-root, and append the cloned target elements
        into this shadow root. We no longer have to take care of attachment/detachment, style
        recalculation, etc. - that's handled transparenly by ShadowRoot(List) now.

        This makes SVGShadowTreeElements & RenderSVGShadowTreeRootContainer obsolete. Switch
        SVGUseElement to create a RenderSVGTransformableContainer as its renderer, and make
        it respect the translation induced by the x/y attributes, given for a <use> element.

        Remove all occourences of SVGShadowRoot, remove all special cases it induced.

        It's all covered by existing tests, took a while to make them all pass again.

        * CMakeLists.txt: Remove SVGShadowTreeElements/RenderSVGShadowTreeRootContainer from build.
        * GNUmakefile.list.am: Ditto.
        * Target.pri: Ditto.
        * WebCore.gypi: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::collectMatchingRulesForList): Enable fast path for selector checking, now that special shadow tree rules are gone.
        * css/SelectorChecker.cpp:
        (WebCore::linkAttribute): No need to guard this code with ENABLE(SVG).
        (WebCore::SelectorChecker::checkSelector): Remove obsolete SVG shadow root special case.
        * dom/EventDispatcher.cpp:
        (WebCore::eventTargetRespectingSVGTargetRules): Remove loop, simplify & cleanup this code.
        (WebCore::EventDispatcher::adjustToShadowBoundaries): s/isShadowRootOrSVGShadowRoot/isShadowRoot/.
        (WebCore::EventDispatcher::adjustRelatedTarget): Ditto.
        (WebCore::EventDispatcher::ensureEventAncestors): Simplify logic for SVG, fixed a FIXME.
        * dom/Node.cpp: Remove obsolete svgShadowHost().
        (WebCore::Node::shadowTreeRootNode): Remove obsolete isSVGShadowRoot() checks.
        (WebCore::Node::nonBoundaryShadowTreeRootNode): Ditto.
        (WebCore::Node::isInShadowTree): Make it const.
        * dom/Node.h: Remove isSVGShadowRoot/svgShadowHost.
        (WebCore::Node::isShadowRoot): s/IsShadowRootOrSVGShadowRootFlag/isShadowRoot/.
        (WebCore::Node::parentNode): Augment comments.
        (WebCore::Node::parentNodeGuaranteedHostFree): Ditto.
        * dom/Range.cpp:
        (WebCore::Range::checkNodeBA): Remove obsolete SVG shadow root special case.
        * dom/ScriptElement.cpp:
        (WebCore::ScriptElement::prepareScript): Ditto.
        * rendering/RenderObject.h: Remove isSVGShadowTreeRootContainer.
        (WebCore::RenderObject::isSVGTransformableContainer): Added.
        * rendering/svg/RenderSVGAllInOne.cpp: Remove SVGShadowTreeElements/RenderSVGShadowTreeRootContainer from build.
        * rendering/svg/RenderSVGModelObject.cpp:
        (WebCore::isGraphicsElement): To check for <use>, a tag name comparision is needed now, as it no longer has a special renderer.
        * rendering/svg/RenderSVGResourceClipper.cpp:
        (WebCore::RenderSVGResourceClipper::drawContentIntoMaskImage): Ditto.
        (WebCore::RenderSVGResourceClipper::calculateClipContentRepaintRect): Ditto.
        (WebCore::RenderSVGResourceClipper::hitTestClipContent): Ditto.
        * rendering/svg/RenderSVGResourceContainer.cpp: Remove RenderSVGShadowTreeRootContainer.h include.
        * rendering/svg/RenderSVGShadowTreeRootContainer.cpp: Removed.
        * rendering/svg/RenderSVGShadowTreeRootContainer.h: Removed.
        * rendering/svg/RenderSVGTransformableContainer.cpp: Keep track of last used additional x/y translation.
        (WebCore::RenderSVGTransformableContainer::calculateLocalTransform): Handle x/y translation for <use> contains here, instead of storing it in the SVGShadowTreeRootElement.
        * rendering/svg/RenderSVGTransformableContainer.h: Store last used x/y translation.
        (WebCore::RenderSVGTransformableContainer::isSVGTransformableContainer): Return true.
        (WebCore::toRenderSVGTransformableContainer): Add conversion helpers.
        * rendering/svg/RenderSVGViewportContainer.cpp: Ditto.
        (WebCore::RenderSVGViewportContainer::calcViewport): Handle width/height attributes inheritance from the <use> element, if we're a <svg> or <symbol> replacement in the shadow tree.
        * rendering/svg/RenderSVGViewportContainer.h: Remove isSVGContainer() override which is not needed here (already present in RenderSVGContainer).
        * rendering/svg/SVGShadowTreeElements.cpp: Removed.
        * rendering/svg/SVGShadowTreeElements.h: Removed.
        * svg/SVGAElement.cpp:
        (WebCore::SVGAElement::createRenderer): Check if parentNode is really a SVGElement, before casting.
        * svg/SVGElement.cpp:
        (WebCore::SVGElement::isOutermostSVGSVGElement): Early exit if tag name isn't <svg>, or if we're in a shadow tree (can't be an outermost <svg> element then).
        (WebCore::hasLoadListener): Deploy parentOrHostElement() usage to remove any special cases, related to shadow boundaries.
        (WebCore::SVGElement::sendSVGLoadEventIfPossible): Ditto.
        (WebCore::SVGElement::customStyleForRenderer): Ditto.
        * svg/SVGElementInstance.cpp:
        (WebCore::SVGElementInstance::invalidateAllInstancesOfElement): Call updateStyleIfNeeded() instead of updateLayoutIgnorePendingStylesheets().
        * svg/SVGGElement.cpp:
        (WebCore::SVGGElement::rendererIsNeeded): s/parentNode/parentOrHostElement/ - we need to cross shadow boundaries now.
        * svg/SVGGElement.h: Remove obsolete isShadowTreeContainerElement().
        * svg/SVGLocatable.cpp:
        (WebCore::SVGLocatable::nearestViewportElement): s/parentNode/parentOrHostElement/ - we need to cross shadow boundaries now.
        (WebCore::SVGLocatable::farthestViewportElement): Ditto.
        (WebCore::SVGLocatable::computeCTM): Ditto.
        * svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::title): Ditto. (+ simplify code a lot, no need to walk the shadow tree to find its root anymore, use isInShadowTree() helper.)
        (WebCore::SVGStyledElement::rendererIsNeeded): Ditto.
        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::SVGUseElement): Remove no longer needed m_updatesBlocked.
        (WebCore::SVGUseElement::create): Always call ensureShadowRoot(), to create a #shadow-root, upon creating a SVGUseElement.
        (WebCore::SVGUseElement::insertedIntoDocument): Align with SVGFEImageElement/SVGTRefElement - call buildPendingResource() from insertedIntoDocument(), finally! (no renderer needed anymore to update the SVG shadow subtree).
        (WebCore::SVGUseElement::removedFromDocument): Align with SVGFEImageElement/SVGTRefElement - immediately release the SVGElementInstance & shadow tree, once we're removed from the document.
        (WebCore::SVGUseElement::svgAttributeChanged): Simplify code a lot, no longer need to deal with x/y/width/height attributes, the renderes in the shadow tree grab these values from their corresponding <use> elements automatically now.
        (WebCore::SVGUseElement::willRecalcStyle):
            New main part of the logic. invalidateShadowTree() calls setNeedsStyleRecalc, and sets m_needsShadowTreeRecreation=true. If we encounter this case, force rebuilding the SVG shadow tree
            and the SVGElementInstance tree, immediately, before executing the actual style recalc. This allows us to lazily rebuild the SVG shadow tree for the <use> element. Consider:
            <defs><rect id="rect"></defs> <use xlink:href="#rect"/>. Now from a script we change the rect x/y/width/height attributes:
            rect.setAttribute("x", "10"); rect.setAttribute("y", "10")... each call will lead to a SVGUseElement::invalidateShadowTree() call by SVGElementInstance::invalidateAllInstancesOfElement, invoked after the <rect> element got parsed.
            This won't update the shadow tree four times, but only once upon the next style recalculation - otherwise performance is a nightmare.
            This will serve as future starting point, to explore partial SVG subtree re-clones, which should easily be doable now.
        (WebCore::dumpInstanceTree): Add a 'static' to allow DUMP_INSTANCE_TREE to be used in clang builds.
        (WebCore::SVGUseElement::clearResourceReferences): Added helper to release instance & shadow tree.
        (WebCore::SVGUseElement::buildPendingResource): Modeled exactly like SVGFEImageElement/SVGTRefElement. It's possible to share more code between these in future.
        (WebCore::SVGUseElement::buildShadowAndInstanceTree): Cleanup code, adapt to new shadow-root concept.
        (WebCore::SVGUseElement::createRenderer): Create a RenderSVGTransformableContainer, no longer a <use> specific renderer.
        (WebCore::removeDisallowedElementsFromSubtree): Use new replacedChild/appendChild variants, that don't require a ExceptionCode to be passed in.
        (WebCore::SVGUseElement::buildShadowTree): Ditto.
        (WebCore::SVGUseElement::expandUseElementsInShadowTree): Ditto.
        (WebCore::SVGUseElement::expandSymbolElementsInShadowTree): Ditto.
        (WebCore::SVGUseElement::invalidateShadowTree): Only trigger style recalculations if needed.
        * svg/SVGUseElement.h: Remove lots of now unnecessary overrides: attach/detach/didRecalcStyle/updateContainerOffset/updateContainerSizes/etc..
        * svg/animation/SVGSMILElement.cpp:
        (WebCore::SVGSMILElement::insertedIntoDocument): No need to walk the shadow tree to find its root anymore, use isInShadowTree() helper.

2012-02-23  Philip Rogers  <pdr@google.com>

        Recompute font metrics on scale changes
        https://bugs.webkit.org/show_bug.cgi?id=75091

        Reviewed by Nikolas Zimmermann.

        SVG text metrics depend on the transform from renderer to the svg root
        which requires that we propagate transform changes down to text.
        This change adds a boolean for tracking transform changes to
        SVGViewportContainers and SVGTransformableContainers, and updates
        RenderSVGText::layout() to recalculate text metrics if the transform
        of an ancestor has changed.

        Tests: platform/mac/svg/text/text-rescale.html
               platform/mac/svg/text/text-viewbox-rescale.html
               svg/text/text-rescale.html
               svg/text/text-viewbox-rescale.html

        * rendering/RenderObject.h:
        (WebCore::RenderObject::isSVGTransformableContainer):
        (WebCore::RenderObject::isSVGViewportContainer):
        * rendering/svg/RenderSVGContainer.h:
        (WebCore::RenderSVGContainer::didTransformToRootUpdate):
        * rendering/svg/RenderSVGInlineText.cpp:
        (WebCore::RenderSVGInlineText::computeNewScaledFontForStyle):
        * rendering/svg/RenderSVGText.cpp:
        (WebCore::RenderSVGText::RenderSVGText):
        (WebCore::RenderSVGText::layout):
        * rendering/svg/RenderSVGText.h:
        (WebCore::RenderSVGText::setNeedsTextMetricsUpdate):
        (RenderSVGText):
        * rendering/svg/RenderSVGTransformableContainer.cpp:
        (WebCore::RenderSVGTransformableContainer::RenderSVGTransformableContainer):
        (WebCore::RenderSVGTransformableContainer::calculateLocalTransform):
        * rendering/svg/RenderSVGTransformableContainer.h:
        (WebCore::RenderSVGTransformableContainer::isSVGTransformableContainer):
        (WebCore::RenderSVGTransformableContainer::didTransformToRootUpdate):
        (RenderSVGTransformableContainer):
        * rendering/svg/RenderSVGViewportContainer.cpp:
        (WebCore::RenderSVGViewportContainer::RenderSVGViewportContainer):
        (WebCore::RenderSVGViewportContainer::calcViewport):
        * rendering/svg/RenderSVGViewportContainer.h:
        (WebCore::RenderSVGViewportContainer::didTransformToRootUpdate):
        (RenderSVGViewportContainer):
        * rendering/svg/SVGRenderSupport.cpp:
        (WebCore::SVGRenderSupport::transformToRootChanged):
        (WebCore):
        (WebCore::SVGRenderSupport::layoutChildren):
        * rendering/svg/SVGRenderSupport.h:
        (SVGRenderSupport):

2012-03-01  Stephen Chenney  <schenney@chromium.org>

        Crash in WebCore::SVGDocumentExtensions::removeAnimationElementFromTarget
        https://bugs.webkit.org/show_bug.cgi?id=79831

        Reviewed by Eric Seidel.

        Out-of-order operations in the SVGSMILElement::removedFromDocument
        method caused its target to be removed and then re-added due to a
        later call. This led to the target being set on the animation while
        the target element itself was unaware. At deletion time, this caused a
        crash (or assert in debug builds). Thanks to Abhishek Arya for help
        with the layout test.

        Test: svg/animations/smil-element-target-crash-main.html

        * svg/animation/SVGSMILElement.cpp:
        (WebCore::SVGSMILElement::removedFromDocument):

2012-02-24  Abhishek Arya  <inferno@chromium.org>

        Overhanging floats not removed from new flex box.
        https://bugs.webkit.org/show_bug.cgi?id=79522

        Reviewed by Ojan Vafai.

        Similar to r69476.

        Test: fast/flexbox/overhanging-floats-not-removed-crash.html

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::removeFloatingOrPositionedChildFromBlockLists):

2012-02-21  Abhishek Arya  <inferno@chromium.org>

        Crash in RenderTableSection::nodeAtPoint.
        https://bugs.webkit.org/show_bug.cgi?id=78922

        Reviewed by Julien Chaffraix.

        Test: fast/table/table-section-node-at-point-crash.html

        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::nodeAtPoint): recalc cells if the
        m_needsCellRecalc is set. Otherwise, we will end up accessing
        removed table cells.

2012-02-22  Abhishek Arya  <inferno@chromium.org>

        Cloning and linebox issues in multi-column layout.
        https://bugs.webkit.org/show_bug.cgi?id=78273

        Reviewed by Eric Seidel.

        Tests: fast/multicol/span/clone-flexbox.html
               fast/multicol/span/clone-summary.html
               fast/multicol/span/textbox-not-removed-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::clone): Fix cloning algorithm to take
        care of cloning descendant classes of RenderBlock.
        (WebCore::RenderBlock::splitBlocks): When we move our inline children
        to cloneBlock, we need to clear our entire line box tree. Any descendant
        child in the hierarchy could be a part of our line box tree and will
        never get cleared since the child has moved to new parent cloneBlock.

2012-02-28  Abhishek Arya  <inferno@chromium.org>

        Incorrect before child parent calculation when adding new children
        to anonymous column blocks.
        https://bugs.webkit.org/show_bug.cgi?id=79755

        Reviewed by David Hyatt.

        before child can be wrapped in anonymous containers, so need to
        take care of that in before child parent calculation.

        Test: fast/multicol/span/before-child-anonymous-column-block.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::addChildToAnonymousColumnBlocks):

2012-02-21  Adam Klein  <adamk@chromium.org>

        ContainerNode::childrenChanged must be called immediately after removing children
        https://bugs.webkit.org/show_bug.cgi?id=79162

        Reviewed by Ryosuke Niwa.

        In r108152, a call to childrenChanged() was erroneously moved
        below the call to child->removedFromDocument(). This breaks, at the
        least, the behavior of the <title> element. This patch corrects the
        mistake and adds a test.

        Test: fast/dom/title-directionality-removeChild.html

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::removeChild):

2012-02-17  Adam Klein  <adamk@chromium.org>

        Avoid inconsistency in Node::inDocument due to DOMSubtreeModified dispatch
        https://bugs.webkit.org/show_bug.cgi?id=76087

        Reviewed by Ryosuke Niwa.

        Move post-removal notifications after call to Node::removeFromDocument
        to avoid inconsistent state of Node::inDocument() and thus avoid
        inconsistent state in DocumentOrderedMap.

        Tests: fast/dom/getElementById-consistency.html
               fast/dom/getElementById-consistency2.html

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::removeChild):
        * svg/SVGTRefElement.cpp:
        (WebCore::SVGTRefElement::updateReferencedText): Fixed to work with new timing of DOMSubtreeModified dispatch.

2012-03-25  Abhishek Arya  <inferno@chromium.org>

        Crash in ContainerNode::resumePostAttachCallbacks.
        https://bugs.webkit.org/show_bug.cgi?id=82159

        Reviewed by Hajime Morita.

        Test: plugins/object-onfocus-mutation-crash.html

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::resumePostAttachCallbacks): dispatching post attach
        callbacks when our attach depth is 1 can fire mutation events such as onfocus
        which can blow away |this|. Need to protect it with a RefPtr.
        * html/HTMLPlugInImageElement.cpp:
        (WebCore::HTMLPlugInImageElement::attach): add calls to suspend attach callbacks
        until the function completes.

2012-03-09  Tom Sepez  <tsepez@chromium.org>

        Hold cached images with a CachedResourceHandle rather than a raw pointer for CSSCrossfadeValue
        https://bugs.webkit.org/show_bug.cgi?id=80186

        Reviewed by Simon Fraser.

        Test: http/tests/css/cross-fade-reload.html

        * css/CSSCrossfadeValue.h:
        (CSSCrossfadeValue):

2012-05-31  Hajime Morrita  <morrita@chromium.org>

        REGRESSION(r117572): editing/spelling/spellcheck-async-remove-frame.html crashes on Mac
        https://bugs.webkit.org/show_bug.cgi?id=86859

        Reviewed by Ryosuke Niwa.

        The test tries to reach an invalid SpellChecker object. Such an access should be guarded
        beforehand.

        Asynchronous spellchecking can return results after originated
        frame is gone, which triggered an invalid access to the dead spellchecker
        object. This chagne prevents it by marking request objects from
        the spellchecker as invalid:

        - Originally TextCheckerClient API was passed a SpellCheker object.
          This change abstracted it behind TextCheckingRequest interface,
          didSucceed() and didCancel() method specifically.
        - TextCheckingRequest was turned from a plain old object into
          a refcounted abstract class, which is now subclassed by SpellCheckRequest.
        - SpellChecker now marks pending SpellCheckRequest objects as invalid
          on its destructor.

        Test: editing/spelling/spellcheck-async-remove-frame.html

        * WebCore.exp.in:
        * editing/SpellChecker.cpp:
        (WebCore::SpellCheckRequest::SpellCheckRequest):
        (WebCore::SpellCheckRequest::create):
        (WebCore::SpellCheckRequest::didSucceed):
        (WebCore):
        (WebCore::SpellCheckRequest::didCancel):
        (WebCore::SpellCheckRequest::wasRequestedBy):
        (WebCore::SpellCheckRequest::requesterDestroyed):
        (WebCore::SpellChecker::~SpellChecker):
        (WebCore::SpellChecker::requestCheckingFor):
        (WebCore::SpellChecker::invokeRequest):
        (WebCore::SpellChecker::didCheckSucceed):
        (WebCore::SpellChecker::didCheckCancel):
        * editing/SpellChecker.h:
        (WebCore):
        (SpellCheckRequest):
        (WebCore::SpellCheckRequest::isStarted):
        (SpellChecker):
        * loader/EmptyClients.h:
        (WebCore::EmptyTextCheckerClient::requestCheckingOfString):
        * platform/text/TextCheckerClient.h:
        (TextCheckerClient):
        * platform/text/TextChecking.h:
        (GrammarDetail):
        (TextCheckingResult):
        (TextCheckingRequest):
        (WebCore::TextCheckingRequest::~TextCheckingRequest):

2012-04-18  Hironori Bono  <hbono@chromium.org>

        Split SpellChecker::didCheck() to SpellChecker::didCheckSucceeded() and SpellChecker::didCheckCanceled()
        https://bugs.webkit.org/show_bug.cgi?id=83748

        Reviewed by Ryosuke Niwa.

        The current SpellChecker::didCheck() does not delete existing markers. It causes
        a problem that it leaves misspelled markers when a spellchecker client finishes
        checking text successfully. This change splits this function to didCheckSucceeded()
        and  didCheckCanceled() so the SpellChecker class can delete existing markers
        when its client finishes checking text successfully. (We do not have to erase
        existing markers when the client needs to cancel a text-check request.)

        Test: platform/chromium/editing/spelling/delete-misspelled-word.html

        * WebCore.exp.in: Replaced SpellChecker::didCheck with SpellChecker::didCheckSucceeded.
        * editing/SpellChecker.cpp:
        (WebCore::SpellChecker::didCheckSucceeded): Added.
        (WebCore):
        (WebCore::SpellChecker::didCheckCanceled): Added.
        * editing/SpellChecker.h:
        (SpellChecker): Added didCheckSucceeded and didCheckCanceled. Also changed didCheck to a private function.

2012-04-03  Hironori Bono  <hbono@chromium.org>

        Prevent spellchecking text pasted to an element having spellchecking disabled
        https://bugs.webkit.org/show_bug.cgi?id=81323

        Reviewed by Hajime Morita.

        This change prevent calling SpellChecker::requestCheckingFor when pasting text
        to an element whose spellcheck attribute is false or a password input.

        Test: editing/spelling/spellcheck-paste-disabled.html

        * editing/Editor.cpp:
        (WebCore::Editor::replaceSelectionWithFragment): Disabled spellchecking on password inputs.
        * editing/SpellChecker.cpp:
        (WebCore::SpellChecker::isCheckable): Return false when spellchecking is disabled.

2012-02-24  Shinya Kawanaka  <shinyak@chromium.org>

        SpellCheckRequest needs to know the context where the spellcheck happened.
        https://bugs.webkit.org/show_bug.cgi?id=79320

        Reviewed by Hajime Morita.

        WebKit clients should be able to get the context how the spellcheck happended.
        For example, WebKit clients may want to change the behavior by a spellcheck request is
        invoked in typing or in pasting.

        This patch added an enum in SpellCheckRequest so that WebKit clients can understand the context.

        * editing/Editor.cpp:
        (WebCore::Editor::replaceSelectionWithFragment):
        (WebCore::Editor::markAllMisspellingsAndBadGrammarInRanges):
        * editing/SpellChecker.cpp:
        (WebCore::SpellCheckRequest::SpellCheckRequest):
        (WebCore::SpellCheckRequest::create):
        (WebCore::SpellChecker::invokeRequest):
        * editing/SpellChecker.h:
        (SpellCheckRequest):
        (WebCore::SpellCheckRequest::textCheckingRequest):
        (WebCore::SpellCheckRequest::processType):
        * loader/EmptyClients.h:
        (WebCore::EmptyTextCheckerClient::requestCheckingOfString):
        * platform/text/TextCheckerClient.h:
        (WebCore):
        (TextCheckerClient):
        * platform/text/TextChecking.h:
        (TextCheckingRequest):
        (WebCore::TextCheckingRequest::TextCheckingRequest):
        (WebCore::TextCheckingRequest::setSequence):
        (WebCore::TextCheckingRequest::sequence):
        (WebCore::TextCheckingRequest::text):
        (WebCore::TextCheckingRequest::mask):
        (WebCore::TextCheckingRequest::processType):
        (WebCore):

2012-05-18  MORITA Hajime <morrita@google.com>

        Unreviewed attempt to fix build breakage on r117572

        * editing/Editor.cpp:
        (WebCore::Editor::willDetachPage):

2012-05-18  MORITA Hajime  <morrita@google.com>

        https://bugs.webkit.org/show_bug.cgi?id=85515
        Stale frame in WebCore::SpellChecker::didCheckSucceeded

        Reviewed by Ryosuke Niwa.

        Added EditorClient::frameWillDetachPage() notification to give a
        change to invalidate pending spellcheck requests on the client.

        Test: editing/spelling/spellcheck-async-remove-frame.html

        * editing/Editor.cpp:
        (WebCore::Editor::Editor):
        * editing/Editor.h:
        (Editor):
        * loader/EmptyClients.h:
        (WebCore::EmptyEditorClient::frameWillDetachPage):
        * page/EditorClient.h:
        (EditorClient):

2012-05-02  Philippe Normand  <pnormand@igalia.com>

        [GTK] media/track/track-cue-rendering-snap-to-lines-not-set.html fails
        https://bugs.webkit.org/show_bug.cgi?id=84378

        Reviewed by Eric Carlson.

        Fix positioning of the controls panel back to relative, as it is
        in the parent CSS. Also remove some duplicate CSS attributes.

        * css/mediaControlsGtk.css:
        (audio::-webkit-media-controls-panel, video::-webkit-media-controls-panel):

2012-04-26  Dominik Röttsches  <dominik.rottsches@linux.intel.com>

        [cairo] CairoGraphicsContext fillRect (with Color) overrides composite operator
        https://bugs.webkit.org/show_bug.cgi?id=84848

        Reviewed by Martin Robinson.

        FillRectWithColor used to be called fillRectSourceOver before r89314
        where this operator still made sense. The way this function is used
        these days doesn't expect the composite operator to be overridden anymore.

        No new tests, covered by existing tests, e.g.
        svg/filters/feDropShadow.svg

        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::fillRectWithColor):

2012-05-04  Dan Winship  <danw@gnome.org>

        [GTK] ASSERTION FAILED: shouldLoadAsEmptyDocument(r.url()) ||
        !defersLoading() in MainResourceLoader.cpp:382

        Remove a soup_session_pause_message() call that got left behind,
        update the defersLoading stuff to handle this case.

        https://bugs.webkit.org/show_bug.cgi?id=85159

        Reviewed by Martin Robinson.

        No new tests. Now passes loader/load-defer-resume-crash.html under
        debug build.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::sendRequestCallback):
        (WebCore::ResourceHandle::platformSetDefersLoading):

2012-05-04  Christophe Dumez  <christophe.dumez@intel.com>

        [soup] URL of the ResourceResponse passed to willSendRequest is incorrect
        https://bugs.webkit.org/show_bug.cgi?id=85072

        Reviewed by Gustavo Noronha Silva.

        Store the response message by catching the "got-headers" signal so
        that it can be passed later to willSendRequest() in case of
        redirection. This is required because the SoupMessage headers and URL
        have already been updated once restartedCallback() is called.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore):
        (WebCore::gotHeadersCallback):
        (WebCore::restartedCallback):
        (WebCore::sendRequestCallback):
        (WebCore::startHTTPRequest):

2012-05-14  Sriram Neelakandan  <sriram.neelakandan@gmail.com>

        [Gtk][DOM Bindings] Feature-protected interface usage in set/get property must be under condition guards
        https://bugs.webkit.org/show_bug.cgi?id=86060

        Reviewed by Martin Robinson.

        Property set/get functions generated was referencing WebCore::interface without any condition guard.
        This issue was triggered usually when an interface gets disabled; For instance; --disable-video, disables WebCore::HTMLMediaElement.
        Also updated the GObject binding reference tests

        No new tests - covered by existing bindings tests

        * bindings/scripts/CodeGeneratorGObject.pm:
        (GenerateProperties):
        * bindings/scripts/test/GObject/WebKitDOMTestActiveDOMObject.cpp:
        (webkit_dom_test_active_dom_object_get_property):
        * bindings/scripts/test/GObject/WebKitDOMTestEventConstructor.cpp:
        (webkit_dom_test_event_constructor_get_property):
        * bindings/scripts/test/GObject/WebKitDOMTestException.cpp:
        (webkit_dom_test_exception_get_property):
        * bindings/scripts/test/GObject/WebKitDOMTestInterface.cpp:
        (webkit_dom_test_interface_set_property):
        (webkit_dom_test_interface_get_property):
        * bindings/scripts/test/GObject/WebKitDOMTestObj.cpp:
        (webkit_dom_test_obj_set_property):
        (webkit_dom_test_obj_get_property):
        * bindings/scripts/test/GObject/WebKitDOMTestSerializedScriptValueInterface.cpp:
        (webkit_dom_test_serialized_script_value_interface_get_property):

2012-05-30  Daniel Drake  <dsd@laptop.org>

        Check for GTK2/GTK3 symbol mismatch earlier
        https://bugs.webkit.org/show_bug.cgi?id=87687

        Reviewed by Martin Robinson.

        No new tests. Regressions in core behavior are covered by existing
        plugin tests and the fix deals with particular aspects of the system
        environment that are difficult to test.

        Detect plugins that would mix GTK+ symbols earlier, so that the
        WebKit can skip them and choose a more appropriate plugin module.

        * plugins/gtk/PluginPackageGtk.cpp: Move this code from PluginViewGtk.
        (WebCore::moduleMixesGtkSymbols):
        (WebCore::PluginPackage::load):
        * plugins/gtk/PluginViewGtk.cpp: Move this code to PluginPackageGtk.
        (WebCore::PluginView::platformStart):

2012-03-09  Abhishek Arya  <inferno@chromium.org>

        Crash when splitting an anonymous block in multi-column layout.
        https://bugs.webkit.org/show_bug.cgi?id=80432

        Reviewed by David Hyatt.

        Calculating currChild->nextSibling() is risky after destroying :after content
        because it can blow away currChild if it is a left over empty anonymous block.
        We need to calculate next sibling upfront, using the same trick, we do in
        RenderBlock::addChildIgnoringAnonymousColumnBlock to reset beforeChild (check
        out the line before splitFlow call).

        Test: fast/multicol/anonymous-block-split-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::splitBlocks):

2012-03-24  Jeffrey Pfau  <jpfau@apple.com>

        XML error document creation should not fire mutation events
        https://bugs.webkit.org/show_bug.cgi?id=80765

        Reviewed by Adam Barth.

        Broke two tests that expected the old behavior, which have now been updated.

        * xml/XMLErrors.cpp:
        (WebCore::createXHTMLParserErrorHeader):
        (WebCore::XMLErrors::insertErrorMessageBlock):

2012-04-30  Abhishek Arya  <inferno@chromium.org>

        Remove positioned float code.
        https://bugs.webkit.org/show_bug.cgi?id=84795

        Reviewed by Dan Bernstein.

        Backout r92004 and some pieces from r91702.

        Test: fast/block/float/positioned-float-crash.html

        * css/CSSParser.cpp:
        (WebCore::isValidKeywordPropertyAndValue):
        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue):
        (WebCore::CSSPrimitiveValue::operator EFloat):
        * css/CSSValueKeywords.in:
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::RenderBlock):
        (WebCore::RenderBlock::layoutBlock):
        (WebCore::RenderBlock::addOverflowFromFloats):
        (WebCore::RenderBlock::layoutBlockChild):
        (WebCore::RenderBlock::simplifiedLayout):
        (WebCore::RenderBlock::layoutPositionedObjects):
        (WebCore::RenderBlock::insertFloatingObject):
        (WebCore::RenderBlock::positionNewFloats):
        (WebCore::RenderBlock::clearFloats):
        (WebCore::RenderBlock::FloatingObjects::clear):
        (WebCore::RenderBlock::FloatingObjects::increaseObjectsCount):
        (WebCore::RenderBlock::FloatingObjects::decreaseObjectsCount):
        * rendering/RenderBlock.h:
        (RenderBlock):
        (WebCore::RenderBlock::forceLayoutInlineChildren):
        (FloatingObject):
        (WebCore::RenderBlock::FloatingObject::FloatingObject):
        (WebCore::RenderBlock::hasOverhangingFloats):
        (WebCore::RenderBlock::FloatingObjects::FloatingObjects):
        (FloatingObjects):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::updateBoxModelInfoFromStyle):
        * rendering/RenderDeprecatedFlexibleBox.cpp:
        (WebCore::RenderDeprecatedFlexibleBox::layoutBlock):
        * rendering/RenderDeprecatedFlexibleBox.h:
        (RenderDeprecatedFlexibleBox):
        * rendering/RenderFlexibleBox.cpp:
        (WebCore::RenderFlexibleBox::layoutBlock):
        * rendering/RenderFlexibleBox.h:
        (RenderFlexibleBox):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::updateScrollbarsAfterLayout):
        * rendering/style/RenderStyleConstants.h:

2012-05-07  Abhishek Arya  <inferno@chromium.org>

        Crash in RenderBlock::updateFirstLetterStyle.
        https://bugs.webkit.org/show_bug.cgi?id=85759

        Reviewed by Julien Chaffraix.

        Test: fast/css-generated-content/first-letter-next-sibling-crash.html

        RenderBlock::removeChild can bring up the children from last single anonymous block,
        causing |nextSibling| in RenderBlock::updateFirstLetterStyle to go stale. We prevent
        this by removing the child safely using removeChildNode before destroying it.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::updateFirstLetterStyle):

2012-05-04  Abhishek Arya  <inferno@chromium.org>

        ASSERT(beforeChildAnonymousContainer->isTable()); fails in RenderBlock::addChildIgnoringAnonymousColumnBlocks.
        https://bugs.webkit.org/show_bug.cgi?id=84606

        Reviewed by Julien Chaffraix.

        RenderBlock::removeChild forgot to set display on the anonymous block, causing it
        to display as INLINE. To prevent this kind of failure in future, we replace
        createAnonymousStyle with createAnonymousStyleWithDisplay to make everyone explictly
        pass display as the argument.

        Test: fast/block/block-add-child-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::removeChild): 
        (WebCore::RenderBlock::createAnonymousWithParentRendererAndDisplay):
        (WebCore::RenderBlock::createAnonymousColumnsWithParentRenderer):
        (WebCore::RenderBlock::createAnonymousColumnSpanWithParentRenderer):
        * rendering/RenderInline.cpp:
        (WebCore::updateStyleOfAnonymousBlockContinuations):
        (WebCore::RenderInline::addChildIgnoringContinuation):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::propagateStyleToAnonymousChildren):
        * rendering/RenderRuby.cpp:
        (WebCore::createAnonymousRubyInlineBlock):
        * rendering/RenderRubyRun.cpp:
        (WebCore::RenderRubyRun::createRubyBase):
        (WebCore::RenderRubyRun::staticCreateRubyRun):
        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::createAnonymousWithParentRenderer):
        * rendering/RenderTableCell.cpp:
        (WebCore::RenderTableCell::createAnonymousWithParentRenderer):
        * rendering/RenderTableRow.cpp:
        (WebCore::RenderTableRow::createAnonymousWithParentRenderer):
        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::createAnonymousWithParentRenderer):
        * rendering/mathml/RenderMathMLBlock.cpp:
        (WebCore::RenderMathMLBlock::createAlmostAnonymousBlock):
        * rendering/mathml/RenderMathMLRow.cpp:
        (WebCore::RenderMathMLRow::createAnonymousWithParentRenderer):
        * rendering/mathml/RenderMathMLSubSup.cpp:
        (WebCore::RenderMathMLSubSup::addChild):
        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::createAnonymousStyleWithDisplay):
        * rendering/style/RenderStyle.h:

2012-05-16  Abhishek Arya  <inferno@chromium.org>

        Missing RenderApplet cast check in HTMLAppletElement::renderWidgetForJSBindings.
        https://bugs.webkit.org/show_bug.cgi?id=86627

        Reviewed by Andreas Kling.

        Test: java/inline-applet-crash.html

        * html/HTMLAppletElement.cpp:
        (WebCore::HTMLAppletElement::renderWidgetForJSBindings):

2012-05-10  Abhishek Arya  <inferno@chromium.org>

        Crash in ApplyStyleCommand::joinChildTextNodes.
        https://bugs.webkit.org/show_bug.cgi?id=85939

        Reviewed by Ryosuke Niwa.

        Test: editing/style/apply-style-join-child-text-nodes-crash.html

        * editing/ApplyStyleCommand.cpp:
        (WebCore::ApplyStyleCommand::applyRelativeFontStyleChange): add conditions
        to bail out if our start and end position nodes are removed due to 
        mutation events in joinChildTextNodes.
        (WebCore::ApplyStyleCommand::applyInlineStyle): this executes after
        applyRelativeFontStyleChange in ApplyStyleCommand::doApply. So, need
        to bail out if our start and end position nodes are removed due to
        mutation events.
        (WebCore::ApplyStyleCommand::joinChildTextNodes): hold all the children
        in a ref vector to prevent them from getting destroyed due to mutation events.

2012-05-09  Abhishek Arya  <inferno@chromium.org>

        Crash in ReplaceSelectionCommand::performTrivialReplace
        https://bugs.webkit.org/show_bug.cgi?id=85943

        Reviewed by Ryosuke Niwa.

        RefPtr nodeAfterInsertionPos to guard against mutation events.

        Test: editing/inserting/insert-html-crash.html

        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::performTrivialReplace):

2012-05-10  Abhishek Arya  <inferno@chromium.org>

        Crash due to floats not removed from first-letter element.
        https://bugs.webkit.org/show_bug.cgi?id=86019

        Reviewed by Julien Chaffraix.

        Move clearing logic of a floating/positioned object from removeChild
        to removeChildNode. There are lot of places which use removeChildNode
        directly and hence the object is not removed from the floating or
        positioned objects list.

        Test: fast/block/float/float-not-removed-from-first-letter.html

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::removeChild):
        * rendering/RenderObjectChildList.cpp:
        (WebCore::RenderObjectChildList::removeChildNode):

2012-05-12  Abhishek Arya  <inferno@chromium.org>

        Crash in HTMLSelectElement::setOption
        https://bugs.webkit.org/show_bug.cgi?id=85420

        Reviewed by Eric Seidel
        
        RefPtr before option in HTMLSelectElement::setOption since it
        can get destroyed due to mutation events.

        Test: fast/dom/HTMLSelectElement/option-add-crash.html

        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::setOption):

2012-05-15  Abhishek Arya  <inferno@chromium.org>

        Crash in Document::nodeChildrenWillBeRemoved.
        https://bugs.webkit.org/show_bug.cgi?id=85247

        Reviewed by Hajime Morita.

        Reverse ordering of commands to ref ptr the children set
        first before calling nodeChildrenWillBeRemoved, since it
        can fire mutation events.

        Test: fast/dom/HTMLObjectElement/beforeload-set-text-crash.xhtml

        * dom/ContainerNode.cpp:
        (WebCore::willRemoveChildren):

2012-05-10  Abhishek Arya  <inferno@chromium.org>

        Crash in swapInNodePreservingAttributesAndChildren.
        https://bugs.webkit.org/show_bug.cgi?id=85197
 
        Reviewed by Ryosuke Niwa.
 
        Keep the children in a ref vector before adding them to newNode.
        They can get destroyed due to mutation events.

        No new tests because we don't have a reduction.

        * editing/ReplaceNodeWithSpanCommand.cpp:
        (WebCore::swapInNodePreservingAttributesAndChildren):

2012-05-07  Ken Buchanan  <kenrb@chromium.org>

        Crash due to positioned object list not being cleared during block flow split
        https://bugs.webkit.org/show_bug.cgi?id=85074

        Reviewed by Abhishek Arya.

        When an element is being split due to a column span element being
        inserted, any of its ancestors that are underneath the column
        containing block also get split. If an ancestor has an object in
        its positioned object list from a previous layout, then the list
        will have to be cleared because the positioned object could have moved
        to be under the continuation. This patch causes the list to be
        cleared.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::splitBlocks):

2012-05-01  James Simonsen  <simonjam@chromium.org>

        Ensure HTMLElementStack fails gracefully if it has a non-Element.
        https://bugs.webkit.org/show_bug.cgi?id=85167

        Reviewed by Adam Barth.

        Test: Added to html5lib/resources/webkit02.dat

        * html/parser/HTMLElementStack.cpp:
        (WebCore::HTMLElementStack::oneBelowTop):
        * html/parser/HTMLTreeBuilder.cpp:
        (WebCore::HTMLTreeBuilder::processEndTag):

2012-02-20  Adam Barth  <abarth@webkit.org>

        Invalid cast in WebCore::toElement / WebCore::HTMLElementStack::ElementRecord::element
        https://bugs.webkit.org/show_bug.cgi?id=78975

        Reviewed by Eric Seidel.

        We're supposed to set the action attribute on the form element we just
        created.  Previously, we assumed the newly created form element would
        be on the top of the stack of open elements, but if we're in the table
        body insertion mode, the form element gets treated as self closing and
        is therefore popped off the stack of open elements.

        Fortunately, we already cache a pointer to the most recently inserted
        form element on the HTMLConstructionSite, so we can just grab the
        element from there.

        Test: html5lib/runner.html

        * html/parser/HTMLTreeBuilder.cpp:
        (WebCore::HTMLTreeBuilder::processIsindexStartTagForInBody):
        (WebCore):

2012-04-30  Justin Schuh  <jschuh@chromium.org>

        loadOrRedirectSubframe should return the owner element's frame
        https://bugs.webkit.org/show_bug.cgi?id=84780

        Reviewed by Nate Chapin.

        Test: fast/loader/javascript-url-iframe-remove-on-navigate.html

        * loader/SubframeLoader.cpp:
        (WebCore::SubframeLoader::loadOrRedirectSubframe):

2012-04-26  Jeffrey Pfau  <jpfau@apple.com>

        Invalid cast in WebCore::HTMLCollection::isAcceptableElement
        https://bugs.webkit.org/show_bug.cgi?id=84626

        Reviewed by Darin Adler.

        Check if the object is an HTMLElement before casting.

        Test: fast/dom/htmlcollection-non-html.html

        * html/HTMLCollection.cpp:
        (WebCore::HTMLCollection::isAcceptableElement):

2012-04-25  Nate Chapin  <japhet@chromium.org>

        Crash in CachedRawResource::didAddClient() due to missing protector.
        https://bugs.webkit.org/show_bug.cgi?id=83632

        Reviewed by Eric Seidel.

        Test: http/tests/xmlhttprequest/access-control-repeated-failed-preflight-crash.html

        * loader/cache/CachedRawResource.cpp:
        (WebCore::CachedRawResource::didAddClient):

2012-03-09  Nate Chapin  <japhet@chromium.org>

        CachedRawResource breaks when trying to load
        a resource with an empty response body from cache.

        Reviewed by Alexey Proskuryakov.

        Test: http/tests/cache/zero-length-xhr.html

        * loader/cache/CachedRawResource.cpp:
        (WebCore::CachedRawResource::didAddClient): Don't exit early
            if m_data is empty, we may still need to notifyFinished().

2012-02-22  Nate Chapin  <japhet@chromium.org>

        Prevent CachedRawResource from sending the same data
        chunk multiple times.
        https://bugs.webkit.org/show_bug.cgi?id=78810

        Reviewed by Adam Barth.

        If a CachedRawResource receives data while a CachedRawResourceCallback
        timer is active, the incremental data will be sent to the client, followed
        but all data received so far, resulting in invalid data. Resolving this adds
        complexity to CachedRawResource and requires making a few more CachedResource
        functions virtual, so push the callback logic into CachedResource where it can
        be implemented more cleanly.

        Test: inspector/debugger/script-formatter-console.html
            should no longer be flaky.

        * loader/cache/CachedRawResource.cpp: CachedRawResourceCallback renamed and moved to CachedResource.
        (WebCore::CachedRawResource::didAddClient): More or less the same as sendCallbacks() was.
        * loader/cache/CachedRawResource.h:
        * loader/cache/CachedResource.cpp:
        (WebCore::CachedResource::addClient): Check the return value of addClientToSet() to determine whether
            or not to call didAddClient.
        (WebCore::CachedResource::didAddClient): May be called during addClient(), or may be called on a timer.
            If called on a timer, move the client between sets.
        (WebCore::CachedResource::addClientToSet): Determine whether didAddClient() can be called synchronously and
            return true if it can.
        (WebCore::CachedResource::removeClient): Ensure we cancel pending callbacks if necessary.
        (WebCore::CachedResource::CachedResourceCallback::CachedResourceCallback): Renamed and moved from CachedRawResource.
        * loader/cache/CachedResource.h:
        (WebCore::CachedResource::hasClients): Check m_clientsAwaitingCallback as well as m_clients.
        (WebCore::CachedResource::CachedResourceCallback::schedule):
        (WebCore::CachedResource::hasClient): Helper for calling contains() on both m_clientsAwaitingCallback and m_clients.

2012-04-05  Adam Klein  <adamk@chromium.org>

        Crash in MutationObservers due to an invalid HashSet iterator
        https://bugs.webkit.org/show_bug.cgi?id=83304

        Reviewed by Ojan Vafai.

        If the observed node has been GCed when we clear transient observers
        from it, the HashSet iterator in WebKitMutationObserver::deliver would
        be invalidated. This patch fixes that behavior by copying the relevant
        registrations into a seperate vector first and operating on the copy.

        This patch also fixes a bug: transient observers should be cleared
        after every microtask, not just when delivering.

        Tests: fast/mutation/clear-transient-without-delivery.html
               fast/mutation/transient-gc-crash.html

        * dom/MutationObserverRegistration.cpp:
        (WebCore::MutationObserverRegistration::observedSubtreeNodeWillDetach):
        Notify the observer that it has a transient registration so it can be properly cleared.
        * dom/MutationObserverRegistration.h:
        (WebCore::MutationObserverRegistration::hasTransientRegistrations):
        Add an accessor for use when deliver() creates its vector of registrations.
        * dom/WebKitMutationObserver.cpp:
        (WebCore::WebKitMutationObserver::setHasTransientRegistration): Add this to the active observer set
        to allow transient registrations to be cleared appropriately.
        (WebCore::WebKitMutationObserver::deliver): Avoid modifying m_registrations while iterating over it.
        Clear registrations before checking for a lack of records to deliver.
        * dom/WebKitMutationObserver.h:

2012-02-27  Adam Klein  <adamk@chromium.org>

        [MutationObservers] Clear pending mutation records on disconnect()
        https://bugs.webkit.org/show_bug.cgi?id=78639

        Reviewed by Ojan Vafai.

        Test: fast/mutation/disconnect-cancel-pending.html

        * dom/WebKitMutationObserver.cpp:
        (WebCore::WebKitMutationObserver::disconnect): Clear pending records.
        (WebCore::WebKitMutationObserver::deliver): Avoid calling the callback if no records are pending delivery.

2012-04-04  Dmitry Lomov  <dslomov@google.com>

        WorkerEventQueue::close might access deleted WorkerEventQueue::EventDispatcherTask.
        https://bugs.webkit.org/show_bug.cgi?id=83202

        On closing the event queue, WorkerEventQueue cancels all the tasks associated with events.
        The tasks in their turn delete themselves from the map whenever task gets executed.
        However if shutdown occurs when task is in queue but before task gets executed, the task will be deleted without execution.
        This patch makes sure that no deleted tasks stay in WorkerEventQueue, by task removing itself in destructor.

        Reviewed by David Levin.

        Covered by existing tests.

        * workers/WorkerEventQueue.cpp:
        (WebCore::WorkerEventQueue::EventDispatcherTask::~EventDispatcherTask):
        (WorkerEventQueue::EventDispatcherTask):
        (WebCore::WorkerEventQueue::EventDispatcherTask::performTask):

2012-04-04  Simon Fraser  <simon.fraser@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=82994

        Reviewed by James Robinson.
        
        Fix an issue when removing elements with reflections from the document.

        Test: compositing/reflections/remove-reflection.html

        * platform/graphics/GraphicsLayer.cpp:
        (WebCore::GraphicsLayer::willBeDestroyed):

2012-04-02  Simon Fraser  <simon.fraser@apple.com>

        Fix issue with reflections and composited layers
        https://bugs.webkit.org/show_bug.cgi?id=82636

        Reviewed by Alexey Proskuryakov
        
        When tearing down GraphicsLayers which referene eachother via m_replicatedLayer/m_replicaLayer,
        we need to clean up the replica layer pointers.

        No new tests; tested by existing compositing and repaint tests.

        * platform/graphics/GraphicsLayer.cpp:
        (WebCore::GraphicsLayer::~GraphicsLayer):
        (WebCore::GraphicsLayer::setReplicatedByLayer):

2012-02-08  Kentaro Hara  <haraken@chromium.org>

        Replace [CheckNodeSecurity] with [CheckAccessToNode]
        https://bugs.webkit.org/show_bug.cgi?id=77971

        Reviewed by Adam Barth.

        [CheckNodeSecurity] is not implemented by code generators.
        This patch replaces [CheckNodeSecurity] with [CheckAccessToNode].

        Test: http/tests/security/cross-frame-access-frameelement.html

        * page/DOMWindow.idl:

2012-05-09  Ken Buchanan  <kenrb@chromium.org>

        Crash from removal of a line break object
        https://bugs.webkit.org/show_bug.cgi?id=85997

        Reviewed by David Hyatt.

        Regression from r115343. That replaced a call to setNeedsLayout()
        with a separate call that used a different bit during linebox
        invalidation after renderer child removal. There are special cases
        where layout isn't marked on parent nodes just from the removal, so
        line dirtying needs to explicitly mark ancestors for layout.

        * rendering/RenderObject.h:
        (WebCore::RenderObject::setAncestorLineBoxDirty):

2012-04-26  Ken Buchanan  <kenrb@chromium.org>

        Crash from removal of line break object after layout
        https://bugs.webkit.org/show_bug.cgi?id=75461

        Reviewed by David Hyatt.

        There is a condition where objects can get removed from underneath
        inlines while they represent a line break object in a RootInlineBox
        of an ancestor block. If an intermediary inline has already been
        marked as needing layout, then the line box will not get dirtied
        because dirtyLineFromChangedChild thinks it already has been.

        This patch introduces a new set in RenderObject to indicate whether
        an ancestral line box corresponding to the current line has been
        marked dirty or not. dirtyLinesFromChangedChild() can use this set 
        rather than m_selfNeedsLayout, so it will not be confused if a
        container was dirtied for some other reason that did not affect the
        line box.

        * rendering/RenderLineBoxList.cpp:
        (WebCore::RenderLineBoxList::dirtyLinesFromChangedChild): Use the new
        set rather than m_selfNeedsLayout in the container to determine
        whether to continue propagating upward.
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::s_ancestorLineboxDirtySet): Instantiate the
        static member.
        (WebCore::RenderObject::willBeDestroyed): Clears the object from the
        linebox set when it is being destroyed.
        * rendering/RenderObject.h:
        (WebCore::RenderObject::s_ancestorLineboxDirtySet): Added static
        member set.
        (WebCore::RenderObject::setNeedsLayout): Clears the
        object from the linebox set when layout bits are getting cleared.
        (WebCore::RenderObject::ancestorLineBoxDirty): Added.
        (WebCore::RenderObject::setAncestorLineBoxDirty): Added.

2012-03-01  Abhishek Arya  <inferno@chromium.org>

        Prevent layout root to remain set on renderers getting destroyed.
        https://bugs.webkit.org/show_bug.cgi?id=79953

        Reviewed by Eric Seidel.

        Implement Julien Chaffraix's idea.

        * page/FrameView.h:
        (WebCore::FrameView::clearLayoutRoot): helper to clear layout root.
        * rendering/RenderObject.cpp:
        (WebCore::clearLayoutRootIfNeeded): if we know we are going
        away and we are the view's layout root, then we need to reset the layout
        root to prevent being used.
        (WebCore):
        (WebCore::RenderObject::willBeDestroyed): call clearLayoutRootIfNeeded at end.

2012-04-04  Jeffrey Pfau  <jpfau@apple.com>

        Move pending sheet removal from ~HTMLLinkElement to removal from document.
        https://bugs.webkit.org/show_bug.cgi?id=69184

        Reviewed by Adam Barth.

        Test: fast/html/pending-stylesheet-crash.html

        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::~HTMLLinkElement):
        (WebCore::HTMLLinkElement::removedFromDocument):

2012-04-04  Sergio Villar Senin  <svillar@igalia.com>

        [GTK] ASSERT in SocketStreamHandleSoup.cpp
        https://bugs.webkit.org/show_bug.cgi?id=83123

        Reviewed by Martin Robinson.

        Do not try to reuse a GOwnPtr as calling outPtr() causes an
        assertion if the pointer is already valid. Also do not try to
        close the IOStream if it was not created.

        This patch fixes
        http/tests/websocket/tests/hybi/workers/worker-reload.html but I
        am leaving it skipped until webkit.org/b/83124 is fixed.

        * platform/network/soup/SocketStreamHandleSoup.cpp:
        (WebCore::connectedCallback):

2012-04-03  Yuta Kitamura  <yutak@chromium.org>

        Crash in WebCore::WorkerThreadableWebSocketChannel::Bridge::mainThreadCreateWebSocketChannel
        https://bugs.webkit.org/show_bug.cgi?id=82873

        Reviewed by David Levin.

        WorkerThreadableWebSocketChannel::Bridge should properly handle the cases where inter-thread
        callback is not called due to the termination of the worker run loop. Specifically, the bridge
        should not send its "this" pointer to the main thread, because the bridge object may be freed
        in the worker thread before the main thread starts to process.

        Test: http/tests/websocket/tests/hybi/workers/worker-reload.html

        * Modules/websockets/ThreadableWebSocketChannelClientWrapper.cpp:
        (WebCore::ThreadableWebSocketChannelClientWrapper::ThreadableWebSocketChannelClientWrapper):
        (WebCore::ThreadableWebSocketChannelClientWrapper::peer):
        (WebCore::ThreadableWebSocketChannelClientWrapper::didCreateWebSocketChannel):
        Renamed from setUseHixie76Protocol, as this funtion now also sets m_peer.
        Sets m_syncMethodDone to true, because this function is called in the end of
        synchronous wait of Bridge::initialize().
        (WebCore::ThreadableWebSocketChannelClientWrapper::clearPeer):
        (WebCore::ThreadableWebSocketChannelClientWrapper::useHixie76Protocol):
        * Modules/websockets/ThreadableWebSocketChannelClientWrapper.h:
        Add WorkerThreadableWebSocketChannel::Peer which is initialized after the creation of
        WebSocketChannel in the main thread.
        (ThreadableWebSocketChannelClientWrapper):
        * Modules/websockets/WorkerThreadableWebSocketChannel.cpp:
        (WebCore::WorkerThreadableWebSocketChannel::WorkerThreadableWebSocketChannel):
        Don't do synchronous wait in the constructor, as a member function may be called
        during the wait before the constructor finishes. The meat of the constructor has
        moved to initialize() function.
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::Bridge):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::~Bridge):
        (WorkerContextDidInitializeTask):
        (WebCore::WorkerContextDidInitializeTask::create):
        (WebCore::WorkerContextDidInitializeTask::~WorkerContextDidInitializeTask):
        (WebCore::WorkerContextDidInitializeTask::WorkerContextDidInitializeTask):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::mainThreadInitialize):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::initialize):
        Don't pass "this" object to the main thread. Receive the pointer to the peer object
        via ThreadableWebSocketChannelClientWrapper which is ThreadSafeRefCounted<>.
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::connect):
        m_peer may be NULL, and we should not do anything in that case.
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::send):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::bufferedAmount):
        (WebCore::WorkerThreadableWebSocketChannel::mainThreadClose):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::close):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::fail):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::suspend):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::resume):
        * Modules/websockets/WorkerThreadableWebSocketChannel.h:
        (WorkerThreadableWebSocketChannel):
        (WebCore::WorkerThreadableWebSocketChannel::refThreadableWebSocketChannel):
        (WebCore::WorkerThreadableWebSocketChannel::derefThreadableWebSocketChannel):
        (Bridge):
        * workers/DefaultSharedWorkerRepository.cpp:
        (SharedWorkerProxy):
        (WebCore::SharedWorkerProxy::postTaskForModeToWorkerContext):
        * workers/WorkerLoaderProxy.h:
        (WorkerLoaderProxy::postTaskForModeToWorkerContext):
        Return bool to indicate whether postTask was successful or not. This is necessary
        to avoid memory leaks of Peer object in Bridge::initialize() function.
        * workers/WorkerMessagingProxy.cpp:
        (WebCore::WorkerMessagingProxy::postTaskForModeToWorkerContext):
        * workers/WorkerMessagingProxy.h:
        (WorkerMessagingProxy):

2012-04-09  Abhishek Arya  <inferno@chromium.org>

        Incorrect placement of new child to table when before child parent is not |this|.
        https://bugs.webkit.org/show_bug.cgi?id=82630

        Reviewed by Julien Chaffraix.

        Tests: fast/table/table-row-split2.html
               fast/table/table-section-split2.html
               fast/table/table-split.html
               fast/table/table-split2.html
        and tested by layouttests in commits r97180, r108127, and a few others.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::addChildToAnonymousColumnBlocks): function rename, block->box.
        (WebCore::RenderBlock::makeChildrenAnonymousColumnBlocks): ditto.
        (WebCore::RenderBlock::addChildIgnoringAnonymousColumnBlocks): ditto.
        * rendering/RenderBlock.h:
        (RenderBlock):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::moveChildTo): move these functions from RenderBlock, needs to be
        used in RenderBox::splitAnonymousBoxesAroundChild.
        (WebCore):
        (WebCore::RenderBox::moveChildrenTo): ditto.
        (WebCore::markBoxForRelayoutAfterSplit): helper to mark a block or table part for complete relayout
        after anonymous boxes are split around child.
        (WebCore::RenderBox::splitAnonymousBoxesAroundChild): moved from RenderBlock to be able
        to work with table parts.
        * rendering/RenderBox.h:
        (RenderBox):
        (WebCore::RenderBox::moveChildTo):
        (WebCore::RenderBox::moveAllChildrenTo):
        (WebCore::RenderBox::moveChildrenTo):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::addChild): no longer need the hack added in r95461.
        * rendering/RenderRubyBase.cpp:
        (WebCore::RenderRubyBase::moveChildren): function rename, block->box.
        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::addChild): Use splitAnonymousBoxesAroundChild function when |beforeChild| != |this|.
        * rendering/RenderTableRow.cpp:
        (WebCore::RenderTableRow::addChild): ditto. 
        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::addChild): ditto.

2012-04-06  Abhishek Arya  <inferno@chromium.org>

        Virtualize createAnonymousBoxWithSameTypeAs.
        https://bugs.webkit.org/show_bug.cgi?id=83229

        Reviewed by Julien Chaffraix.

        This helps to use the same function to create anonymous
        table parts and in the future extend to more classes
        derived from RenderBox.

        The current switch case situation was going to be messy as
        we will need to mix cases that were very dependent on the
        class, so it made sense to add a virtual function.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::splitAnonymousBlocksAroundChild):
        (WebCore::RenderBlock::createAnonymousBoxWithSameTypeAs):
        * rendering/RenderBlock.h:
        (RenderBlock):
        * rendering/RenderBox.h:
        (WebCore::RenderBox::createAnonymousBoxWithSameTypeAs):
        (RenderBox):
        * rendering/RenderInline.cpp:
        (WebCore::RenderInline::splitFlow):
        * rendering/RenderTable.h:
        (WebCore::RenderTable::createAnonymousBoxWithSameTypeAs):
        * rendering/RenderTableCell.h:
        (WebCore::RenderTableCell::createAnonymousBoxWithSameTypeAs):
        * rendering/RenderTableRow.h:
        (WebCore::RenderTableRow::createAnonymousBoxWithSameTypeAs):
        * rendering/RenderTableSection.h:
        (WebCore::RenderTableSection::createAnonymousBoxWithSameTypeAs):

2012-04-04  Abhishek Arya  <inferno@chromium.org>

        Add helpers to create anonymous table parts.
        https://bugs.webkit.org/show_bug.cgi?id=83116

        Reviewed by Julien Chaffraix.

        The patch introduces helpers to create anonymous table parts by
        introducing a new static function createAnonymousWithParentRenderer.
        The function builds a new anonymous wrapper of the same type as the class,
        inheriting style properties from parent and sets a display based on
        argument/default values. Also we streamline the RenderBlock functions
        to match this naming convention.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::createAnonymousBlockWithSameTypeAs):
        (WebCore::RenderBlock::createAnonymousWithParentRendererAndDisplay):
        (WebCore):
        (WebCore::RenderBlock::createAnonymousColumnsWithParentRendererAndDisplay):
        (WebCore::RenderBlock::createAnonymousColumnSpanWithParentRendererAndDisplay):
        * rendering/RenderBlock.h:
        (RenderBlock):
        (WebCore::RenderBlock::createAnonymousBlock):
        (WebCore::RenderBlock::createAnonymousColumnsBlock):
        (WebCore::RenderBlock::createAnonymousColumnSpanBlock):
        * rendering/RenderButton.cpp:
        (WebCore::RenderButton::addChild):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::addChild):
        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::addChild):
        (WebCore::RenderTable::createAnonymousWithParentRendererAndDisplay):
        (WebCore):
        * rendering/RenderTable.h:
        (RenderTable):
        * rendering/RenderTableCell.cpp:
        (WebCore::RenderTableCell::createAnonymousWithParentRendererAndDisplay):
        (WebCore):
        * rendering/RenderTableCell.h:
        (RenderTableCell):
        * rendering/RenderTableRow.cpp:
        (WebCore::RenderTableRow::addChild):
        (WebCore::RenderTableRow::createAnonymousWithParentRendererAndDisplay):
        (WebCore):
        * rendering/RenderTableRow.h:
        (RenderTableRow):
        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::addChild):
        (WebCore::RenderTableSection::createAnonymousWithParentRendererAndDisplay):
        (WebCore):
        * rendering/RenderTableSection.h:
        (RenderTableSection):

2012-02-22  Abhishek Arya  <inferno@chromium.org>

        Crash in RenderBlock::addChildIgnoringAnonymousColumnBlocks.
        https://bugs.webkit.org/show_bug.cgi?id=79043

        Reviewed by Julien Chaffraix.

        Tests: fast/runin/runin-div-before-child.html
               fast/runin/runin-table-before-child.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::addChildIgnoringAnonymousColumnBlocks): handle
        the case of run-in elements and strengthen code to handle cases where
        beforeChild is incorrectly set.
        * rendering/RenderObject.h: remove anonymousContainer function since
        the new logic in RenderBlock does not need it.

2012-04-11  Erik Arvidsson  <arv@chromium.org>

        StyleElement ownerNode is not cleared correctly
        https://bugs.webkit.org/show_bug.cgi?id=83696

        Reviewed by Antti Koivisto.

        When the css text changes in such a way that we remove the sheet of a style element or a link[rel=stylesheet]
        element we need to ensure that the ownerNode of the sheet is cleared. If we don't do this and there is a
        wrapper for the sheet the sheet is kept alive but the ownerNode of the sheet may point to a deleted node.

        Tests: fast/dom/StyleSheet/detached-sheet-owner-node-link.html
               fast/dom/StyleSheet/detached-sheet-owner-node.html

        * dom/StyleElement.cpp:
        (WebCore::StyleElement::removedFromDocument):
        (WebCore::StyleElement::clearSheet):
        (WebCore):
        (WebCore::StyleElement::createSheet):
        * dom/StyleElement.h:
        (StyleElement):
        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::process):
        (WebCore::HTMLLinkElement::clearSheet):
        (WebCore):
        * html/HTMLLinkElement.h:
        (HTMLLinkElement):

2012-04-03  Abhishek Arya  <inferno@chromium.org>

        Crash in SelectorChecker::checkOneSelector.
        https://bugs.webkit.org/show_bug.cgi?id=83040

        Reviewed by Antti Koivisto.

        Test: fast/css/css-set-selector-text-crash.html

        Removing the early bail when we detect that our selector text
        hasn't changed, and we don't notify the styleSelectorChanged.
        In fact, when we adopt the new selector list, the old one will
        get destroyed and the styleSelectorChanged call needs to be made.

        * css/CSSStyleRule.cpp:
        (WebCore::CSSStyleRule::setSelectorText):

2012-04-09  Abhishek Arya  <inferno@chromium.org>

        Crash due to floats not cleared before starting SVG <text> layout.
        https://bugs.webkit.org/show_bug.cgi?id=83021

        Reviewed by Dirk Schulze.

        Manual Test - ManualTests/svg-text-float-not-removed-crash.html.
        Can't reproduce the failure in DRT.

        forceLayoutInlineChildren is used in SVG <text> layout and overrides
        RenderBlock::layoutBlock. However, it missed the 'clearFloats' step,
        which will cause a crash when trying to access removed renderers.

        * rendering/RenderBlock.h:
        (WebCore::RenderBlock::forceLayoutInlineChildren):

2012-04-02  Abhishek Arya  <inferno@chromium.org>

        <select> shouldn't intrude as a run-in.
        https://bugs.webkit.org/show_bug.cgi?id=82829

        Reviewed by Tony Chang.

        Matches Opera's behavior which also does not allow <select>
        to intrude as a run-in into the neighbouring block.
        IE and Firefox doesn't support run-ins, so can't compare behavior
        with them.

        Test: fast/runin/select-runin.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::handleRunInChild):

2012-04-10  Abhishek Arya  <inferno@chromium.org>

        Crash due to intruding float not removed from next siblings.
        https://bugs.webkit.org/show_bug.cgi?id=83301

        Reviewed by Eric Seidel.

        Test: fast/block/float/intruding-float-not-removed-from-next-sibling-crash.html

        markSiblingsWithFloatsForLayout currently only handled overhanging floats and made
        checks for those by checking if logicalBottomForFloat > our logicalHeight. We need
        to take care of intruding floats as well, since these can intrude into the neighbouring
        blocks too. So, generalized the function to check all our next siblings if they contains
        that float (one getting removed) and if yes, mark it and all its descendants for layout.
        This fixes the crash.

        For performance, we change the looping condition to iterate over the next sibling
        blocks first and finding which ones can contain floats and then check it against
        our floating object list. Currently, it is the other way around and is less
        performant due to repeated calls to isRenderBlock(), isFloatingOrPositioned()
        and avoidFloats().

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::markSiblingsWithFloatsForLayout):

2012-04-09  Abhishek Arya  <inferno@chromium.org>

        ASSERTION FAILED: !attached() in Node::attach.
        https://bugs.webkit.org/show_bug.cgi?id=80726

        Reviewed by Adam Barth.

        While parsing XML document, prevent attaching the leaf text node
        back to document, if its parent is not attached.

        Test: fast/dom/text-node-attach-crash.xhtml

        * xml/parser/XMLDocumentParser.cpp:
        (WebCore::XMLDocumentParser::exitText):

2012-03-26  Adam Barth  <abarth@webkit.org>

        FrameLoader::shouldAllowNavigation uses Frame for context rather than Document
        https://bugs.webkit.org/show_bug.cgi?id=81020

        Reviewed by Eric Seidel.

        The vast majority of security checks in the browser should use a
        ScriptExecutionContext (aka a Document) to designate "who" is
        attempting to perform a given action.  Unfortunately,
        shouldAllowNavigation was using a Frame to designate "who" is
        attempting the navigation.

        In cases when the executing script is "inactive" (i.e., belongs to a
        document that is not currently displayed in a Frame), using the Frame
        can cause us to grant the script the privileges of the document that's
        currently displayed in the Frame rather than the one that contains the
        script.

        This patch moves shouldAllowNavigation from FrameLoader to Document
        (and renames it to canNavigate), effectively change the context object
        from a Frame to a Document.

        Test: http/tests/security/frameNavigation/inactive-function-in-popup-navigate-child.html

        * bindings/generic/BindingSecurity.h:
        (BindingSecurity):
        (WebCore):
        * bindings/v8/V8Utilities.cpp:
        (WebCore):
        * bindings/v8/V8Utilities.h:
        (WebCore):
            - Deletes unused code.
        * dom/Document.cpp:
        (WebCore::canAccessAncestor):
        (WebCore):
        (WebCore::Document::canNavigate):
            - canNavigate is copied from FrameLoader::shouldAllowNavigation.
              I've added a null-check bailout if the document is inactive.
        * dom/Document.h:
        (Document):
        * loader/FormState.cpp:
        (WebCore::FormState::FormState):
        (WebCore::FormState::create):
        * loader/FormState.h:
        (WebCore):
        (FormState):
        (WebCore::FormState::sourceDocument):
        * loader/FormSubmission.cpp:
        (WebCore::FormSubmission::create):
            - Changes the context object from Frame to Document.
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::submitForm):
        (WebCore::FrameLoader::loadFrameRequest):
        (WebCore):
        (WebCore::FrameLoader::findFrameForNavigation):
            - FrameLoader::findFrameForNavigation still incorrectly uses Frame
              as the context object, but that's a bug for another patch.
        (WebCore::createWindow):
        * loader/FrameLoader.h:
        (FrameLoader):
        * loader/NavigationScheduler.cpp:
        (WebCore::ScheduledFormSubmission::fire):
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::close):
        (WebCore::DOMWindow::setLocation):
        (WebCore::DOMWindow::open):
        * page/History.cpp:
        (WebCore::History::go):

2012-03-13  Stephen Chenney  <schenney@chromium.org>

        Crash in WebCore::GraphicsContext::paintingDisabled
        https://bugs.webkit.org/show_bug.cgi?id=80669

        Reviewed by Nikolas Zimmermann.

        The SVGImageBufferTools::clipToImageBuffer method deletes the clip
        image when it thinks it is not needed. However, there are cases when
        it is in fact still needed, particularly when the clip buffer is
        coming from higher up in the stack where it may be needed again.

        So this patch adds a flag to only allow deletion of the image buffer
        if it was created at the most recent call site.

        Tests: svg/custom/circular-clip-path-references-crash-expected.svg
               svg/custom/circular-clip-path-references-crash.svg

        * rendering/svg/RenderSVGResourceClipper.cpp:
        (WebCore::RenderSVGResourceClipper::applyClippingToContext):
        * rendering/svg/RenderSVGResourceGradient.cpp:
        (WebCore::clipToTextMask):
        * rendering/svg/RenderSVGResourceMasker.cpp:
        (WebCore::RenderSVGResourceMasker::applyResource):
        * rendering/svg/SVGImageBufferTools.cpp:
        (WebCore::SVGImageBufferTools::clipToImageBuffer):
        * rendering/svg/SVGImageBufferTools.h:
        (SVGImageBufferTools):

2012-03-09  Ken Buchanan  <kenrb@chromium.org>

        Crash due to inserting letter into div with first-letter
        https://bugs.webkit.org/show_bug.cgi?id=78534

        Reviewed by David Hyatt.

        This fixes an issue in RenderTextFragment with setTextInternal
        getting called with different intents. While most calls to it
        are intended to change the underlying DOM node string, it can
        also be called as a result of styleDidChange just for transforms
        on the substring text fragment. This adds a mechanism for internal
        callers to specify if the internal text is being updated without
        a DOM node text change.

        * rendering/RenderTextFragment.cpp:
        (WebCore::RenderTextFragment::styleDidChange)
        (WebCore::RenderTextFragment::setTextInternal)
        * rendering/RenderTextFragment.h:
        (WebCore::RenderTextFragment)

2012-03-13  Philip Rogers  <pdr@google.com>

        Fix the use of stale text fragments
        https://bugs.webkit.org/show_bug.cgi?id=80729

        Reviewed by Nikolas Zimmermann.

        Previously, we were allowing SVGTextFragments to get out of sync with the
        actual text in RenderSVGInlineTextBox. This patch reuses the dirty line
        box code in RenderText::setTextWithOffset to force
        clearTextFragments() when setTextWithOffset is called, preventing the use
        of stale SVGTextFragments.

        Test: svg/custom/delete-text-crash.html

        * rendering/InlineBox.h:
        (InlineBox):
        * rendering/svg/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::dirtyLineBoxes):
        (WebCore):
        * rendering/svg/SVGInlineTextBox.h:
        (SVGInlineTextBox):

2012-03-27  Adam Klein  <adamk@chromium.org>

        Hold a reference to refChild in insertBefore before calling collectChildrenAndRemoveFromOldParent
        https://bugs.webkit.org/show_bug.cgi?id=82377

        Reviewed by Ryosuke Niwa.

        This fixes a regression from r111925.

        Test: fast/dom/insertBefore-refChild-crash.html

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::insertBefore): Move the 'next' RefPtr above the call to
        collectChildrenAndRemoveFromOldParent and rename refChildPreviousSibling
        to 'prev' (matching appendChild and replaceChild).

2012-04-26  Zan Dobersek  <zandobersek@gmail.com>

        [Gtk] WebKitGTK+ 1.8.1 fails to build when disabling HTML Video feature
        https://bugs.webkit.org/show_bug.cgi?id=84838

        Reviewed by Martin Robinson.

        Wrap WebCore objects and functions in GObject property setters and getters
        with conditional guards (if present) to avoid compilation errors.

        No new tests - changes covered by existing bindings tests.

        * bindings/scripts/CodeGeneratorGObject.pm:
        (GenerateProperty):
        (GenerateProperties):
        * bindings/scripts/test/GObject/WebKitDOMTestInterface.cpp: Rebaseline.
        (webkit_dom_test_interface_set_property):
        (webkit_dom_test_interface_get_property):
        * bindings/scripts/test/GObject/WebKitDOMTestSerializedScriptValueInterface.cpp: Ditto.
        (webkit_dom_test_serialized_script_value_interface_get_property):

2012-04-22  Martin Robinson  <mrobinson@igalia.com>

        REGRESSION(113604): [Soup] Some pages that use synchronous XMLHttpRequests freeze the browser
        https://bugs.webkit.org/show_bug.cgi?id=84560

        Reviewed by Xan Lopez.

        When kicking off a synchronous XMLHttpRequest, add one to the connection
        limit. This ensures that when a page starts a synchronous request, while
        already at the connection limit the request will not deadlock.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::WebCoreSynchronousLoader::WebCoreSynchronousLoader): Accept a new SoupSession
        argument so that we can get the correct SoupSession for the networking context. Bump
        the connection limit.
        (WebCore::WebCoreSynchronousLoader::~WebCoreSynchronousLoader): Decrement the connection limit.
        (WebCore::WebCoreSynchronousLoader::adjustMaxConnections): Added this helper.
        (WebCoreSynchronousLoader): Added a new SoupSession member.
        (WebCore::sessionFromContext): Added this helper.
        (WebCore::ResourceHandleInternal::soupSession): Use the new sessionFromContext helper.
        (WebCore::ResourceHandle::loadResourceSynchronously): Pass the SoupSession from the NetworkingContext
        to the synchronous loader.

2012-04-18  MORITA Hajime  <morrita@google.com>

        ShadowTree uses weak iteration patterns
        https://bugs.webkit.org/show_bug.cgi?id=80572

        Reviewed by Dimitri Glazkov.

        Patch by Adam Barth.

        This patch moves various ShadowTree to using a better iteration pattern
        in which we collect all the ShadowRoots we're planning to iterate into
        a vector and then iterate over them.

        * dom/ShadowTree.cpp:
        (ShadowRootVector):
        (WebCore::ShadowRootVector::ShadowRootVector):
        (WebCore):
        (WebCore::ShadowTree::removeAllShadowRoots):
        (WebCore::ShadowTree::insertedIntoDocument):
        (WebCore::ShadowTree::removedFromDocument):
        (WebCore::ShadowTree::insertedIntoTree):
        (WebCore::ShadowTree::removedFromTree):
        (WebCore::ShadowTree::willRemove):

2012-04-18  Stephen Chenney  <schenney@chromium.org>

        SVG layout leaves objects still needing layout
        https://bugs.webkit.org/show_bug.cgi?id=81006

        Reviewed by Nikolas Zimmermann.

        Change the layout of SVG objects such that resources that trigger
        layout of other objects are handled in a distinct pass, and then
        objects still requiring layout are laid out again.

        Test: svg/custom/delete-text-innerText-crash.html

        * rendering/svg/RenderSVGResourceContainer.cpp:
        (WebCore::RenderSVGResourceContainer::layout):
        * rendering/svg/RenderSVGResourceMarker.cpp:
        (WebCore::RenderSVGResourceMarker::layout):
        * rendering/svg/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::layout):
        (WebCore::RenderSVGRoot::addResourceForClientInvalidation):
        (WebCore):
        * rendering/svg/RenderSVGRoot.h:
        (RenderSVGRoot):

2012-04-18  Abhishek Arya  <inferno@chromium.org>

        Crash due to accessing removed parent lineboxes when clearing selection.
        https://bugs.webkit.org/show_bug.cgi?id=81359

        Reviewed by Eric Seidel.

        Similar to r110323, adds the canUpdateSelectionOnRootLineBoxes
        check to more places.

        Test: editing/selection/clear-selection-crash.html

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::canUpdateSelectionOnRootLineBoxes):
        * rendering/RenderSelectionInfo.h:
        (WebCore::RenderSelectionInfo::RenderSelectionInfo):
        (WebCore::RenderBlockSelectionInfo::RenderBlockSelectionInfo):

2012-04-18  Abhishek Arya  <inferno@chromium.org>

        Crash due to accessing removed parent lineboxes when clearing selection.
        https://bugs.webkit.org/show_bug.cgi?id=79264

        Reviewed by Dave Hyatt.

        Test: editing/selection/first-letter-selection-crash.html

        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::setSelectionState):
        1. No need of checking if we are being set to same selection state.
        Now tested by setSelectionStateIfNeeded. Rename 's' with 'state' and
        'cb' with 'containingBlock'.
        * rendering/RenderListMarker.cpp:
        (WebCore::RenderListMarker::setSelectionState):
        1. Add check to canUpdateSelectionOnRootLineBoxes to make sure our
        root line boxes are still valid before setting them.
        2. No need of calling setSelectionState on containing block since our base
        class call to RenderBox::setSelectionState covers it. Added a comment to indicate that.
        3. Use m_inlineBoxWrapper variable directly to simplify the ifs.
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::canUpdateSelectionOnRootLineBoxes):
        (WebCore): helper function to tell if we can update selection information
        on our root line boxes. This returns false if our containing block is pending layout.
        * rendering/RenderObject.h:
        (RenderObject):
        (WebCore::RenderObject::setSelectionStateIfNeeded):
        (WebCore): helper to set selection state only if it is different from our
        current selection state.
        * rendering/RenderReplaced.cpp:
        (WebCore::RenderReplaced::setSelectionState):
        1. Rename 's' to 'state', 'line' to 'root' and use m_inlineBoxWrapper directly
        to simplify ifs.
        2. Add check to canUpdateSelectionOnRootLineBoxes to make sure our
        root line boxes are still valid before setting them.
        * rendering/RenderText.cpp:
        (WebCore::RenderText::setSelectionState):
        1. Add check to canUpdateSelectionOnRootLineBoxes to make sure our
        root line boxes are still valid before setting them.
        2. Rename 'cb' to 'containingBlock', 'line' to 'root', move InlineTextBox
        declaration to local.
        * rendering/RenderView.cpp:
        (WebCore::RenderView::setSelection): Replace all calls to setSelectionState
        with setSelectionStateIfNeeded.
        * rendering/RenderWidget.cpp:
        (WebCore::RenderWidget::setSelectionState):
        1. No need of checking if we are being set to same selection state.
        Now tested by setSelectionStateIfNeeded.

2012-04-18  Ken Buchanan  <kenrb@chromium.org>

        Crash due to floating object lists not properly being cleared
        https://bugs.webkit.org/show_bug.cgi?id=74056

        Reviewed by David Hyatt.

        Add a check to clearFloats() that determines when intruding floats
        are being cleared and not re-added. In this condition, ensure
        children with floats are also getting layout because they might
        need to have the same intruding floats cleared from their floating
        object lists also.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::clearFloats):

2012-04-18  Abhishek Arya  <inferno@chromium.org>

        Crash in GenericEventQueue::~GenericEventQueue.
        https://bugs.webkit.org/show_bug.cgi?id=81976

        Reviewed by Eric Carlson.

        * dom/GenericEventQueue.cpp:
        (WebCore::GenericEventQueue::create):
        (WebCore):
        (WebCore::GenericEventQueue::GenericEventQueue):
        (WebCore::GenericEventQueue::enqueueEvent):
        (WebCore::GenericEventQueue::timerFired):
        * dom/GenericEventQueue.h:
        (GenericEventQueue):
        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::HTMLMediaElement):
        (WebCore::HTMLMediaElement::scheduleEvent):
        (WebCore::HTMLMediaElement::updateActiveTextTrackCues):
        (WebCore::HTMLMediaElement::cancelPendingEventsAndCallbacks):
        (WebCore::HTMLMediaElement::hasPendingActivity):
        * html/HTMLMediaElement.h:
        (HTMLMediaElement):

2012-04-18  Jer Noble  <jer.noble@apple.com>

        Heap-use-after-free in WebCore::InlineFlowBox::deleteLine due to fullscreen issues.
        https://bugs.webkit.org/show_bug.cgi?id=82055

        Reviewed by David Hyatt.

        No new tests; fixes fuzz test crasher which is not reproducible in DRT or WKTR.

        When a RenderFullScreen object is inserted between a child and parent renderer, make sure the
        parent renderer deletes its line boxes by calling setNeedsLayoutAndPrefWidthsRecalc().  This
        forces its InlineBox renderers to be removed from the line boxes and their parents in the correct
        order, fixing a double-delete crash.

        The same is true when unwrapping the RenderFullScreen object, and when creating and inserting
        the full screen placeholder.

        * rendering/RenderFullScreen.cpp:
        (RenderFullScreen::wrapRenderer):
        (RenderFullScreen::unwrapRenderer):
        (RenderFullScreen::createPlaceholder):

2012-04-18  Ken Buchanan  <kenrb@chromium.org>

        Assert failure from capitalized RenderTextFragment
        https://bugs.webkit.org/show_bug.cgi?id=82096

        Reviewed by Ryosuke Niwa.

        The cause of this bug was the call to RenderTextFragment::setTextInternal
        resulting from a style change from RenderObject::addChild. The idea here
        is to better separate the code path for transforming existing text from
        the code path for replacing the underlying text of a node. For
        RenderTextFragment this has to be clear because only in the latter case
        does the first-letter get reset.

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::addChild): Added call to transformText
        * rendering/RenderText.cpp:
        (WebCore::RenderText::styleDidChange): Added call to transformText
        (WebCore::RenderText::transformText): Added
        * rendering/RenderText.h:
        (WebCore::RenderText::setText): Changed to virtual so RenderTextFragment can override
        (WebCore::RenderText::transformText): Added
        * rendering/RenderTextFragment.cpp:
        (WebCore::RenderTextFragment::styleDidChange): Removed references to
        m_allowFragmentReset which was the previous approach to separating the
        code paths
        (WebCore::RenderTextFragment::setTextInternal): Deleted
        (WebCore::RenderTextFragment::setText): Added with most of logic that was
        previously in setTextInternal
        (WebCore::RenderTextFragment::transformText): Added
        * rendering/RenderTextFragment.h:
        (WebCore::RenderTextFragment::setText): Added
        (WebCore::RenderTextFragment::transformText): Added
        (WebCore::RenderTextFragment::setTextInternal): Deleted

2012-04-18  Adam Barth  <abarth@webkit.org>

        FrameLoader::shouldAllowNavigation uses Frame for context rather than Document
        https://bugs.webkit.org/show_bug.cgi?id=81020

        Reviewed by Eric Seidel.

        The vast majority of security checks in the browser should use a
        ScriptExecutionContext (aka a Document) to designate "who" is
        attempting to perform a given action.  Unfortunately,
        shouldAllowNavigation was using a Frame to designate "who" is
        attempting the navigation.

        In cases when the executing script is "inactive" (i.e., belongs to a
        document that is not currently displayed in a Frame), using the Frame
        can cause us to grant the script the privileges of the document that's
        currently displayed in the Frame rather than the one that contains the
        script.

        This patch moves shouldAllowNavigation from FrameLoader to Document
        (and renames it to canNavigate), effectively change the context object
        from a Frame to a Document.

        Test: http/tests/security/frameNavigation/inactive-function-in-popup-navigate-child.html

        * bindings/generic/BindingSecurity.h:
        (BindingSecurity):
        (WebCore):
        * bindings/v8/V8Utilities.cpp:
        (WebCore):
        * bindings/v8/V8Utilities.h:
        (WebCore):
            - Deletes unused code.
        * dom/Document.cpp:
        (WebCore::canAccessAncestor):
        (WebCore):
        (WebCore::Document::canNavigate):
            - canNavigate is copied from FrameLoader::shouldAllowNavigation.
              I've added a null-check bailout if the document is inactive.
        * dom/Document.h:
        (Document):
        * loader/FormState.cpp:
        (WebCore::FormState::FormState):
        (WebCore::FormState::create):
        * loader/FormState.h:
        (WebCore):
        (FormState):
        (WebCore::FormState::sourceDocument):
        * loader/FormSubmission.cpp:
        (WebCore::FormSubmission::create):
            - Changes the context object from Frame to Document.
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::submitForm):
        (WebCore::FrameLoader::loadFrameRequest):
        (WebCore):
        (WebCore::FrameLoader::findFrameForNavigation):
            - FrameLoader::findFrameForNavigation still incorrectly uses Frame
              as the context object, but that's a bug for another patch.
        (WebCore::createWindow):
        * loader/FrameLoader.h:
        (FrameLoader):
        * loader/NavigationScheduler.cpp:
        (WebCore::ScheduledFormSubmission::fire):
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::close):
        (WebCore::DOMWindow::setLocation):
        (WebCore::DOMWindow::open):
        * page/History.cpp:
        (WebCore::History::go):

2012-04-18  Stephen Chenney  <schenney@chromium.org>

        Failure to invalidate text position attributes when DOM changes
        https://bugs.webkit.org/show_bug.cgi?id=81464

        Reviewed by Nikolas Zimmermann.

        The text positioning elements data structure in RenderSVGText must be
        updated when either the children of the corresponding element are
        modified, or the length of the text inside the elements changes.
        Previously, the call to clear the text positioning elements (to force
        recomputation) was guarded by a flag. If code tried to invalidate when
        the flag was not set, then something set the flag, the elements would
        be invalid at use time.

        This patch modifies the method that invalidates the positining
        attributes so that the action always happens. It also renames the
        method to more accurately reflect its function.

        Test: svg/custom/delete-modified-text-in-defs-crash.svg

        * rendering/svg/RenderSVGInlineText.cpp:
        (WebCore::RenderSVGInlineText::setTextInternal): Rename textDOMChanged to invalidateTextPositioningElements
        * rendering/svg/RenderSVGText.cpp:
        (WebCore::RenderSVGText::invalidateTextPositioningElements): Rename
        textDOMChanged to invalidateTextPositioningElements and remove the check against the needsPosition... flag.
        * rendering/svg/RenderSVGText.h:
        (RenderSVGText): Rename textDOMChanged to invalidateTextPositioningElements
        * svg/SVGAElement.cpp:
        (WebCore::SVGAElement::childrenChanged): Rename textDOMChanged to invalidateTextPositioningElements
        * svg/SVGTextContentElement.cpp:
        (WebCore::SVGTextContentElement::childrenChanged): Rename textDOMChanged to invalidateTextPositioningElements

2012-04-18  Abhishek Arya  <inferno@chromium.org>

        Crash in ApplyStyleCommand::applyInlineStyleToNodeRange.
        https://bugs.webkit.org/show_bug.cgi?id=81959

        Reviewed by Ryosuke Niwa.

        Test: editing/execCommand/apply-style-command-crash.html

        * editing/ApplyStyleCommand.cpp:
        (WebCore::ApplyStyleCommand::applyInlineStyleToNodeRange): RefPtr the weak
        node iterator |node|.
        * editing/ApplyStyleCommand.h:
        (ApplyStyleCommand): convert |startNode| and |pastEndNode| into PassRefPtr.

2012-04-18  Abhishek Arya  <inferno@chromium.org>

        Crash in RenderBlock::splitBlocks.
        https://bugs.webkit.org/show_bug.cgi?id=81926

        Reviewed by Julien Chaffraix.

        We are updating the :after content before calling splitFlow. The :after content
        gets blown away since it will go to the continuation. beforeChild was earlier
        set to the first child. Being the last anonymous block, its children gets pulled
        up in collapseAnonymousBoxChild and it gets destroyed. So, we need to update
        beforeChild value. 

        Test: fast/multicol/span/update-after-content-before-child-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::addChildIgnoringAnonymousColumnBlocks):

2012-04-18  Eric Carlson  <eric.carlson@apple.com>

        Deal with DOM modifications when evaluating source elements.
        https://bugs.webkit.org/show_bug.cgi?id=81163

        Reviewed by Alexey Proskuryakov.

        Test: media/video-beforeload-remove-source.html

        * dom/ContainerNode.cpp: Make NodeVector and collectNodes public, renamed as getChildNodes.
        (WebCore::ContainerNode::takeAllChildrenFrom): collectNodes -> getChildNodes.
        (WebCore::ContainerNode::willRemove): collectNodes -> getChildNodes.
        (WebCore::ContainerNode::willRemoveChildren): collectNodes -> getChildNodes.
        (WebCore::ContainerNode::insertedIntoDocument): collectNodes -> getChildNodes.
        (WebCore::ContainerNode::removedFromDocument): collectNodes -> getChildNodes.
        * dom/ContainerNode.h:
        (WebCore::getChildNodes):

        * editing/ReplaceSelectionCommand.cpp: Remove unused NodeVector declaration.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::HTMLMediaElement): m_nextChildNodeToConsider and m_currentSourceNode
            are now RefPtrs.
        (WebCore::HTMLMediaElement::loadTimerFired): Protect HTMLMediaElement from being deleted during
            a DOM modification during an event callback.
        (WebCore::HTMLMediaElement::load): Ditto.
        (WebCore::HTMLMediaElement::selectMediaResource): Set m_nextChildNodeToConsider to the first
            child node, it will be the first node considered.
        (WebCore::HTMLMediaElement::havePotentialSourceChild): m_nextChildNodeToConsider and m_currentSourceNode
            are now RefPtrs.
        (WebCore::HTMLMediaElement::selectNextSourceChild): Collect all child nodes in a vector before
            looking for <source> nodes because 'beforeload' event handlers can mutate the DOM. Don't
            use a <source> that is no longer a child node after 'beforeload'. Use 0 to represent the end
            of the child node list because m_nextChildNodeToConsider is now a RefPtr so using the previous 
            sentinel, "this", would cause a retain cycle.
        (WebCore::HTMLMediaElement::sourceWasAdded):  m_nextChildNodeToConsider and m_currentSourceNode
            are now RefPtrs.
        (WebCore::HTMLMediaElement::sourceWillBeRemoved): Ditto.
        (WebCore::HTMLMediaElement::getPluginProxyParams): Protect HTMLMediaElement from being deleted during
            a DOM modification during an event callback.
        * html/HTMLMediaElement.h:

2012-04-18  Adam Barth  <abarth@webkit.org>

        ContainerNode::willRemove uses a weak iteration pattern
        https://bugs.webkit.org/show_bug.cgi?id=80530

        Reviewed by Ryosuke Niwa.

        This patch moves ContainerNode::willRemove to using a better iteration
        pattern in which we collect all the nodes we're planning to iterate
        into a vector and then iterate over them.

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::willRemove):

2012-04-18  Adam Barth  <abarth@webkit.org>

        ContainerNode::insertedIntoTree and removedFromTree use weak iteration patterns
        https://bugs.webkit.org/show_bug.cgi?id=80570

        Reviewed by Ryosuke Niwa.

        These functions use weak iteration patterns, but as far as I can tell,
        we never execute script below these functions.  This patch adds ASSERTs
        to help us avoid adding events in the future.

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::insertedIntoTree):
        (WebCore::ContainerNode::removedFromTree):
        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::loadInternal):
            - There's a somewhat complex call chain from insertedIntoTree into
              HTMLMediaElement, and somewhat complex control flow below
              loadInternal that eventually leads to the BeforeLoad event being
              fired.  In studying this code, I don't see a way for the
              BeforeLoad event to be fired during insertedIntoTree, but I've
              added this assert here to make sure we don't call loadInternal
              when we're not supposed to dispatch events.  This ASSERT should
              help us catch these BeforeLoad errors more quickly.

2012-04-18  Abhishek Arya  <inferno@chromium.org>

        Incorrect beforeChild parent calculation in RenderRubyBase::moveChildren.
        https://bugs.webkit.org/show_bug.cgi?id=80297

        Reviewed by Julien Chaffraix.

        beforeChild might share the same anonymous block parent with other previous
        siblings. Before moving the children across ruby bases, we need to make sure
        to split the tree across the beforeChild correctly.

        Test: fast/ruby/ruby-text-before-child-split.html

        * rendering/RenderRubyBase.cpp:
        (WebCore::RenderRubyBase::moveChildren):

2012-04-18  Philip Rogers  <pdr@google.com>

        Skip building resources if SVGTRef is not in a document
        https://bugs.webkit.org/show_bug.cgi?id=81473

        Reviewed by Nikolas Zimmermann.

        We can skip the building of pending resources in SVGTRef if we're not
        yet in a document. This mirrors the nearly identical logic in
        SVGUseElement::buildPendingResource() and
        SVGFEImageElement::buildPendingResource().

        Test: http/tests/svg/tref-adoptNode-crash.html

        * svg/SVGTRefElement.cpp:
        (WebCore::SVGTRefElement::buildPendingResource):

2012-03-28  Sergio Villar Senin  <svillar@igalia.com>

        [Soup] DNS prefetching spams resolver, shoots self in the foot
        https://bugs.webkit.org/show_bug.cgi?id=41630

        Reviewed by Martin Robinson.

        Added generic DNSResolveQueue class to throttle DNS
        prefetches. It's an abstract refactoring of CFNET's
        DNSResolveQueue. Platform specific methods implemented for soup
        and CFNET backends.

        No new tests required as we're just refactoring existing code to
        be used by two different ports.

        * CMakeLists.txt: added new file.
        * GNUmakefile.list.am: ditto.
        * WebCore.vcproj/WebCore.vcproj: ditto.
        * WebCore.xcodeproj/project.pbxproj: ditto.
        * platform/network/DNSResolveQueue.cpp: Added.
        (WebCore):
        (WebCore::DNSResolveQueue::add): adds a new host to be prefetched.
        (WebCore::DNSResolveQueue::fired): by using a delay we coalesce
        several prefetch requests and try to resolve them all here.
        * platform/network/DNSResolveQueue.h: Added.
        (WebCore):
        (DNSResolveQueue): class that implements DNS prefetch
        throttling using a template pattern.
        (WebCore::DNSResolveQueue::shared):
        (WebCore::DNSResolveQueue::decrementRequestCount):
        * platform/network/cf/DNSCFNet.cpp:
        (WebCore::DNSResolveQueue::platformProxyIsEnabledInSystemPreferences):
        (WebCore::DNSResolveQueue::platformResolve):
        * platform/network/soup/DNSSoup.cpp:
        (WebCore):
        (WebCore::DNSResolveQueue::platformProxyIsEnabledInSystemPreferences):
        (WebCore::resolvedCallback):
        (WebCore::DNSResolveQueue::platformResolve):
        (WebCore::prefetchDNS):

2012-03-14  Sudarsana Nagineni  <sudarsana.nagineni@linux.intel.com>

        Build error: DNSSoup.cpp:30: fatal error: CString.h: No such file or
        directory
        https://bugs.webkit.org/show_bug.cgi?id=81093

        Reviewed by Philippe Normand.

        Fix build error introduced by r110669.

        * platform/network/soup/DNSSoup.cpp:

2012-03-13  Sergio Villar Senin  <svillar@igalia.com>

        [GTK] Use the same DNS prefetching path than the other ports.
        https://bugs.webkit.org/show_bug.cgi?id=80997

        Reviewed by Martin Robinson.

        This patch basically reverts r56128. There is no need to add an
        special code path for GTK+ DNS pre-fetching because the main
        reason to do that (some potential changes in libsoup) is not
        going to happen. It also reduces the amount of DNS queries by
        adding a NULL hostname check.

        No need for new tests as this just moves code around.

        * GNUmakefile.list.am:
        * html/HTMLAnchorElement.cpp:
        (WebCore::HTMLAnchorElement::parseAttribute):
        * html/HTMLLinkElement.cpp:
        * loader/LinkLoader.cpp:
        (WebCore::LinkLoader::loadLink):
        * page/Chrome.cpp:
        (WebCore::Chrome::mouseDidMoveOverElement):
        * platform/network/DNS.h:
        (WebCore):
        * platform/network/ResourceHandle.cpp:
        * platform/network/ResourceHandle.h:
        (ResourceHandle):
        * platform/network/chromium/DNSChromium.cpp:
        * platform/network/soup/DNSSoup.cpp: restored.
        (WebCore):
        (WebCore::prefetchDNS):
        * platform/network/soup/ResourceHandleSoup.cpp:

2012-04-09  Martin Robinson  <mrobinson@igalia.com>

        [soup] Crash while loading http://www.jusco.cn
        https://bugs.webkit.org/show_bug.cgi?id=68238

        Reviewed by Philippe Normand.

        Test: http/tests/xmlhttprequest/xmlhttprequest-sync-no-timers.html

        When running synchronous XMLHttpRequests, push a new inner thread default
        context, so that other sources from timers and network activity do not run.
        This will make synchronous requests truly synchronous with the rest of
        WebCore.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCoreSynchronousLoader): Clean up the method definitions a bit by writing them inline.
        (WebCore::WebCoreSynchronousLoader::WebCoreSynchronousLoader): Push a new thread default
        context to prevent other sources from running.
        (WebCore::WebCoreSynchronousLoader::~WebCoreSynchronousLoader): Pop the inner thread default context.
        (WebCore::closeCallback): If the client is synchronous call didFinishLoading now.
        (WebCore::readCallback): Only call didFinishLoading if the client isn't synchronous.
        (WebCore::ResourceHandle::defaultSession): Activate use-thread-context so that the soup session
        respects the inner thread context.

2012-04-09  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Toggle buttons do not size appropriately in some themes
        https://bugs.webkit.org/show_bug.cgi?id=82833

        Reviewed by Gustavo Noronha Silva.

        Test: platform/gtk/fast/forms/large-toggle-elements.html

        Instead of drawing a toggle button across the entire rectangle of
        the WebCore control, draw a default-sized one cenetered in the rectangle.

        * platform/gtk/RenderThemeGtk3.cpp:
        (WebCore::paintToggle): Draw default-sized toggles.

2012-04-05  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Scrolling some iframes that are partially out of the viewport leads to repaint errors
        https://bugs.webkit.org/show_bug.cgi?id=83309

        Reviewed by Gustavo Noronha Silva.

        Test: platform/gtk/fast/frames/scrolling-iframe-out-of-viewport.html

        The X11 backing store was not properly trimming the scroll region when it
        was only a portion of the screen. This was hidden by subsequent repaints.

        * platform/gtk/GtkWidgetBackingStoreX11.cpp:
        (WebCore::WidgetBackingStore::scroll): Fix the calculation of the scrolling region.

2012-04-18  Abhishek Arya  <inferno@chromium.org>

        Crash due to layer tree information not updated when moving run-in children.
        https://bugs.webkit.org/show_bug.cgi?id=81265

        Reviewed by Julien Chaffraix.

        We need to do a full removal as the run-in child is getting inserted into
        the neighbouring block and |blockRunIn| is going to be destroyed later
        in the function.

        Test: fast/runin/run-in-layer-not-removed-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::handleRunInChild):

2012-04-18  Abhishek Arya  <inferno@chromium.org>

        Crash in Text::splitText due to mutation events.
        https://bugs.webkit.org/show_bug.cgi?id=80828

        Reviewed by Ryosuke Niwa.

        Test: fast/text/split-text-crash.xhtml

        * dom/Range.cpp:
        (WebCore::Range::insertNode): replace m_start.container() calls with ref protected node.

2012-04-18  Tim Horton  <timothy_horton@apple.com>

        Crash in SVGTextLayoutAttributesBuilder::fillCharacterDataMap
        https://bugs.webkit.org/show_bug.cgi?id=78949
        <rdar://problem/10889440>

        Reviewed by Nikolas Zimmermann.

        Invalidate the text positioning cache when the children of an SVGAElement change,
        so that we regenerate the list the next time it's needed instead of using stale values.

        Test: svg/text/text-positioning-remove-child-crash.svg

        * rendering/svg/SVGAElement.cpp:
        (WebCore::SVGAElement::childrenChanged):

2012-04-16  Adam Barth  <abarth@webkit.org>

        ContainerNode::insertedIntoDocument and removedFromDocument use weak iteration patterns
        https://bugs.webkit.org/show_bug.cgi?id=80569

        Reviewed by Ryosuke Niwa.

        This patch moves ContainerNode::insertedIntoDocument and
        removedFromDocument to using a better iteration pattern in which we
        collect all the nodes we're planning to iterate into a vector and then
        iterate over them.

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::insertedIntoDocument):
        (WebCore::ContainerNode::removedFromDocument):

2012-04-03  Dominik Röttsches  <dominik.rottsches@linux.intel.com>

        Soup HTTP backend does not send Content-Length in certain cases
        https://bugs.webkit.org/show_bug.cgi?id=82036

        Reviewed by Gustavo Noronha Silva.

        Telling soup explicitly when to send content-length header
        in POST & PUT cases in order to align with e.g. Chromium and FF.

        No new tests, already covered by *methods*.html in
        http/tests/xmlhttprequest/.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::startHTTPRequest): Special handling for POST & PUT.

2012-03-26  Zan Dobersek  <zandobersek@gmail.com>

        [GObject bindings] Supplemental interfaces are not disabled with the "Conditional" attribute
        https://bugs.webkit.org/show_bug.cgi?id=80030

        Reviewed by Martin Robinson.

        Changes in CodeGeneratorGObject.pm:
        - group implementation of private helpers and guard them inside
        an ifdef if a root conditional attribute is present.
        - always define the type of a GObject binding, even if the root
        conditional feature is not enabled
        - the methods are generated as well, but are simply stubs if the
        feature is not enabled, throwing a warning upon interaction.
        - if the method itself is guarded by a conditional attribute,
        the stub implementation gains one more level of depth, throwing
        a warning if the method's conditional feature is not enabled
        but the root conditional feature is.
        - small style fixes in random places.

        Also changed are GObject baselines for binding tests.

        No new tests - no new testable functionality.

        * bindings/gobject/GNUmakefile.am:
        * bindings/scripts/CodeGeneratorGObject.pm:
        (HumanReadableConditional):
        (GenerateConditionalWarn):
        (GenerateProperty):
        (GenerateProperties):
        (GenerateFunction):
        (GenerateFunctions):
        (GenerateCFile):
        (GenerateEventTargetIface):
        (Generate):
        (WriteData):
        * bindings/scripts/test/GObject/WebKitDOMFloat64Array.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapFloat64Array):
        (webkit_dom_float64array_finalize):
        (webkit_dom_float64array_foo):
        * bindings/scripts/test/GObject/WebKitDOMFloat64ArrayPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestActiveDOMObject.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestActiveDOMObject):
        (webkit_dom_test_active_dom_object_finalize):
        (webkit_dom_test_active_dom_object_exciting_function):
        (webkit_dom_test_active_dom_object_post_message):
        (webkit_dom_test_active_dom_object_get_exciting_attr):
        * bindings/scripts/test/GObject/WebKitDOMTestActiveDOMObjectPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestCallback.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::core):
        (WebKit::wrapTestCallback):
        (webkit_dom_test_callback_finalize):
        (webkit_dom_test_callback_callback_with_no_param):
        (webkit_dom_test_callback_callback_with_class1param):
        (webkit_dom_test_callback_callback_with_class2param):
        (webkit_dom_test_callback_callback_with_non_bool_return_type):
        (webkit_dom_test_callback_callback_with_string_list):
        * bindings/scripts/test/GObject/WebKitDOMTestCallbackPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestCustomNamedGetter.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestCustomNamedGetter):
        (webkit_dom_test_custom_named_getter_finalize):
        (webkit_dom_test_custom_named_getter_another_function):
        * bindings/scripts/test/GObject/WebKitDOMTestCustomNamedGetterPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestEventConstructor.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestEventConstructor):
        (webkit_dom_test_event_constructor_finalize):
        (webkit_dom_test_event_constructor_get_attr1):
        (webkit_dom_test_event_constructor_get_attr2):
        * bindings/scripts/test/GObject/WebKitDOMTestEventConstructorPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestEventTarget.cpp:
        (WebKit):
        (WebKit::core):
        (WebKit::wrapTestEventTarget):
        (webkit_dom_test_event_target_finalize):
        (webkit_dom_test_event_target_item):
        (webkit_dom_test_event_target_dispatch_event):
        * bindings/scripts/test/GObject/WebKitDOMTestEventTargetPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestInterface.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::core):
        (WebKit::wrapTestInterface):
        (webkit_dom_test_interface_finalize):
        (webkit_dom_test_interface_supplemental_method1):
        (webkit_dom_test_interface_supplemental_method2):
        (webkit_dom_test_interface_supplemental_method4):
        (webkit_dom_test_interface_get_supplemental_str1):
        (webkit_dom_test_interface_get_supplemental_str2):
        (webkit_dom_test_interface_set_supplemental_str2):
        (webkit_dom_test_interface_get_supplemental_node):
        (webkit_dom_test_interface_set_supplemental_node):
        * bindings/scripts/test/GObject/WebKitDOMTestInterfacePrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestMediaQueryListListener.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestMediaQueryListListener):
        (webkit_dom_test_media_query_list_listener_finalize):
        * bindings/scripts/test/GObject/WebKitDOMTestMediaQueryListListenerPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestNamedConstructor.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestNamedConstructor):
        (webkit_dom_test_named_constructor_finalize):
        * bindings/scripts/test/GObject/WebKitDOMTestNamedConstructorPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestObj.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::core):
        (WebKit::wrapTestObj):
        (webkit_dom_test_obj_finalize):
        (webkit_dom_test_obj_set_property):
        (webkit_dom_test_obj_get_property):
        (webkit_dom_test_obj_constructed):
        (webkit_dom_test_obj_class_init):
        (webkit_dom_test_obj_init):
        (webkit_dom_test_obj_void_method):
        (webkit_dom_test_obj_void_method_with_args):
        (webkit_dom_test_obj_int_method):
        (webkit_dom_test_obj_int_method_with_args):
        (webkit_dom_test_obj_obj_method):
        (webkit_dom_test_obj_obj_method_with_args):
        (webkit_dom_test_obj_method_with_sequence_arg):
        (webkit_dom_test_obj_method_that_requires_all_args_and_throws):
        (webkit_dom_test_obj_serialized_value):
        (webkit_dom_test_obj_idb_key):
        (webkit_dom_test_obj_options_object):
        (webkit_dom_test_obj_method_with_exception):
        (webkit_dom_test_obj_with_script_state_void):
        (webkit_dom_test_obj_with_script_state_obj):
        (webkit_dom_test_obj_with_script_state_void_exception):
        (webkit_dom_test_obj_with_script_state_obj_exception):
        (webkit_dom_test_obj_with_script_execution_context):
        (webkit_dom_test_obj_with_script_execution_context_and_script_state):
        (webkit_dom_test_obj_with_script_execution_context_and_script_state_obj_exception):
        (webkit_dom_test_obj_with_script_execution_context_and_script_state_with_spaces):
        (webkit_dom_test_obj_method_with_optional_arg):
        (webkit_dom_test_obj_method_with_non_optional_arg_and_optional_arg):
        (webkit_dom_test_obj_method_with_non_optional_arg_and_two_optional_args):
        (webkit_dom_test_obj_method_with_optional_string):
        (webkit_dom_test_obj_method_with_optional_string_is_undefined):
        (webkit_dom_test_obj_method_with_optional_string_is_null_string):
        (webkit_dom_test_obj_conditional_method1):
        (webkit_dom_test_obj_conditional_method2):
        (webkit_dom_test_obj_conditional_method3):
        (webkit_dom_test_obj_class_method):
        (webkit_dom_test_obj_class_method_with_optional):
        (webkit_dom_test_obj_overloaded_method1):
        (webkit_dom_test_obj_convert1):
        (webkit_dom_test_obj_convert2):
        (webkit_dom_test_obj_convert3):
        (webkit_dom_test_obj_convert4):
        (webkit_dom_test_obj_convert5):
        (webkit_dom_test_obj_mutable_point_function):
        (webkit_dom_test_obj_immutable_point_function):
        (webkit_dom_test_obj_orange):
        (webkit_dom_test_obj_strict_function):
        (webkit_dom_test_obj_get_read_only_int_attr):
        (webkit_dom_test_obj_get_read_only_string_attr):
        (webkit_dom_test_obj_get_read_only_test_obj_attr):
        (webkit_dom_test_obj_get_short_attr):
        (webkit_dom_test_obj_set_short_attr):
        (webkit_dom_test_obj_get_unsigned_short_attr):
        (webkit_dom_test_obj_set_unsigned_short_attr):
        (webkit_dom_test_obj_get_int_attr):
        (webkit_dom_test_obj_set_int_attr):
        (webkit_dom_test_obj_get_long_long_attr):
        (webkit_dom_test_obj_set_long_long_attr):
        (webkit_dom_test_obj_get_unsigned_long_long_attr):
        (webkit_dom_test_obj_set_unsigned_long_long_attr):
        (webkit_dom_test_obj_get_string_attr):
        (webkit_dom_test_obj_set_string_attr):
        (webkit_dom_test_obj_get_test_obj_attr):
        (webkit_dom_test_obj_set_test_obj_attr):
        (webkit_dom_test_obj_get_xml_obj_attr):
        (webkit_dom_test_obj_set_xml_obj_attr):
        (webkit_dom_test_obj_get_create):
        (webkit_dom_test_obj_set_create):
        (webkit_dom_test_obj_get_reflected_string_attr):
        (webkit_dom_test_obj_set_reflected_string_attr):
        (webkit_dom_test_obj_get_reflected_integral_attr):
        (webkit_dom_test_obj_set_reflected_integral_attr):
        (webkit_dom_test_obj_get_reflected_unsigned_integral_attr):
        (webkit_dom_test_obj_set_reflected_unsigned_integral_attr):
        (webkit_dom_test_obj_get_reflected_boolean_attr):
        (webkit_dom_test_obj_set_reflected_boolean_attr):
        (webkit_dom_test_obj_get_reflected_url_attr):
        (webkit_dom_test_obj_set_reflected_url_attr):
        (webkit_dom_test_obj_get_reflected_custom_integral_attr):
        (webkit_dom_test_obj_set_reflected_custom_integral_attr):
        (webkit_dom_test_obj_get_reflected_custom_boolean_attr):
        (webkit_dom_test_obj_set_reflected_custom_boolean_attr):
        (webkit_dom_test_obj_get_reflected_custom_url_attr):
        (webkit_dom_test_obj_set_reflected_custom_url_attr):
        (webkit_dom_test_obj_get_attr_with_getter_exception):
        (webkit_dom_test_obj_set_attr_with_getter_exception):
        (webkit_dom_test_obj_get_attr_with_setter_exception):
        (webkit_dom_test_obj_set_attr_with_setter_exception):
        (webkit_dom_test_obj_get_string_attr_with_getter_exception):
        (webkit_dom_test_obj_set_string_attr_with_getter_exception):
        (webkit_dom_test_obj_get_string_attr_with_setter_exception):
        (webkit_dom_test_obj_set_string_attr_with_setter_exception):
        (webkit_dom_test_obj_get_with_script_state_attribute):
        (webkit_dom_test_obj_set_with_script_state_attribute):
        (webkit_dom_test_obj_get_with_script_execution_context_attribute):
        (webkit_dom_test_obj_set_with_script_execution_context_attribute):
        (webkit_dom_test_obj_get_with_script_state_attribute_raises):
        (webkit_dom_test_obj_set_with_script_state_attribute_raises):
        (webkit_dom_test_obj_get_with_script_execution_context_attribute_raises):
        (webkit_dom_test_obj_set_with_script_execution_context_attribute_raises):
        (webkit_dom_test_obj_get_with_script_execution_context_and_script_state_attribute):
        (webkit_dom_test_obj_set_with_script_execution_context_and_script_state_attribute):
        (webkit_dom_test_obj_get_with_script_execution_context_and_script_state_attribute_raises):
        (webkit_dom_test_obj_set_with_script_execution_context_and_script_state_attribute_raises):
        (webkit_dom_test_obj_get_with_script_execution_context_and_script_state_with_spaces_attribute):
        (webkit_dom_test_obj_set_with_script_execution_context_and_script_state_with_spaces_attribute):
        (webkit_dom_test_obj_get_conditional_attr1):
        (webkit_dom_test_obj_set_conditional_attr1):
        (webkit_dom_test_obj_get_conditional_attr2):
        (webkit_dom_test_obj_set_conditional_attr2):
        (webkit_dom_test_obj_get_conditional_attr3):
        (webkit_dom_test_obj_set_conditional_attr3):
        (webkit_dom_test_obj_get_content_document):
        (webkit_dom_test_obj_get_mutable_point):
        (webkit_dom_test_obj_set_mutable_point):
        (webkit_dom_test_obj_get_immutable_point):
        (webkit_dom_test_obj_set_immutable_point):
        (webkit_dom_test_obj_get_strict_float):
        (webkit_dom_test_obj_set_strict_float):
        (webkit_dom_test_obj_get_description):
        (webkit_dom_test_obj_get_id):
        (webkit_dom_test_obj_set_id):
        (webkit_dom_test_obj_get_hash):
        * bindings/scripts/test/GObject/WebKitDOMTestObjPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestSerializedScriptValueInterface.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::core):
        (WebKit::wrapTestSerializedScriptValueInterface):
        (webkit_dom_test_serialized_script_value_interface_finalize):
        (webkit_dom_test_serialized_script_value_interface_accept_transfer_list):
        (webkit_dom_test_serialized_script_value_interface_multi_transfer_list):
        (webkit_dom_test_serialized_script_value_interface_get_value):
        (webkit_dom_test_serialized_script_value_interface_set_value):
        (webkit_dom_test_serialized_script_value_interface_get_readonly_value):
        (webkit_dom_test_serialized_script_value_interface_get_cached_value):
        (webkit_dom_test_serialized_script_value_interface_set_cached_value):
        (webkit_dom_test_serialized_script_value_interface_get_cached_readonly_value):
        * bindings/scripts/test/GObject/WebKitDOMTestSerializedScriptValueInterfacePrivate.h:

2012-03-26  Zan Dobersek  <zandobersek@gmail.com>

        [GObject bindings] Supplemental interfaces are not disabled with the "Conditional" attribute
        https://bugs.webkit.org/show_bug.cgi?id=80030

        Reviewed by Martin Robinson.

        Changes in CodeGeneratorGObject.pm:
        - group implementation of private helpers and guard them inside
        an ifdef if a root conditional attribute is present.
        - always define the type of a GObject binding, even if the root
        conditional feature is not enabled
        - the methods are generated as well, but are simply stubs if the
        feature is not enabled, throwing a warning upon interaction.
        - if the method itself is guarded by a conditional attribute,
        the stub implementation gains one more level of depth, throwing
        a warning if the method's conditional feature is not enabled
        but the root conditional feature is.
        - small style fixes in random places.

        Also changed are GObject baselines for binding tests.

        No new tests - no new testable functionality.

        * bindings/gobject/GNUmakefile.am:
        * bindings/scripts/CodeGeneratorGObject.pm:
        (HumanReadableConditional):
        (GenerateConditionalWarn):
        (GenerateProperty):
        (GenerateProperties):
        (GenerateFunction):
        (GenerateFunctions):
        (GenerateCFile):
        (GenerateEventTargetIface):
        (Generate):
        (WriteData):
        * bindings/scripts/test/GObject/WebKitDOMFloat64Array.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapFloat64Array):
        (webkit_dom_float64array_finalize):
        (webkit_dom_float64array_foo):
        * bindings/scripts/test/GObject/WebKitDOMFloat64ArrayPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestActiveDOMObject.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestActiveDOMObject):
        (webkit_dom_test_active_dom_object_finalize):
        (webkit_dom_test_active_dom_object_exciting_function):
        (webkit_dom_test_active_dom_object_post_message):
        (webkit_dom_test_active_dom_object_get_exciting_attr):
        * bindings/scripts/test/GObject/WebKitDOMTestActiveDOMObjectPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestCallback.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::core):
        (WebKit::wrapTestCallback):
        (webkit_dom_test_callback_finalize):
        (webkit_dom_test_callback_callback_with_no_param):
        (webkit_dom_test_callback_callback_with_class1param):
        (webkit_dom_test_callback_callback_with_class2param):
        (webkit_dom_test_callback_callback_with_non_bool_return_type):
        (webkit_dom_test_callback_callback_with_string_list):
        * bindings/scripts/test/GObject/WebKitDOMTestCallbackPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestCustomNamedGetter.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestCustomNamedGetter):
        (webkit_dom_test_custom_named_getter_finalize):
        (webkit_dom_test_custom_named_getter_another_function):
        * bindings/scripts/test/GObject/WebKitDOMTestCustomNamedGetterPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestEventConstructor.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestEventConstructor):
        (webkit_dom_test_event_constructor_finalize):
        (webkit_dom_test_event_constructor_get_attr1):
        (webkit_dom_test_event_constructor_get_attr2):
        * bindings/scripts/test/GObject/WebKitDOMTestEventConstructorPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestEventTarget.cpp:
        (WebKit):
        (WebKit::core):
        (WebKit::wrapTestEventTarget):
        (webkit_dom_test_event_target_finalize):
        (webkit_dom_test_event_target_item):
        (webkit_dom_test_event_target_dispatch_event):
        * bindings/scripts/test/GObject/WebKitDOMTestEventTargetPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestInterface.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::core):
        (WebKit::wrapTestInterface):
        (webkit_dom_test_interface_finalize):
        (webkit_dom_test_interface_supplemental_method1):
        (webkit_dom_test_interface_supplemental_method2):
        (webkit_dom_test_interface_supplemental_method4):
        (webkit_dom_test_interface_get_supplemental_str1):
        (webkit_dom_test_interface_get_supplemental_str2):
        (webkit_dom_test_interface_set_supplemental_str2):
        (webkit_dom_test_interface_get_supplemental_node):
        (webkit_dom_test_interface_set_supplemental_node):
        * bindings/scripts/test/GObject/WebKitDOMTestInterfacePrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestMediaQueryListListener.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestMediaQueryListListener):
        (webkit_dom_test_media_query_list_listener_finalize):
        * bindings/scripts/test/GObject/WebKitDOMTestMediaQueryListListenerPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestNamedConstructor.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::wrapTestNamedConstructor):
        (webkit_dom_test_named_constructor_finalize):
        * bindings/scripts/test/GObject/WebKitDOMTestNamedConstructorPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestObj.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::core):
        (WebKit::wrapTestObj):
        (webkit_dom_test_obj_finalize):
        (webkit_dom_test_obj_set_property):
        (webkit_dom_test_obj_get_property):
        (webkit_dom_test_obj_constructed):
        (webkit_dom_test_obj_class_init):
        (webkit_dom_test_obj_init):
        (webkit_dom_test_obj_void_method):
        (webkit_dom_test_obj_void_method_with_args):
        (webkit_dom_test_obj_int_method):
        (webkit_dom_test_obj_int_method_with_args):
        (webkit_dom_test_obj_obj_method):
        (webkit_dom_test_obj_obj_method_with_args):
        (webkit_dom_test_obj_method_with_sequence_arg):
        (webkit_dom_test_obj_method_that_requires_all_args_and_throws):
        (webkit_dom_test_obj_serialized_value):
        (webkit_dom_test_obj_idb_key):
        (webkit_dom_test_obj_options_object):
        (webkit_dom_test_obj_method_with_exception):
        (webkit_dom_test_obj_with_script_state_void):
        (webkit_dom_test_obj_with_script_state_obj):
        (webkit_dom_test_obj_with_script_state_void_exception):
        (webkit_dom_test_obj_with_script_state_obj_exception):
        (webkit_dom_test_obj_with_script_execution_context):
        (webkit_dom_test_obj_with_script_execution_context_and_script_state):
        (webkit_dom_test_obj_with_script_execution_context_and_script_state_obj_exception):
        (webkit_dom_test_obj_with_script_execution_context_and_script_state_with_spaces):
        (webkit_dom_test_obj_method_with_optional_arg):
        (webkit_dom_test_obj_method_with_non_optional_arg_and_optional_arg):
        (webkit_dom_test_obj_method_with_non_optional_arg_and_two_optional_args):
        (webkit_dom_test_obj_method_with_optional_string):
        (webkit_dom_test_obj_method_with_optional_string_is_undefined):
        (webkit_dom_test_obj_method_with_optional_string_is_null_string):
        (webkit_dom_test_obj_conditional_method1):
        (webkit_dom_test_obj_conditional_method2):
        (webkit_dom_test_obj_conditional_method3):
        (webkit_dom_test_obj_class_method):
        (webkit_dom_test_obj_class_method_with_optional):
        (webkit_dom_test_obj_overloaded_method1):
        (webkit_dom_test_obj_convert1):
        (webkit_dom_test_obj_convert2):
        (webkit_dom_test_obj_convert3):
        (webkit_dom_test_obj_convert4):
        (webkit_dom_test_obj_convert5):
        (webkit_dom_test_obj_mutable_point_function):
        (webkit_dom_test_obj_immutable_point_function):
        (webkit_dom_test_obj_orange):
        (webkit_dom_test_obj_strict_function):
        (webkit_dom_test_obj_get_read_only_int_attr):
        (webkit_dom_test_obj_get_read_only_string_attr):
        (webkit_dom_test_obj_get_read_only_test_obj_attr):
        (webkit_dom_test_obj_get_short_attr):
        (webkit_dom_test_obj_set_short_attr):
        (webkit_dom_test_obj_get_unsigned_short_attr):
        (webkit_dom_test_obj_set_unsigned_short_attr):
        (webkit_dom_test_obj_get_int_attr):
        (webkit_dom_test_obj_set_int_attr):
        (webkit_dom_test_obj_get_long_long_attr):
        (webkit_dom_test_obj_set_long_long_attr):
        (webkit_dom_test_obj_get_unsigned_long_long_attr):
        (webkit_dom_test_obj_set_unsigned_long_long_attr):
        (webkit_dom_test_obj_get_string_attr):
        (webkit_dom_test_obj_set_string_attr):
        (webkit_dom_test_obj_get_test_obj_attr):
        (webkit_dom_test_obj_set_test_obj_attr):
        (webkit_dom_test_obj_get_xml_obj_attr):
        (webkit_dom_test_obj_set_xml_obj_attr):
        (webkit_dom_test_obj_get_create):
        (webkit_dom_test_obj_set_create):
        (webkit_dom_test_obj_get_reflected_string_attr):
        (webkit_dom_test_obj_set_reflected_string_attr):
        (webkit_dom_test_obj_get_reflected_integral_attr):
        (webkit_dom_test_obj_set_reflected_integral_attr):
        (webkit_dom_test_obj_get_reflected_unsigned_integral_attr):
        (webkit_dom_test_obj_set_reflected_unsigned_integral_attr):
        (webkit_dom_test_obj_get_reflected_boolean_attr):
        (webkit_dom_test_obj_set_reflected_boolean_attr):
        (webkit_dom_test_obj_get_reflected_url_attr):
        (webkit_dom_test_obj_set_reflected_url_attr):
        (webkit_dom_test_obj_get_reflected_custom_integral_attr):
        (webkit_dom_test_obj_set_reflected_custom_integral_attr):
        (webkit_dom_test_obj_get_reflected_custom_boolean_attr):
        (webkit_dom_test_obj_set_reflected_custom_boolean_attr):
        (webkit_dom_test_obj_get_reflected_custom_url_attr):
        (webkit_dom_test_obj_set_reflected_custom_url_attr):
        (webkit_dom_test_obj_get_attr_with_getter_exception):
        (webkit_dom_test_obj_set_attr_with_getter_exception):
        (webkit_dom_test_obj_get_attr_with_setter_exception):
        (webkit_dom_test_obj_set_attr_with_setter_exception):
        (webkit_dom_test_obj_get_string_attr_with_getter_exception):
        (webkit_dom_test_obj_set_string_attr_with_getter_exception):
        (webkit_dom_test_obj_get_string_attr_with_setter_exception):
        (webkit_dom_test_obj_set_string_attr_with_setter_exception):
        (webkit_dom_test_obj_get_with_script_state_attribute):
        (webkit_dom_test_obj_set_with_script_state_attribute):
        (webkit_dom_test_obj_get_with_script_execution_context_attribute):
        (webkit_dom_test_obj_set_with_script_execution_context_attribute):
        (webkit_dom_test_obj_get_with_script_state_attribute_raises):
        (webkit_dom_test_obj_set_with_script_state_attribute_raises):
        (webkit_dom_test_obj_get_with_script_execution_context_attribute_raises):
        (webkit_dom_test_obj_set_with_script_execution_context_attribute_raises):
        (webkit_dom_test_obj_get_with_script_execution_context_and_script_state_attribute):
        (webkit_dom_test_obj_set_with_script_execution_context_and_script_state_attribute):
        (webkit_dom_test_obj_get_with_script_execution_context_and_script_state_attribute_raises):
        (webkit_dom_test_obj_set_with_script_execution_context_and_script_state_attribute_raises):
        (webkit_dom_test_obj_get_with_script_execution_context_and_script_state_with_spaces_attribute):
        (webkit_dom_test_obj_set_with_script_execution_context_and_script_state_with_spaces_attribute):
        (webkit_dom_test_obj_get_conditional_attr1):
        (webkit_dom_test_obj_set_conditional_attr1):
        (webkit_dom_test_obj_get_conditional_attr2):
        (webkit_dom_test_obj_set_conditional_attr2):
        (webkit_dom_test_obj_get_conditional_attr3):
        (webkit_dom_test_obj_set_conditional_attr3):
        (webkit_dom_test_obj_get_content_document):
        (webkit_dom_test_obj_get_mutable_point):
        (webkit_dom_test_obj_set_mutable_point):
        (webkit_dom_test_obj_get_immutable_point):
        (webkit_dom_test_obj_set_immutable_point):
        (webkit_dom_test_obj_get_strict_float):
        (webkit_dom_test_obj_set_strict_float):
        (webkit_dom_test_obj_get_description):
        (webkit_dom_test_obj_get_id):
        (webkit_dom_test_obj_set_id):
        (webkit_dom_test_obj_get_hash):
        * bindings/scripts/test/GObject/WebKitDOMTestObjPrivate.h:
        * bindings/scripts/test/GObject/WebKitDOMTestSerializedScriptValueInterface.cpp:
        (WebKit):
        (WebKit::kit):
        (WebKit::core):
        (WebKit::wrapTestSerializedScriptValueInterface):
        (webkit_dom_test_serialized_script_value_interface_finalize):
        (webkit_dom_test_serialized_script_value_interface_accept_transfer_list):
        (webkit_dom_test_serialized_script_value_interface_multi_transfer_list):
        (webkit_dom_test_serialized_script_value_interface_get_value):
        (webkit_dom_test_serialized_script_value_interface_set_value):
        (webkit_dom_test_serialized_script_value_interface_get_readonly_value):
        (webkit_dom_test_serialized_script_value_interface_get_cached_value):
        (webkit_dom_test_serialized_script_value_interface_set_cached_value):
        (webkit_dom_test_serialized_script_value_interface_get_cached_readonly_value):
        * bindings/scripts/test/GObject/WebKitDOMTestSerializedScriptValueInterfacePrivate.h:

2012-03-23  Julien Chaffraix  <jchaffraix@webkit.org>

        REGRESSION(107971): Google Voice contact list is broken in WebKit due to badly allocating the extra height
        https://bugs.webkit.org/show_bug.cgi?id=81826

        Reviewed by Tony Chang.

        Covered by tables/mozilla/bugs/bug27038-{1|2}.html.

        This partly reverts r107971: the extra logical height distribution change was not needed
        to fix the bug (it is needed by the test though). We revert to giving all the extra height
        to the first tbody and not the first section.

        This is broken but unfortunately some websites are relying on that. Getting a real
        distribution algorithm is covered by bug 81824. However this is super tricky to get
        right and I did not want to add more compatibility risks until I have something solid.

        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::distributeExtraLogicalHeight):

2012-03-23  Konrad Piascik  <kpiascik@rim.com>

        (r110063) m_mouseDownMayStartDrag is used without being behind the ENABLE(DRAG_SUPPORT) macro
        https://bugs.webkit.org/show_bug.cgi?id=81666

        Reviewed by Rob Buis.

        Compiled with feature disabled and built.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::selectCursor):

2012-03-23  Adam Barth  <abarth@webkit.org>

        Remove support for "magic" iframe
        https://bugs.webkit.org/show_bug.cgi?id=81590

        Reviewed by Eric Seidel.

        This patch removes support for "magic" iframe, which previously allowed
        an iframe to be transfered from one document to another without
        reloading the iframe.  The idea behind this feature was to let sites
        create "pop out" windows that could outlive their parents by
        transfering state to these windows via these magic iframes.

        Unforuntately, this feature was never implemented by other browsers and
        has been the source of a series of security vulnerabilities.  Although
        we have fixed each vulnerability as it has been discovered, the feature
        is still a complex corner case that isn't widely exercised on the web.
        For that reason, it's likely to have more vulnerabilities in the
        future.

        I'm not aware of any web sites that use this feature anymore.  There
        were a handful of them, but we appear to have been successful in
        evangalizing them to move away from "magic" iframe.

        * dom/Document.cpp:
        (WebCore::Document::adoptNode):
        * html/HTMLFrameElementBase.cpp:
        (WebCore):
        (WebCore::HTMLFrameElementBase::HTMLFrameElementBase):
        (WebCore::HTMLFrameElementBase::insertedIntoDocument):
        * html/HTMLFrameElementBase.h:
        (HTMLFrameElementBase):
        * loader/DocumentLoader.cpp:
        (WebCore):
        * loader/DocumentLoader.h:
        (DocumentLoader):
        * loader/EmptyClients.h:
        (WebCore::EmptyFrameLoaderClient::createFrame):
        * loader/FrameLoader.cpp:
        (WebCore):
        * loader/FrameLoader.h:
        (FrameLoader):
        * loader/FrameLoaderClient.h:
        (FrameLoaderClient):
        * loader/ResourceLoadNotifier.cpp:
        (WebCore):
        * loader/ResourceLoadNotifier.h:
        (ResourceLoadNotifier):
        * page/Frame.cpp:
        (WebCore):
        * page/Frame.h:
        (Frame):

2012-03-23  Allan Sandfeld Jensen  <allan.jensen@nokia.com>

        REGRESSION(r106232): The resize handler is always called after loading.
        https://bugs.webkit.org/show_bug.cgi?id=80242

        Reviewed by Kenneth Rohde Christiansen.

        Ensure resize-events are not emitted when layout-size changes due to added
        scrollbars. For fixed layout, scrollbars are never subtracted or added, so
        we can compare fixedLayoutSize directly. For normal layout, use the full
        visible rect size which is the same as layout size plus scrollbars.

        Test: fast/events/resize-events.html

        * page/FrameView.cpp:
        (WebCore::FrameView::reset):
        (WebCore::FrameView::layout):
        (WebCore::FrameView::performPostLayoutTasks):
        * page/FrameView.h:
        (FrameView):

2012-03-23  Adam Klein  <adamk@chromium.org>

        REGRESSION(r103452): 100% CPU usage and 5s pause after clicking on a link in Yahoo Mail
        https://bugs.webkit.org/show_bug.cgi?id=81141

        Reviewed by Ojan Vafai.

        Revert the behavior change from r103452: don't fire DOMSubtreeModified
        events when an attribute value merely changes. Still fire that event
        when an attribute is added or removed from an element.

        Though this contradicts the DOM3 spec, it matches legacy WebKit behavior,
        and given that Mutation Events are deprecated, it seems unwise to make
        any additions to WebKit's implementation of them.

        Test: fast/dom/subtree-modified-attributes.html

        * dom/Element.cpp:
        (WebCore::Element::didAddAttribute): Renamed from didModifyAttribute.
        (WebCore::Element::didModifyAttribute): Remove the call to dispatchSubtreeModifiedEvent.
        (WebCore):
        * dom/Element.h:
        (Element):
        * dom/ElementAttributeData.cpp:
        (WebCore::ElementAttributeData::addAttribute): Call didAddAttribute instead of didModifyAttribute.

2012-03-23  Daniel Bates  <dbates@webkit.org>

        REGRESSION(r99369): File input button doesn't highlight when pressed
        https://bugs.webkit.org/show_bug.cgi?id=79385

        Reviewed by Kent Tamura.

        Fixes an issue where the file input button doesn't highlight on mouse press.

        Currently we always override the active state of the button with whether
        a dragged file is being hovered over the file input control (i.e. can the control
        receive a dropped file; HTMLInputElement::canReceiveDroppedFiles()).
        Instead, we should only override the active state of the button when the state
        changes for whether we can receive dropped files (e.g. during a drag) so that
        we honor the active state of the button when it is pressed.

        Test: fast/forms/file/file-input-pressed-state.html

        * rendering/RenderFileUploadControl.cpp:
        (WebCore::RenderFileUploadControl::RenderFileUploadControl):
        (WebCore::RenderFileUploadControl::updateFromElement):
        * rendering/RenderFileUploadControl.h:
        (RenderFileUploadControl):

2012-03-23  Shawn Singh  <shawnsingh@chromium.org>

        REGRESSION (r93614): scrolling div does not repaint
        https://bugs.webkit.org/show_bug.cgi?id=80641

        Reviewed by Simon Fraser.

        Test: compositing/repaint/newly-composited-repaint-rect.html

        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::updateBacking): When a layer
        becomes newly composited and creates its backing, the repaintRect
        may become invalid. This patch recomputes repaintRects in this
        case.

2012-03-23  Andy Estes  <aestes@apple.com>

        REGRESSION (r105396): Dragging an iWork document into icloud.com opens it in the Mac app instead of uploading it to icloud.com
        https://bugs.webkit.org/show_bug.cgi?id=79443

        Reviewed by Ryosuke Niwa.

        icloud.com registers a drop event handler that sets display:none on the
        file input element receiving the drop. After dispatching the drop event,
        DragController hit tests the position under the mouse to see if it is a
        file input element in need of receiving files. Since the file input
        element has lost its renderer, it cannot be found by hit testing, so
        the dropped file is never attached to the file input element, no change
        event fires, and no upload commences. We want these things to happen
        even if the element is no longer visible.

        Since we already keep track of the file input element under the mouse
        via m_fileInputElementUnderMouse, this additional hit test is
        unnecessary. Use m_fileInputElementUnderMouse in concludeEditDrag()
        when dropping files.

        Test: fast/events/file-input-hidden-in-ondrop.html

        * page/DragController.cpp:
        (WebCore::DragController::concludeEditDrag): Use
        m_fileInputElementUnderMouse instead of the element returned by hit
        testing. Assert that m_fileInputElementUnderMouse equals the hit tested
        element unless m_fileInputElementUnderMouse doesn't have a renderer.

2012-03-23  Mikkel Kruse Johnsen  <mikkel@linet.dk>

        WebKitGtk+ fails to build on win32 against GTK3
        https://bugs.webkit.org/show_bug.cgi?id=63919

        Reviewed by Gustavo Noronha Silva.

        * plugins/gtk/PluginViewGtk.cpp: Don't use gtk_socket_new with GTK3 on Win32
        (WebCore::PluginView::platformStart):

2012-03-23  Dan Bernstein  <mitz@apple.com>

        <rdar://problem/10923294> REGRESSION (r100847): Entries are clipped out in Day One
        https://bugs.webkit.org/show_bug.cgi?id=80494

        Reviewed by Sam Weinig.

        Test: fast/dom/HTMLDocument/width-and-height.html

        * html/HTMLDocument.idl: Reverted r100847 by re-enabling the width and height properties
        in the JavaScript bindings.

2012-03-23  Adele Peterson  <adele@apple.com>

        REGRESSION(r96566): Cursor is I-beam upon dragging an attachment in mail
        https://bugs.webkit.org/show_bug.cgi?id=80458
        <rdar://problem/10873195>

        Reviewed by Dan Bernstein.

        No tests because we currently don't have any test machinery for cursors.

        Make sure the shortcut to always use an iBeam cursor during selection isn't used during dragging.
        Before r96566, we handled plugin cursors as a special case before calling into selectCursor, so we never hit this code path.

        * page/EventHandler.cpp: (WebCore::EventHandler::selectCursor):

2012-03-23  Maciej Stachowiak  <mjs@apple.com>

        REGRESSION(r97353): Crash when accessing location or history properties inside a navigated window
        https://bugs.webkit.org/show_bug.cgi?id=80133
        <rdar://problem/10432233>
        
        Reviewed by Antti Koivisto.

        Test: fast/dom/Window/navigated-window-properties.html

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore): Remove custom getters for window.location and window.history; they
        were unnecessary and did the wrong thing when DOMWindow returned null values 
        for these.
        * page/DOMWindow.idl: ditto
        * bindings/js/JSDOMBinding.cpp:
        (WebCore::reportException): Remove assert about null values and update comment,
        since this is now an expected state for navigated inner windows.

2012-03-23  Ryosuke Niwa  <rniwa@webkit.org>

        REGRESSION(r74971): Can't select a line of RTL text on Facebook
        https://bugs.webkit.org/show_bug.cgi?id=59435

        Reviewed by Eric Seidel.

        The bug was caused by inline text boxes created by BRs being placed at the end of the line
        according to the block's direction regardless of its unicode bidi-level. e.g. if we have
        <div dir="rtl"><span dir="ltr">hello<br>world</span></div>
        the inline box generated by the br has the bidi-level of 2 like the rest of text in the span.
        This inline text box gives an illusion of having text on the left of "hello" to hit testing
        and editing code and causes all sorts of problems.

        Fixed the bug by replacing calls to nextLeafChild and prevLeafChild by newly introduced
        nextLeafChildIgnoringLineBreak and prevLeafChildIgnoringLineBreak. These two functions will
        return 0 when they hit the end of a line or inline text box that's a line break. In effect,
        hit testing and editing code can ignore inline boxes generated by br's.

        In the long term, we should move these two functions into RenderedPosition along with the rest
        of code that converts a Position and an inline box, offset pair.

        Test: editing/selection/select-line-break-with-opposite-directionality.html

        * dom/Position.cpp:
        (WebCore::Position::getInlineBoxAndOffset):
        * editing/RenderedPosition.cpp:
        (WebCore::RenderedPosition::prevLeafChild):
        (WebCore::RenderedPosition::nextLeafChild):
        * rendering/InlineBox.cpp:
        (WebCore::InlineBox::nextLeafChildIgnoringLineBreak):
        (WebCore::InlineBox::prevLeafChildIgnoringLineBreak):
        * rendering/InlineBox.h:
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::positionForPointWithInlineChildren):
        * rendering/RenderText.cpp:
        (WebCore::lineDirectionPointFitsInBox): If we're on the left of a RTL line, we should stay at
        upstream position since we're at the end of a line.
        (WebCore::createVisiblePositionAfterAdjustingOffsetForBiDi): Merge the two special cases into
        the general loop as the comment suggests. Skip an inline text box for a line break at the left
        edge when there are more line boxes on the line.
        (WebCore::RenderText::positionForPoint):
        * rendering/RootInlineBox.cpp:
        (WebCore::RootInlineBox::closestLeafChildForLogicalLeftPosition): Ignore line boxes created for
        line boxes when there are other boxes on the line.

2012-03-23  Antti Koivisto  <antti@apple.com>

        REGRESSION (r104060): Page contents not painted if inserting a new stylesheet and temporary body node
        https://bugs.webkit.org/show_bug.cgi?id=76590

        Reviewed by Maciej Stachowiak.

        Test: fast/css/pending-stylesheet-repaint.html
        
        If there has been a style recalc with a pending stylesheet, the forced repaint will need to be triggered even
        if the stylesheet doesn't affect the rendering. Otherwise we may end up never painting at all.

        * dom/Document.cpp:
        (WebCore::Document::styleSelectorChanged):

2012-03-23  Kent Tamura  <tkent@chromium.org>

        REGRESSION(90089): Input type='search' text shakes up and down when the style is changed.
        https://bugs.webkit.org/show_bug.cgi?id=79445

        Reviewed by Dimitri Glazkov.

        If the inner text height of a search field is smaller than the
        content box height of the <input>, the height of the container
        element should be same as the content box height.

        When the element style is changed, the RenderStyle height of the
        container element is cleared, but the renderer height of the
        container element remains. We had a bug that layout() didn't set
        the RenderStyle height in a case that the renderer height was the
        desired height. It shrunk the renderer height as the result of
        layout for children.

        Tests: fast/forms/search/search-shaking-text.html

        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::layout):
        Always set the RenderStyle height explicitly.

2012-03-23  Kent Tamura  <tkent@chromium.org>

        REGRESSION(r106388): Form state is restored to a wrong document.
        https://bugs.webkit.org/show_bug.cgi?id=79206

        Reviewed by Brady Eidson.

        In some cases, the URL of the current HistoryItem and the document
        URL are mismatched.
        A form state should be restored only if the document was loaded
        with a HistoryItem and the document is not loaded as a
        redirection.

        Test: fast/loader/form-state-restore-with-locked-back-forward-list.html

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::checkCompleted): Clear m_requestedHistoryItem.
        (WebCore::FrameLoader::loadItem):
        Save the requested HistoryItem for didLoadWithLodItem().
        * loader/FrameLoader.h:
        (WebCore::FrameLoader::requestedHistoryItem):
        Added. Accessor for m_requestedHistoryItem.
        * loader/HistoryController.cpp:
        (WebCore::HistoryController::restoreDocumentState):
        Restore a form state only if the current document was loaded with
        FrameLoader::loadItem() and not redirection.

2012-03-23  Abhishek Arya  <inferno@chromium.org>

        Regression(r107477): Crash in StaticNodeList::itemWithName.
        https://bugs.webkit.org/show_bug.cgi?id=79532

        Reviewed by Andreas Kling.

        Make sure that node is an element node before checking its id attribute.

        Test: fast/mutation/mutation-callback-non-element-crash.html

        * dom/StaticNodeList.cpp:
        (WebCore::StaticNodeList::itemWithName):

2012-03-23  Ryosuke Niwa  <rniwa@webkit.org>

        REGRESSION(r99076): WebKit pastes the trailing newline into a single-line text field
        https://bugs.webkit.org/show_bug.cgi?id=79305

        Reviewed by Tony Chang.

        The bug was caused by ReplacementFragment::m_hasInterchangeNewlineAtEnd not reset even when
        text field's beforeTextInserted event handler removed interchange new lines at the end.
        Because the event handler is responsible for trimming new lines, we need to recompute the values
        for m_hasInterchangeNewlineAt* after the event dispatch.

        Test: editing/input/paste-text-ending-with-interchange-newline.html

        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplacementFragment::ReplacementFragment):

2012-03-23  Antti Koivisto  <antti@apple.com>

        REGRESSION (r104060): Web font is not loaded if specified by link element dynamically inserted
        https://bugs.webkit.org/show_bug.cgi?id=79186

        Reviewed by Andreas Kling.

        Test: fast/css/font-face-insert-link.html
        
        If a dynamically inserted stylesheet contains @font-face rules, we may fail to update the rendering.
        
        Before r104060 the style selector was destroyed on every style change, and the font selector along with it.
        This is no longer the case and we can't rely on comparing font selector pointers when comparing Fonts
        for equality. This patch adds version number to the font selector and checks it in Font::operator==.
        The version number is incremented when new font-face rules are added to the font selector.
        
        FontFallbackList is an object shared between Fonts so the extra field shouldn't matter much in terms
        of memory.

        * css/CSSFontSelector.cpp:
        (WebCore::CSSFontSelector::CSSFontSelector):
        (WebCore::CSSFontSelector::addFontFaceRule):
        * css/CSSFontSelector.h:
        (CSSFontSelector):
        * platform/graphics/Font.cpp:
        (WebCore::Font::operator==):
        * platform/graphics/FontFallbackList.cpp:
        (WebCore::FontFallbackList::FontFallbackList):
        (WebCore::FontFallbackList::invalidate):
        * platform/graphics/FontFallbackList.h:
        (FontFallbackList):
        (WebCore::FontFallbackList::fontSelectorVersion):
        * platform/graphics/FontSelector.h:
        (FontSelector):

2012-03-23  Nikolas Zimmermann  <nzimmermann@rim.com>

        REGRESSION(58212): html foreignObjects with positions other than static not hidden correctly when parent has display:none
        https://bugs.webkit.org/show_bug.cgi?id=41386

        Reviewed by Zoltan Herczeg.

        r58212 gave SVGGElements a renderer, regardless if "display: none" was set or not, for various reasons (see change set).
        The <g> renderer for such cases is a RenderSVGHiddenContainer. We make sure in SVG that such subtrees are never used
        for painting & hittesting - they only exist for the purpose of SVG DOM (query getCTM, etc..) and to create renderers
        for child resources, like <g display="none"><linearGradient>.

        This concept still works fine for: <g display="none"><foreignObject><body>Foobar</body></foreignObject></g>, as
        RenderSVGForeignObject::paint is never called thus we never paint the subtree of the <fO>. If the <body> elements
        contains "position: relative" a new layer is created for the <body>. When the document paints we have two seperated
        layers, and the <body> layer doesn't know that it's actually inside a "SVG hidden subtree", and gets painted, where it
        shouldn't. HTML doesn't have this problems, as a display: none object, never creates a renderer.

        The fix is to disallow layer creation in hidden SVG subtrees, to mimic what would happen if we'd follow HTML rules
        to not create renderers for display: none objects. This avoids any indirections - as no layers are created anymore.

        Tests: svg/foreignObject/fO-display-none-with-relative-pos-content.svg
               svg/foreignObject/fO-display-none.svg
               svg/foreignObject/fO-parent-display-changes.svg
               svg/foreignObject/fO-parent-display-none-with-relative-pos-content.svg
               svg/foreignObject/fO-parent-display-none.svg
               svg/foreignObject/fO-parent-of-parent-display-none-with-relative-pos-content.svg
               svg/foreignObject/fO-parent-of-parent-display-none.svg

        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::styleDidChange): Only create layers, if its allowed -- layerCreationAllowedForSubtree() will always return true for HTML, and only false for layers inside a hidden SVG subtree.
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::addChild): Only create layers, if its allowed.
        * rendering/RenderObject.h: Add inline layerCreationAllowedForSubtree() helper, that craws the tree to find a RenderSVGHiddenContainer ancestor, if not present, return true.

2012-03-23  Nikolas Zimmermann  <nzimmermann@rim.com>

        REGRESSION: unbalanced transparency layers for clipPath
        https://bugs.webkit.org/show_bug.cgi?id=78074

        Reviewed by Zoltan Herczeg.

        If we're rendering to a mask image buffer, all children are rendered with opacity=1, regardless what their RenderStyles specify.
        SVGRenderSupport::finishRenderSVGContent() did not take this into account and always called endTransparencyLayer(). Fix that
        by checking if we're rendering to a mask image buffer, if so don't call endTransparencyLayer().

        Add new reftest covering both the visual & logical correctness (no assertion).

        Tests: svg/clip-path/opacity-assertion-expected.svg
               svg/clip-path/opacity-assertion.svg

        * rendering/svg/SVGRenderSupport.cpp:
        (WebCore::isRenderingMaskImage): Extraced as sharable helper function.
        (WebCore::SVGRenderSupport::prepareToRenderSVGContent): Factor out isRenderingMaskImage() function.
        (WebCore::SVGRenderSupport::finishRenderSVGContent): Only call endTransparencyLayer(), if we actually called beginTL() first. 

2012-03-23  Ryosuke Niwa  <rniwa@webkit.org>

        Assertion failure in TextIterator::handleTextBox
        https://bugs.webkit.org/show_bug.cgi?id=78530

        Reviewed by Eric Seidel.

        The assertion failure was caused by handleTextNodeFirstLetter's updating m_text without clearing
        m_sortedTextBoxesPosition. Re-structured handleTextNode so that we always reset m_sortedTextBoxesPosition
        when we have a first-letter.

        Test: editing/text-iterator/rtl-first-letter-text-iterator-crash.html

        * editing/TextIterator.cpp:
        (WebCore::TextIterator::handleTextNode):
        (WebCore::TextIterator::handleTextBox):
        (WebCore::TextIterator::handleTextNodeFirstLetter):

2012-03-19  Martin Robinson  <mrobinson@igalia.com>

        [Cairo] Text extent of shadowed text is calculated incorrectly
        https://bugs.webkit.org/show_bug.cgi?id=65035

        Reviewed by Martin Robinson.

        No new tests. This is already covered by fast/canvas/fillText-shadow.html.

        Correct determine the size of rendered text using x and y bearing from the font
        extents.

        * platform/graphics/cairo/FontCairo.cpp:
        (WebCore::drawGlyphsShadow): Use the x and y bearing to calculate text extents.
        This gives a more accurate sizing and avoids clipping the edges of the shadow.

2012-03-19  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Menulist buttons have separators even when the theme turns them off
        https://bugs.webkit.org/show_bug.cgi?id=80668

        Reviewed by Daniel Bates.

        No new tests. GTK+ theme differences are notoriously difficult
        to test, because consistent results depend on having certain themes
        and certain versions of themes installed.

        Instead of using the GTK_TYPE_BUTTON and GTK_TYPE_SEPARATOR tags to get the
        style context, use GTK_TYPE_COMBO_BOX which should provide more accurate theme settings.

        * platform/gtk/RenderThemeGtk3.cpp:
        (WebCore::getComboBoxMetrics): Get metrics from a GTK_TYPE_COMBO_BOX style context.
        (WebCore::RenderThemeGtk::paintMenuList): Get separator settings from the GTK_TYPE_COMBO_BOX style context.

2012-03-19  Scott Byer  <scottbyer@chromium.org>

        Cleanup obsolete files.
        https://bugs.webkit.org/show_bug.cgi?id=80737

        Reviewed by James Robinson.

        No new code.

        * GNUmakefile.list.am:
        * PlatformWinCE.cmake:
        * Target.pri:
        * WebCore.vcproj/WebCore.vcproj:
        * platform/ScrollAnimatorWin.cpp: Removed.
        * platform/ScrollAnimatorWin.h: Removed.

2012-03-06  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r109760.
        http://trac.webkit.org/changeset/109760
        https://bugs.webkit.org/show_bug.cgi?id=80320

        Caused many GTK+ tests to crash (Requested by mrobinson on
        #webkit).

        * platform/network/ResourceHandleClient.h:
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCoreSynchronousLoader):
        (WebCore::WebCoreSynchronousLoader::WebCoreSynchronousLoader):
        (WebCore):
        (WebCore::WebCoreSynchronousLoader::~WebCoreSynchronousLoader):
        (WebCore::WebCoreSynchronousLoader::didReceiveResponse):
        (WebCore::WebCoreSynchronousLoader::didReceiveData):
        (WebCore::WebCoreSynchronousLoader::didFinishLoading):
        (WebCore::WebCoreSynchronousLoader::didFail):
        (WebCore::WebCoreSynchronousLoader::run):
        (WebCore::closeCallback):
        (WebCore::readCallback):
        (WebCore::ResourceHandle::defaultSession):

2012-03-05  Martin Robinson  <mrobinson@igalia.com>

        [soup] Crash while loading http://www.jusco.cn
        https://bugs.webkit.org/show_bug.cgi?id=68238

        Reviewed by Philippe Normand.

        Test: http/tests/xmlhttprequest/xmlhttprequest-sync-no-timers.html

        When running synchronous XMLHttpRequests, push a new inner thread default
        context, so that other sources from timers and network activity do not run.
        This will make synchronous requests truly synchronous with the rest of
        WebCore.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCoreSynchronousLoader): Clean up the method definitions a bit by writing them inline.
        (WebCore::WebCoreSynchronousLoader::WebCoreSynchronousLoader): Push a new thread default
        context to prevent other sources from running.
        (WebCore::WebCoreSynchronousLoader::~WebCoreSynchronousLoader): Pop the inner thread default context.
        (WebCore::closeCallback): If the client is synchronous call didFinishLoading now.
        (WebCore::readCallback): Only call didFinishLoading if the client isn't synchronous.
        (WebCore::ResourceHandle::defaultSession): Activate use-thread-context so that the soup session
        respects the inner thread context.
        (ResourceHandleClient):
        (WebCore::ResourceHandleClient::isSynchronousClient): Added this virtual method.

2012-03-05  Mario Sanchez Prada  <msanchez@igalia.com>

        [GTK] Add GMainLoop and GMainContext to be handled by GRefPtr
        https://bugs.webkit.org/show_bug.cgi?id=79496

        Reviewed by Martin Robinson.

        Updated places where raw pointers to GMainLoop and GMainContext
        were being used, replacing them with GRefPtr-based code.

        * platform/RunLoop.h:
        (RunLoop):
        * platform/gtk/RunLoopGtk.cpp:
        (WebCore::RunLoop::RunLoop):
        (WebCore::RunLoop::~RunLoop):
        (WebCore::RunLoop::mainLoop):
        (WebCore::RunLoop::stop):
        (WebCore::RunLoop::wakeUp):
        (WebCore::RunLoop::TimerBase::start):
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCoreSynchronousLoader):
        (WebCore::WebCoreSynchronousLoader::WebCoreSynchronousLoader):
        (WebCore::WebCoreSynchronousLoader::~WebCoreSynchronousLoader):
        (WebCore::WebCoreSynchronousLoader::didFinishLoading):
        (WebCore::WebCoreSynchronousLoader::run):

2012-03-05  Philippe Normand  <pnormand@igalia.com>

        [GStreamer] media/media-can-play-flac-audio.html fails
        https://bugs.webkit.org/show_bug.cgi?id=80124

        Reviewed by Martin Robinson.

        Handle audio/x-flac in the mimeTypeCache() function so that we
        advertize both audio/flac and audio/x-flac.

        No new tests, this is covered already by media/media-can-play-flac-audio.html.

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp:

2012-03-05  Pablo Flouret  <pablof@motorola.com>

        Fix code generators to correctly guard header declarations that have a [Conditional] attribute.
        https://bugs.webkit.org/show_bug.cgi?id=79375

        Reviewed by Kentaro Hara.

        In most cases code generators weren't checking the Conditional attribute
        when generating code in headers for function/attribute/constants, they
        were just guarding against the Conditional for the whole interface.

        * bindings/scripts/CodeGeneratorCPP.pm:
        (GenerateHeader):
        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateHeader):
        * bindings/scripts/CodeGeneratorObjC.pm:
        (GenerateHeader):
        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateHeader):
        * bindings/scripts/test/CPP/WebDOMTestInterface.h:
        * bindings/scripts/test/CPP/WebDOMTestObj.h:
        * bindings/scripts/test/JS/JSTestInterface.h:
        (JSTestInterface):
        (WebCore):
        * bindings/scripts/test/JS/JSTestObj.h:
        (WebCore):
        * bindings/scripts/test/ObjC/DOMTestInterface.h:
        * bindings/scripts/test/ObjC/DOMTestObj.h:


2012-02-22  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Clean build is broken when using make -j
        https://bugs.webkit.org/show_bug.cgi?id=76388

        No new tests. This is just a build fix.

        Use order-only dependencies to ensure that built sources are built before
        files that depend on them.

        * GNUmakefile.am: Establish an order-only dependency on some built sources before starting
        to build non-generated sources. Rename some temporary files and variables to be more consistent.
        * bindings/gobject/GNUmakefile.am: Updated to reflect new variable names.

2012-02-20  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Web content oftens steals focus from other widgets
        https://bugs.webkit.org/show_bug.cgi?id=77791

        Reviewed by Gustavo Noronha Silva.

        * platform/gtk/WidgetGtk.cpp:
        (WebCore::Widget::setFocus): No longer do anything special to try
        to grab "real" widget focus. This matches the behavior on Qt.
        * plugins/gtk/PluginViewGtk.cpp:
        (WebCore::PluginView::setFocus): Moved the focus handling to here.
        This ensures that behavior for plugins does not change.

2012-02-20  Martin Robinson  <mrobinson@igalia.com>

        [UNIX] Plugin information fields are not interpreted as UTF-8
        https://bugs.webkit.org/show_bug.cgi?id=78635

        Reviewed by Gustavo Noronha Silva.

        Interpret plugin metadata as UTF8 aways. This matches the behavior
        of Chromium and the Totem plugin.

        This is tested by a change to TestNetscapePlugin and expectations updates.

        * plugins/efl/PluginPackageEfl.cpp:
        (WebCore::PluginPackage::fetchInfo): Use String::fromUTF8.
        * plugins/gtk/PluginPackageGtk.cpp:
        (WebCore::PluginPackage::fetchInfo): Use String::fromUTF8.
        * plugins/qt/PluginPackageQt.cpp:
        (WebCore::PluginPackage::fetchInfo): Use String::fromUTF8.

2012-02-20  Anders Carlsson  <andersca@apple.com>

        Stop the committer timer when the page is destroyed
        https://bugs.webkit.org/show_bug.cgi?id=78907

        Reviewed by Adam Roben.

        We don't want the committer timer to fire after the scrolling tree has been invalidated,
        so stop the committer timer to prevent it from firing and trying to access the scrolling tree.

        * page/scrolling/ScrollingCoordinator.cpp:
        (WebCore::ScrollingCoordinator::pageDestroyed):

2012-02-20  Vsevolod Vlasov  <vsevik@chromium.org>

        Unreviewed manual rollout of r107970 which breaks table column widths
        updates from javascript (e.g. inspector's network panel).

        * rendering/FixedTableLayout.cpp:
        (WebCore::FixedTableLayout::calcWidthArray):
        * rendering/RenderTableCol.h:
        (RenderTableCol):

2012-02-20  Kalev Lember  <kalevlember@gmail.com>

        [GTK] Fix build on platforms where UChar is wchar_t
        https://bugs.webkit.org/show_bug.cgi?id=78996

        Reviewed by Martin Robinson.

        The ICU backend defines UChar as wchar_t for platforms where wchar_t is
        16 bits wide, e.g. win32.

        * platform/graphics/pango/FontPango.cpp:
        (WebCore::utf16ToUtf8): Use reinterpret_cast instead of static_cast.
        * platform/gtk/GtkPopupMenu.cpp:
        (WebCore::GtkPopupMenu::typeAheadFind): Ditto.

2012-02-20  Paweł Forysiuk  <tuxator@o2.pl>

        [GTK] Can't find webinspector and error page redirection on Windows
        https://bugs.webkit.org/show_bug.cgi?id=51616

        Create and use an abstraction for finding shared resources on Windows.

        Reviewed by Martin Robinson.

        * platform/FileSystem.h:
        (WebCore):
        * platform/audio/gtk/AudioBusGtk.cpp:
        (WebCore::AudioBus::loadPlatformResource):
        * platform/graphics/gtk/ImageGtk.cpp:
        (WebCore::getPathToImageResource):
        * platform/gtk/FileSystemGtk.cpp:
        (WebCore::sharedResourcesPath):
        (WebCore):

2012-02-19  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck issues.

        * GNUmakefile.list.am: Add missing header.

2012-02-18  Robert Hogan  <robert@webkit.org>

        CSS 2.1 failure: inline-box-002.htm fails
        https://bugs.webkit.org/show_bug.cgi?id=69210

        Reviewed by David Hyatt.

        Tests: css2.1/20110323/dynamic-top-change-005.htm
               css2.1/20110323/dynamic-top-change-005a.htm
               css2.1/20110323/dynamic-top-change-005b.htm
               css2.1/20110323/inline-box-002.htm
               fast/css/relative-positioned-block-nested-with-inline-parent-dynamic-removed.html
               fast/css/relative-positioned-block-nested-with-inline-parent-dynamic.html
               fast/css/relative-positioned-block-nested-with-inline-parent-multiple-descendant-blocks-dynamic.html
               fast/css/relative-positioned-block-nested-with-inline-parent.html
               fast/css/relative-positioned-block-with-inline-ancestor-and-parent-dynamic.html
               fast/css/relative-positioned-block-with-inline-ancestor-dynamic-removed.html
               fast/css/relative-positioned-block-with-inline-ancestor-dynamic.html
               fast/css/relative-positioned-block-with-inline-ancestor.html
               fast/css/relative-positioned-block-with-inline-parent-dynamic-removed.html
               fast/css/relative-positioned-block-with-inline-parent-dynamic.html
               fast/css/relative-positioned-block-with-inline-parent-keeps-style.html
               fast/css/relative-positioned-block-with-inline-parent.html

        A block within an inline is affected by relative positioning on the inline box. Give
        the anonymous block containing the block a layer and make it relative positioned. Then
        calculate the offset of the anonymous block's layer by accumulating the offsets from its
        inline continuation and the inline continuation's inline parents.
        If the position of an inline changes from or to relative positioned then ensure that any
        descendant blocks update their position and layer accordingly.

        * rendering/RenderBoxModelObject.cpp:
        (): add an enum RelPosAxis
        (WebCore::accumulateRelativePositionOffsets): 
        Total up the offsets of all relatively positioned inlines that are de-facto parents of the relatively 
        positioned anonymous block's child block.

        (WebCore):
        (WebCore::RenderBoxModelObject::relativePositionOffsetX): 
        Use accumulateRelativePositionOffsets when calculating the relative position offset of a relatively positioned anonymous block.

        (WebCore::RenderBoxModelObject::relativePositionOffsetY): ditto

        * rendering/RenderInline.cpp:
        (WebCore::hasRelPositionedInlineAncestor): 
        Detects if the anonymous block contains a block that is the de-facto descendant of a relatively positioned inline.

        (WebCore::updateStyleOfAnonymousBlockContinuations): 
        Update the style's positioning for each anonymous block containing a block that is descendant from the inline whose style has changed.

        (WebCore::RenderInline::styleDidChange): 
        If an inline changes to or from relative positioning ensure that any descendant blocks change to or from relative positioning
        as well, unless they still have a relatively positioned ancestor after the current ancestor loses its relative positioning.

        (WebCore::RenderInline::addChildIgnoringContinuation): 
        If the anonymous block contains a block that is effectively descended from a relatively positioned inline, make it relatively
        positioned so the block will respect its inline ancestor's relative positioning.

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::propagateStyleToAnonymousChildren): 
        Preserve style position in anonymous block continuations when the parent block propagates a style change. 

2012-02-18  raman Tenneti  <rtenneti@chromium.org>

        Track the NPN protocol version negotiated with the server
        https://bugs.webkit.org/show_bug.cgi?id=77349

        Reviewed by Darin Fisher..

        [chromium] Added ExtraData to WebURLResponse.
        
        No intended functionality change.

        * platform/network/chromium/ResourceResponse.h:
        (ExtraData):
        (WebCore::ResourceResponse::ExtraData::~ExtraData):
        (ResourceResponse):
        (WebCore::ResourceResponse::extraData):
        (WebCore::ResourceResponse::setExtraData):

2012-02-18  Abhishek Arya  <inferno@chromium.org>

        Unreviewed, rolling out r107965.
        http://trac.webkit.org/changeset/107965
        https://bugs.webkit.org/show_bug.cgi?id=78273

        crashes

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::clone):

2012-02-18  Sam Weinig  <sam@webkit.org>

        Make WebCore compile with libc++ (Part 2)
        https://bugs.webkit.org/show_bug.cgi?id=78974

        Reviewed by Anders Carlsson.

        * config.h:
        Disable the DisallowCType check when using libc++.

2012-02-18  Sam Weinig  <sam@webkit.org>

        Fix the build.

        * page/DOMWindow.idl:

2012-02-14  Sam Weinig  <sam@webkit.org>

        Make WebCore compile with libc++ (Part 1)
        https://bugs.webkit.org/show_bug.cgi?id=78974

        Reviewed by Anders Carlsson.

        Add a workaround for <rdar://problem/10858112>, which cause the standard heap functions
        not to work when using an iterator with proxy objects for reference and pointer types.

        * WebCorePrefix.h:
        (move):
        Add an overload of std::move that the heap functions can call successfully.

2012-02-18  Kevin Ollivier  <kevino@theolliviers.com>

        [wx] Build fixes for C++ bindings after recent changes.
        
        * bindings/scripts/CodeGeneratorCPP.pm:
        (ShouldSkipType):
        (GenerateHeader):
        * page/DOMWindow.idl:

2012-02-18  Kevin Ollivier  <kevino@theolliviers.com>

        [wx] Build fix, add new platform method wx impl.

        * platform/wx/ContextMenuWx.cpp:
        (ContextMenu::itemCount):

2012-02-18  Sam Weinig  <sam@webkit.org>

        Fix part of the windows build failure.

        * WebCore.vcproj/WebCore.vcproj:
        Don't build JSWebKitCSSRegionRule.cpp, since it is already being built
        as part of DerivedSources.cpp.

2012-02-18  Sam Weinig  <sam@webkit.org>

        Fix the ENABLE(THREADED_SCROLLING) build.

        * page/scrolling/ScrollingCoordinator.cpp:
        (WebCore::ScrollingCoordinator::setNonFastScrollableRegion):
        (WebCore::ScrollingCoordinator::setScrollParameters):

2012-02-18  Andreas Kling  <awesomekling@apple.com>

        HTML: Remove unnecessary attributeChange() overrides.
        <http://webkit.org/b/78890>

        Reviewed by Anders Carlsson.

        Move logic from attributeChanged() overrides into parseAttribute().
        This is a step towards making attributeChanged() non-virtual.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::parseAttribute):
        * html/HTMLMediaElement.h:
        (HTMLMediaElement):
        * html/HTMLScriptElement.cpp:
        (WebCore::HTMLScriptElement::parseAttribute):
        * html/HTMLScriptElement.h:
        (HTMLScriptElement):
        * html/HTMLTrackElement.cpp:
        (WebCore::HTMLTrackElement::parseAttribute):
        * html/HTMLTrackElement.h:
        (HTMLTrackElement):

2012-02-18  Andreas Kling  <awesomekling@apple.com>

        Remove Element::createAttribute().
        <http://webkit.org/b/78965>

        Reviewed by Anders Carlsson.

        Switch call sites to use Attribute::create() directly, as there is no magic
        in calling Element::createAttribute() anymore (it used to be virtual and handled
        differently by StyledElement.)

        * dom/Element.cpp:
        (WebCore::Element::setAttributeInternal):
        * dom/Element.h:
        * svg/properties/SVGAnimatedPropertySynchronizer.h:

2012-02-18  Andreas Kling  <awesomekling@apple.com>

        HTMLBodyElement: Avoid synchronous style recalc when setting link/vlink/alink.
        <http://webkit.org/b/78959>

        Reviewed by Anders Carlsson.

        Mark the body element for deferred style recalc instead of doing it synchronously
        when the attributes change.

        * html/HTMLBodyElement.cpp:
        (WebCore::HTMLBodyElement::parseAttribute):

2012-02-18  Martin Robinson  <mrobinson@igalia.com>

        Fix the TextureMapper build for non-Qt ports. Qt debug builds
        must use RTTI, but GTK+, at least, does not.

        * platform/graphics/texmap/TextureMapperLayer.cpp:
        (WebCore::TextureMapperLayer::updateBackingStore): Make the RTTI check
        Qt only.

2012-02-16  Andreas Kling  <awesomekling@apple.com>

        FontFamilyValue: Utilize inheritance from CSSPrimitiveValue better.
        <http://webkit.org/b/78806>

        Reviewed by Antti Koivisto.

        Now that FontFamilyValue's string doesn't change after creation, we can just
        pass the massaged family name up to the CSSPrimitiveValue constructor and get
        cached cssText() for free. This also shrinks FontFamilyValue by sizeof(String)
        though that's less of an issue now that we cache them in CSSValuePool.

        * css/FontFamilyValue.cpp:
        (WebCore::stripFontFamilyJunk):
        (WebCore::FontFamilyValue::FontFamilyValue):
        * css/FontFamilyValue.h:
        (WebCore::FontFamilyValue::familyName):
        (FontFamilyValue):

2012-02-17  Adam Klein  <adamk@chromium.org>

        Avoid inconsistency in Node::inDocument due to DOMSubtreeModified dispatch
        https://bugs.webkit.org/show_bug.cgi?id=76087

        Reviewed by Ryosuke Niwa.

        Move post-removal notifications after call to Node::removeFromDocument
        to avoid inconsistent state of Node::inDocument() and thus avoid
        inconsistent state in DocumentOrderedMap.

        Tests: fast/dom/getElementById-consistency.html
               fast/dom/getElementById-consistency2.html

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::removeChild):
        * svg/SVGTRefElement.cpp:
        (WebCore::SVGTRefElement::updateReferencedText): Fixed to work with new timing of DOMSubtreeModified dispatch.

2012-02-17  Joshua Bell  <jsbell@chromium.org>

        IndexedDB: Support overloaded methods that take IDBKey or IDBKeyRange
        https://bugs.webkit.org/show_bug.cgi?id=78399

        Implements IDBObjectStore.delete(IDBKeyRange) to exercise the functionality.

        Reviewed by Tony Chang.

        Test: storage/indexeddb/delete-range.html

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateFunctionCallString): Use .get() to disambiguate when passing RefPtr.
        * bindings/scripts/test/V8/V8TestObj.cpp: Update test expectations.
        * storage/IDBLevelDBBackingStore.cpp:
        (WebCore):
        * storage/IDBObjectStore.cpp:
        (WebCore::IDBObjectStore::deleteFunction):
        (WebCore):
        * storage/IDBObjectStore.h:
        (IDBObjectStore):
        * storage/IDBObjectStore.idl:
        * storage/IDBObjectStoreBackendImpl.cpp:
        (WebCore::IDBObjectStoreBackendImpl::deleteFunction):
        (WebCore):
        (WebCore::IDBObjectStoreBackendImpl::deleteInternal):
        * storage/IDBObjectStoreBackendImpl.h:
        (IDBObjectStoreBackendImpl):
        * storage/IDBObjectStoreBackendInterface.h:

2012-02-17  Kentaro Hara  <haraken@chromium.org>

        Replace [V8OnInstance] with [V8Unforgeable]
        https://bugs.webkit.org/show_bug.cgi?id=78894

        Reviewed by Adam Barth.

        [V8OnInstance] means that the method should be defined
        (not on a prototype chain but) on a DOM object. It is the
        same meaning as [V8Unforgeable]. This patch replaces [V8OnInstance]
        with [V8Unforgeable].

        No tests. No change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateImplementation):
        * page/Location.idl:

2012-02-17  James Robinson  <jamesr@chromium.org>

        [chromium] Unreviewed build fix. MSVS gyp generator can't handle multiple .cpps with the same name in the same
        target from different paths.

        * WebCore.gypi:
        * page/scrolling/chromium/ScrollingCoordinatorChromium.cpp: Renamed from Source/WebCore/page/scrolling/chromium/ScrollingCoordinator.cpp.
        (WebCore):
        (WebCore::ScrollingCoordinator::frameViewHorizontalScrollbarLayerDidChange):
        (WebCore::ScrollingCoordinator::frameViewVerticalScrollbarLayerDidChange):
        (WebCore::ScrollingCoordinator::setScrollLayer):
        (WebCore::ScrollingCoordinator::setNonFastScrollableRegion):
        (WebCore::ScrollingCoordinator::setScrollParameters):
        (WebCore::ScrollingCoordinator::setWheelEventHandlerCount):
        (WebCore::ScrollingCoordinator::setShouldUpdateScrollLayerPositionOnMainThread):

2012-02-17  James Robinson  <jamesr@chromium.org>

        Unreviewed mac compile fix pt 2

        * page/scrolling/ScrollingCoordinator.cpp:
        (WebCore::ScrollingCoordinator::frameViewHorizontalScrollbarLayerDidChange):
        (WebCore::ScrollingCoordinator::frameViewVerticalScrollbarLayerDidChange):
        (WebCore::ScrollingCoordinator::setScrollLayer):
        (WebCore::ScrollingCoordinator::setNonFastScrollableRegion):
        (WebCore::ScrollingCoordinator::setScrollParameters):
        (WebCore::ScrollingCoordinator::setWheelEventHandlerCount):
        (WebCore::ScrollingCoordinator::setShouldUpdateScrollLayerPositionOnMainThread):

2012-02-17  James Robinson  <jamesr@chromium.org>

        Unreviewed mac compile fix (unused parameter warning)

        * page/scrolling/ScrollingCoordinator.cpp:
        (WebCore::ScrollingCoordinator::frameViewHorizontalScrollbarLayerDidChange):
        (WebCore::ScrollingCoordinator::frameViewVerticalScrollbarLayerDidChange):

2012-02-14  James Robinson  <jamesr@chromium.org>

        Move ScrollingCoordinator out of ENABLE(THREADED_SCROLLING) ifdef and enable on all platforms
        https://bugs.webkit.org/show_bug.cgi?id=78401

        Reviewed by Adam Barth.

        Separates THREADED_SCROLLING from ScrollingCoordinator and enables ScrollingCoordinator-related code on
        chromium. ScrollingCoordinator receives scrolling information to be used with an external scrolling source.
        ENABLE(THREADED_SCROLLING) enables a codepath that uses a thread in WebCore to handle scrolling related input
        events and interact with composited layers.

        * WebCore.gyp/WebCore.gyp:
        * WebCore.gypi:
        * dom/Document.cpp:
        (WebCore::wheelEventHandlerCountChanged):
        * page/FrameView.cpp:
        (WebCore::FrameView::addSlowRepaintObject):
        (WebCore::FrameView::removeSlowRepaintObject):
        (WebCore::FrameView::performPostLayoutTasks):
        * page/Page.cpp:
        (WebCore::Page::~Page):
        (WebCore):
        * page/Page.h:
        (Page):
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        * page/Settings.h:
        (Settings):
        * page/scrolling/ScrollingCoordinator.cpp:
        (WebCore::ScrollingCoordinator::ScrollingCoordinator):
        (WebCore::ScrollingCoordinator::~ScrollingCoordinator):
        (WebCore::ScrollingCoordinator::pageDestroyed):
        (WebCore):
        * page/scrolling/ScrollingCoordinator.h:
        (WebCore):
        (ScrollingCoordinator):
        * page/scrolling/ScrollingThread.cpp:
        (WebCore::ScrollingThread::createThreadIfNeeded):
        * page/scrolling/ScrollingTreeState.cpp:
        * page/scrolling/ScrollingTreeState.h:
        * page/scrolling/chromium/ScrollingCoordinator.cpp: Added.
        (WebCore):
        (WebCore::ScrollingCoordinator::scheduleTreeStateCommit):
        (WebCore::ScrollingCoordinator::frameViewScrollLayerDidChange):
        (WebCore::ScrollingCoordinator::frameViewHorizontalScrollbarLayerDidChange):
        (WebCore::ScrollingCoordinator::frameViewVerticalScrollbarLayerDidChange):
        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::RenderLayerBacking):
        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::frameViewDidScroll):
        (WebCore::shouldCompositeOverflowControls):
        (WebCore::RenderLayerCompositor::requiresOverhangAreasLayer):
        (WebCore::RenderLayerCompositor::requiresContentShadowLayer):
        (WebCore::RenderLayerCompositor::updateOverflowControlsLayers):
        (WebCore::RenderLayerCompositor::ensureRootLayer):
        (WebCore):
        * rendering/RenderLayerCompositor.h:
        (WebCore):
        (RenderLayerCompositor):

2012-02-17  Emil A Eklund  <eae@chromium.org>

        Add FractionalLayoutPoint for sub-pixel layout
        https://bugs.webkit.org/show_bug.cgi?id=78913

        Reviewed by Eric Seidel.

        Add FractionalLayoutUnit version of Point class and a couple of
        conversion methods to the Int and Float versions of same.

        No new tests.

        * GNUmakefile.list.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/FloatPoint.cpp:
        (WebCore::FloatPoint::FloatPoint):
        (WebCore):
        (WebCore::FloatPoint::moveBy):
        * platform/graphics/FloatPoint.h:
        (WebCore):
        (FloatPoint):
        * platform/graphics/FractionalLayoutPoint.h: Added.
        (WebCore):
        (FractionalLayoutPoint):
        (WebCore::FractionalLayoutPoint::FractionalLayoutPoint):
        (WebCore::FractionalLayoutPoint::zero):
        (WebCore::FractionalLayoutPoint::x):
        (WebCore::FractionalLayoutPoint::y):
        (WebCore::FractionalLayoutPoint::setX):
        (WebCore::FractionalLayoutPoint::setY):
        (WebCore::FractionalLayoutPoint::move):
        (WebCore::FractionalLayoutPoint::moveBy):
        (WebCore::FractionalLayoutPoint::scale):
        (WebCore::FractionalLayoutPoint::expandedTo):
        (WebCore::FractionalLayoutPoint::shrunkTo):
        (WebCore::FractionalLayoutPoint::clampNegativeToZero):
        (WebCore::FractionalLayoutPoint::transposedPoint):
        (WebCore::operator+=):
        (WebCore::operator-=):
        (WebCore::operator+):
        (WebCore::operator-):
        (WebCore::operator==):
        (WebCore::operator!=):
        (WebCore::toPoint):
        (WebCore::toSize):
        (WebCore::flooredIntPoint):
        (WebCore::roundedIntPoint):
        (WebCore::ceiledIntPoint):
        * platform/graphics/FractionalLayoutSize.cpp:
        (WebCore::pixelSnappedIntSize):
        * platform/graphics/FractionalLayoutSize.h:
        (WebCore):

2012-02-17  Ryosuke Niwa  <rniwa@webkit.org>

        Move textDirectionForSelection from Editor to EditingStyle
        https://bugs.webkit.org/show_bug.cgi?id=78868

        Reviewed by Enrica Casucci.

        Move textDirectionForSelection from Editor to EditingStyle to centralize the editing code's
        dependency on CSSStyleDeclaration.

        * editing/EditingStyle.cpp:
        (WebCore::EditingStyle::textDirectionForSelection):
        (WebCore):
        * editing/EditingStyle.h:
        (EditingStyle):
        * editing/Editor.cpp:
        (WebCore):
        * editing/Editor.h:
        (Editor):
        * editing/EditorCommand.cpp:
        (WebCore::stateTextWritingDirection):
        * editing/ReplaceSelectionCommand.cpp:
        * editing/markup.cpp:

2012-02-17  David Barton  <dbarton@mathscribe.com>

        MathML internals - embellished operators, getBase() accessor functions
        https://bugs.webkit.org/show_bug.cgi?id=78617

        Reviewed by Eric Seidel.

        Define functions that return an unembellished "base", by omitting
        subscripts/superscripts, underscripts/overscripts, or denominators. This is needed in
        subsequent patches both for correct operator stretching and simple code factoring.

        No new tests.

        * rendering/mathml/RenderMathMLBlock.h:
        (WebCore):
        (RenderMathMLBlock):
        (WebCore::RenderMathMLBlock::unembellishedOperator):
        * rendering/mathml/RenderMathMLFraction.cpp:
        (WebCore::RenderMathMLFraction::unembellishedOperator):
        (WebCore):
        * rendering/mathml/RenderMathMLFraction.h:
        (RenderMathMLFraction):
        * rendering/mathml/RenderMathMLOperator.h:
        (WebCore::RenderMathMLOperator::unembellishedOperator):
        * rendering/mathml/RenderMathMLSubSup.cpp:
        (WebCore::RenderMathMLSubSup::base):
        (WebCore):
        (WebCore::RenderMathMLSubSup::unembellishedOperator):
        (WebCore::RenderMathMLSubSup::stretchToHeight):
            - renamed a variable for clarity, especially in later patches
        (WebCore::RenderMathMLSubSup::layout):
            - renamed a variable for clarity, especially in later patches
        * rendering/mathml/RenderMathMLSubSup.h:
        (RenderMathMLSubSup):
        * rendering/mathml/RenderMathMLUnderOver.cpp:
        (WebCore::RenderMathMLUnderOver::base):
        (WebCore):
        (WebCore::RenderMathMLUnderOver::unembellishedOperator):
        (WebCore::RenderMathMLUnderOver::stretchToHeight):
        * rendering/mathml/RenderMathMLUnderOver.h:
        (RenderMathMLUnderOver):

2012-02-17  No'am Rosenthal  <noam.rosenthal@nokia.com>

        [Qt][WK2] Allow opaque tiles
        https://bugs.webkit.org/show_bug.cgi?id=78809

        Replace the isOpaque boolean in BitmapTexture to a SupportsAlpha flag.
        Use reset/didReset instead of a virtual function that has to call the superclass.

        Make sure that all calls to BitmapTexture::reset() pass the correct SupportsAlpha flag,
        based on the source image.
        Since we now disable blending for opaque textures, we also have to make sure that we treat
        the depth buffer correctly and bring it back to its previous state.

        Reviewed by Kenneth Rohde Christiansen.

        No behavior changes.

        * platform/graphics/opengl/TextureMapperGL.cpp:
        (TextureMapperGLData):
        (WebCore::TextureMapperGLData::initStencil):
        (WebCore::TextureMapperGLData::TextureMapperGLData):
        (BitmapTextureGL):
        (WebCore::TextureMapperGL::beginPainting):
        (WebCore::TextureMapperGL::endPainting):
        (WebCore::TextureMapperGL::drawTexture):
        (WebCore::BitmapTextureGL::didReset):
        (WebCore::BitmapTextureGL::bind):
        (WebCore::TextureMapperGL::beginClip):
        * platform/graphics/texmap/TextureMapper.h:
        (WebCore::BitmapTexture::BitmapTexture):
        (WebCore::BitmapTexture::flags):
        (WebCore::BitmapTexture::didReset):
        (WebCore::BitmapTexture::reset):
        (BitmapTexture):
        * platform/graphics/texmap/TextureMapperBackingStore.cpp:
        (WebCore::TextureMapperTile::updateContents):
        (WebCore::TextureMapperTiledBackingStore::updateContentsFromImageIfNeeded):
        (WebCore::TextureMapperTiledBackingStore::createOrDestroyTilesIfNeeded):
        (WebCore::TextureMapperTiledBackingStore::updateContents):
        * platform/graphics/texmap/TextureMapperBackingStore.h:
        (TextureMapperTiledBackingStore):
        * platform/graphics/texmap/TextureMapperImageBuffer.cpp:
        (WebCore::BitmapTextureImageBuffer::didReset):
        (WebCore):
        * platform/graphics/texmap/TextureMapperImageBuffer.h:
        (BitmapTextureImageBuffer):

2012-02-17  Stephen Chenney  <schenney@chromium.org>

        Crash in SVGAnimateElement due to changed target
        https://bugs.webkit.org/show_bug.cgi?id=75096

        Reviewed by Nikolas Zimmermann.

        The SVGAnimateElement object creates various internal objects
        depending on the type of property being animated, which depends on the
        target. These objects were not being recreated when the target
        changed, and crashes ensued. Now the SVGSMILElement provides a virtual
        method that is called when the target changes, and SVGAnimateElement
        updates its objects as necessary. We also deactivate the animation
        when the target changes, forcing recomputation of other derived
        objects.

        This change also removes various unnecessary calls to semi-expensive
        methods.

        Not only does this change fix the new test, it also fixes potential
        crashes in other tests that apparently never manifested before (but
        manifest when this new test is included in DRT).

        Test: svg/animations/svglength-animation-retarget-crash.html

        * svg/SVGAnimateElement.cpp:
        (WebCore::SVGAnimateElement::hasValidAttributeType):
        (WebCore::SVGAnimateElement::calculateAnimatedValue):
        (WebCore::SVGAnimateElement::calculateFromAndToValues):
        (WebCore::SVGAnimateElement::calculateFromAndByValues):
        (WebCore::SVGAnimateElement::resetToBaseValue):
        (WebCore::SVGAnimateElement::calculateDistance):
        (WebCore):
        (WebCore::SVGAnimateElement::targetElementDidChange):
        * svg/SVGAnimateElement.h:
        (SVGAnimateElement):
        * svg/SVGAnimatedTypeAnimator.h:
        (SVGAnimatedTypeAnimator):
        (WebCore::SVGAnimatedTypeAnimator::type):
        * svg/animation/SVGSMILElement.cpp:
        (WebCore::SVGSMILElement::targetElement):
        (WebCore::SVGSMILElement::resetTargetElement):
        (WebCore):
        * svg/animation/SVGSMILElement.h:
        (SVGSMILElement):
        (WebCore::SVGSMILElement::targetElementDidChange):

2012-02-17  David Hyatt  <hyatt@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=78934
        
        Add the -webkit-line-align property to support the alignment of lines in the inline direction
        to the line grid.

        Reviewed by Dan Bernstein.

        Added fast/line-grid/line-align-parsing.html

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore):
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue):
        (WebCore):
        (WebCore::CSSPrimitiveValue::operator LineAlign):
        * css/CSSProperty.cpp:
        (WebCore::CSSProperty::isInheritedProperty):
        * css/CSSPropertyNames.in:
        * css/CSSStyleApplyProperty.cpp:
        (WebCore::CSSStyleApplyProperty::CSSStyleApplyProperty):
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyProperty):
        * css/CSSValueKeywords.in:
        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::diff):
        * rendering/style/RenderStyle.h:
        * rendering/style/RenderStyleConstants.h:
        * rendering/style/StyleRareInheritedData.cpp:
        (WebCore::StyleRareInheritedData::StyleRareInheritedData):
        (WebCore::StyleRareInheritedData::operator==):
        * rendering/style/StyleRareInheritedData.h:
        (StyleRareInheritedData):

2012-02-17  Emil A Eklund  <eae@chromium.org>

        Add FractionalLayoutSize for sub-pixel layout
        https://bugs.webkit.org/show_bug.cgi?id=78852

        Reviewed by Eric Seidel.

        Add FractionalLayoutUnit version of Size class and a couple of
        conversion methods to the Int and Float versions of same.

        No new tests.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/FloatPoint.cpp:
        (WebCore::FloatPoint::move):
        Add FractionalLayoutSize version of move.

        * platform/graphics/FloatPoint.h:
        * platform/graphics/FloatSize.cpp:
        (WebCore::FloatSize::FloatSize):
        Add FloatSize(FractionalLayoutSize) constructor.

        * platform/graphics/FloatSize.h:
        * platform/graphics/FractionalLayoutSize.cpp: Added.
        * platform/graphics/FractionalLayoutSize.h: Added.

2012-02-17  Enrica Casucci  <enrica@apple.com>

        REGRESSION (r107606): Copy Link writes malformed WebURLsWithTitlesPboardType
        data to the pasteboard.
        https://bugs.webkit.org/show_bug.cgi?id=78933
        <rdar://problem/10874553>
        
        For this format, the data needs to be placed in the pasteboard as array of arrays
        of strings. Currently is it stored as array of strings, which causes the code
        that uses this format to break.
        
        Reviewed by Ryosuke Niwa.

        * platform/mac/PlatformPasteboardMac.mm:
        (WebCore::PlatformPasteboard::setPathnamesForType):

2012-02-17  Abhishek Arya  <inferno@chromium.org>

        Incorrect placement of a new child when beforeChild and its
        previous sibling are in the same table.
        https://bugs.webkit.org/show_bug.cgi?id=78269

        Reviewed by Julien Chaffraix.

        Tests: fast/table/table-cell-split.html
               fast/table/table-row-split.html
               fast/table/table-section-split-with-after-content.html
               fast/table/table-section-split.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::splitAnonymousBlocksAroundChild): add
        call to splitTablePartsAroundChild to take care of splitting the
        table first if the child is part of table.
        (WebCore::markTableForSectionAndCellRecalculation): add helper to
        mark table for complete relayout by invalidating sections and cells.
        (WebCore):
        (WebCore::moveAllTableChildrenTo): moves children to another table.
        (WebCore::RenderBlock::splitTablePartsAroundChild): split table child
        and its next siblings into a new table. This allows adding a new
        non-table child between the tables.
        (WebCore::RenderBlock::addChildIgnoringAnonymousColumnBlocks): calls
        splitTablePartsAroundChild to see if we need to split the table
        for adding this new child.
        * rendering/RenderBlock.h:
        (RenderBlock):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::createAnonymousTable): add helper for
        creating anonymous table.
        (WebCore):
        (WebCore::RenderObject::addChild): use the new helper for creating
        anonymous table.
        * rendering/RenderObject.h:
        (WebCore):
        (RenderObject):
        (WebCore::RenderObject::isTablePart): add helper to tell if the object
        is a table part.

2012-02-17  Andreas Kling  <awesomekling@apple.com>

        Element: Inline style selector and AX invalidation in attributeChanged().
        <http://webkit.org/b/78888>

        Reviewed by Antti Koivisto.

        Inline the updateAfterAttributeChanged() and recalcStyleIfNeededAfterAttributeChanged()
        methods into Element::attributeChanged(). They were separated when we needed them in
        StyledElement::attributeChanged(), but that's no longer the case.

        * dom/Element.cpp:
        (WebCore::Element::attributeChanged):
        * dom/Element.h:

2012-02-17  David Reveman  <reveman@chromium.org>

        [Chromium] Texture eviction doesn't show up in traces.
        https://bugs.webkit.org/show_bug.cgi?id=78851

        Reviewed by James Robinson.

        Add TextureManager::evictTexture() function with TRACE statement so
        that texture eviction shows up in traces.

        No new tests.

        * platform/graphics/chromium/TextureManager.cpp:
        (WebCore::TextureManager::evictTexture):
        (WebCore):
        (WebCore::TextureManager::reduceMemoryToLimit):
        * platform/graphics/chromium/TextureManager.h:
        (TextureManager):

2012-02-17  Kalev Lember  <kalevlember@gmail.com>

        Remove unused parameters from WTF threading API
        https://bugs.webkit.org/show_bug.cgi?id=78389

        Reviewed by Adam Roben.

        waitForThreadCompletion() had an out param 'void **result' to get the
        'void *' returned by ThreadFunction. However, the implementation in
        ThreadingWin.cpp ignored the out param, not filling it in. This had
        led to a situation where none of the client code made use of the param
        and just ignored it.

        To clean this up, the patch changes the signature of ThreadFunction to
        return void instead of void* and drops the the unused 'void **result'
        parameter from waitForThreadCompletion. Also, all client code is
        updated for the API change.

        As mentioned in https://bugs.webkit.org/show_bug.cgi?id=78389 , even
        though the change only affects internal API, Safari is using it
        directly and we'll need to keep the old versions around for ABI
        compatibility. For this, the patch adds compatibility wrappers with
        the old ABI.

        * bindings/js/GCController.cpp:
        (WebCore::collect):
        (WebCore::GCController::garbageCollectOnAlternateThreadForDebugging):
        * fileapi/FileThread.cpp:
        (WebCore::FileThread::fileThreadStart):
        (WebCore::FileThread::runLoop):
        * fileapi/FileThread.h:
        (FileThread):
        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::close):
        (WebCore::IconDatabase::iconDatabaseSyncThreadStart):
        (WebCore::IconDatabase::iconDatabaseSyncThread):
        (WebCore::IconDatabase::syncThreadMainLoop):
        * loader/icon/IconDatabase.h:
        (IconDatabase):
        * page/scrolling/ScrollingThread.cpp:
        (WebCore::ScrollingThread::threadCallback):
        * page/scrolling/ScrollingThread.h:
        (ScrollingThread):
        * platform/audio/HRTFDatabaseLoader.cpp:
        (WebCore::databaseLoaderEntry):
        (WebCore::HRTFDatabaseLoader::waitForLoaderThreadCompletion):
        * platform/audio/ReverbConvolver.cpp:
        (WebCore::backgroundThreadEntry):
        (WebCore::ReverbConvolver::~ReverbConvolver):
        * platform/network/cf/LoaderRunLoopCF.cpp:
        (WebCore::runLoaderThread):
        * storage/DatabaseThread.cpp:
        (WebCore::DatabaseThread::databaseThreadStart):
        (WebCore::DatabaseThread::databaseThread):
        * storage/DatabaseThread.h:
        (DatabaseThread):
        * storage/LocalStorageThread.cpp:
        (WebCore::LocalStorageThread::threadEntryPointCallback):
        (WebCore::LocalStorageThread::threadEntryPoint):
        (WebCore::LocalStorageThread::terminate):
        * storage/LocalStorageThread.h:
        (LocalStorageThread):
        * webaudio/AsyncAudioDecoder.cpp:
        (WebCore::AsyncAudioDecoder::~AsyncAudioDecoder):
        (WebCore::AsyncAudioDecoder::threadEntry):
        * webaudio/AsyncAudioDecoder.h:
        (AsyncAudioDecoder):
        * webaudio/OfflineAudioDestinationNode.cpp:
        (WebCore::OfflineAudioDestinationNode::uninitialize):
        (WebCore::OfflineAudioDestinationNode::renderEntry):
        * webaudio/OfflineAudioDestinationNode.h:
        (OfflineAudioDestinationNode):
        * workers/WorkerThread.cpp:
        (WebCore::WorkerThread::workerThreadStart):
        (WebCore::WorkerThread::workerThread):
        * workers/WorkerThread.h:
        (WorkerThread):

2012-02-17  Robert Hogan  <robert@webkit.org>

        AppleMac Build fix for r108111

        Remove variable that is now unused.

        Unreviewed, build fix.

        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::alwaysRequiresLineBox): Remove lineInfo
        (WebCore::requiresLineBox): 
        (WebCore::RenderBlock::LineBreaker::nextLineBreak):

2012-02-17  Michal Mocny  <mmocny@google.com>

        [chromium] GL_CHROMIUM_gpu_memory_manager extension
        https://bugs.webkit.org/show_bug.cgi?id=77155

        Reviewed by James Robinson.

        * platform/graphics/chromium/Extensions3DChromium.h:
        (GpuMemoryAllocationChangedCallbackCHROMIUM):
        (WebCore::Extensions3DChromium::GpuMemoryAllocationChangedCallbackCHROMIUM::~GpuMemoryAllocationChangedCallbackCHROMIUM):
        (Extensions3DChromium):

2012-01-23  Robert Hogan  <robert@webkit.org>

        REGRESSION: empty span creates renders with non-zero height
        https://bugs.webkit.org/show_bug.cgi?id=76465

        Reviewed by David Hyatt.

        Tests: fast/css/empty-span.html
               fast/css/non-empty-span.html

        Empty inlines with line-height, vertical-alignment or font metrics should only get a linebox if there is some
        other content in the line. So only create line boxes for such elements on lines that are not empty.

        This patch fixes a regression where an empty inline with line-height was propagating its height to an empty line.
        It also fixes cases where lines with content that had a leading empty inline element weren't respecting the 
        vertical alignment or font-height of the empty inline.

        * rendering/RenderBlockLineLayout.cpp:
        (WebCore::RenderBlock::constructLine): only create line boxes for lines that are not empty.
        (WebCore::requiresLineBoxForContent): an inline flow with line-height, vertical-alignment, or font-size
         will need a linebox if the rest of the line is not empty.
        (WebCore):
        (WebCore::alwaysRequiresLineBox): rename from inlineFlowRequiresLineBox.
        (WebCore::requiresLineBox):
        (WebCore::RenderBlock::LineBreaker::nextLineBreak): if the inline flow definitely requires a line, mark
         the line non-empty - otherwise hold off.

2012-02-17  Raymond Toy  <rtoy@google.com>

        RealtimeAnalyserNode does not consistently respect .minDecibels
        https://bugs.webkit.org/show_bug.cgi?id=78729

        Make use of m_minDecibel consistent.  Clean up some style issues
        with names of local variables and style issues with float
        constants.
        
        Reviewed by Chris Rogers.

        No new tests because the changes are cosmetic for style issues.

        * webaudio/RealtimeAnalyser.cpp:
        (WebCore):
        (WebCore::RealtimeAnalyser::doFFTAnalysis):
        (WebCore::RealtimeAnalyser::getFloatFrequencyData):
        (WebCore::RealtimeAnalyser::getByteFrequencyData):
        (WebCore::RealtimeAnalyser::getByteTimeDomainData):

2012-02-17  Abhishek Arya  <inferno@chromium.org>

        :before content incorrectly placed in continuation
        when we don't have a first child.
        https://bugs.webkit.org/show_bug.cgi?id=78380

        Reviewed by David Hyatt.

        Test: fast/css-generated-content/before-content-continuation-chain.html

        * rendering/RenderObjectChildList.cpp:
        (WebCore::RenderObjectChildList::updateBeforeAfterContent):

2012-02-17  Mihnea Ovidenie  <mihnea@adobe.com>

        CSS regions enabled by default
        https://bugs.webkit.org/show_bug.cgi?id=78525

        Reviewed by David Hyatt.

        Test: fast/regions/css-regions-disabled.html

        Add a runtime preference to enable/disable regions functionality at runtime(WebKitCSSRegionsEnabled).
        CSSRegions are still enabled by default.
        In DRT, use layoutTestController.overridePreference("WebKitCSSRegionsEnabled", "0") to disable the css regions functionality.

        * WebCore.xcodeproj/project.pbxproj:
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        (WebCore::CSSParser::cssRegionsEnabled):
        (WebCore):
        (WebCore::CSSParser::parseFlowThread):
        (WebCore::CSSParser::parseRegionThread):
        (WebCore::CSSParser::createRegionRule):
        * css/CSSParser.h:
        * dom/Document.cpp:
        (WebCore::Document::cssRegionsEnabled):
        (WebCore):
        (WebCore::Document::webkitGetFlowByName):
        * dom/Document.h:
        (Document):
        * dom/Element.cpp:
        (WebCore::Element::webkitRegionOverflow):
        * dom/NodeRenderingContext.cpp:
        (WebCore::NodeRenderingContext::moveToFlowThreadIfNeeded):
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        * page/Settings.h:
        (WebCore::Settings::setCSSRegionsEnabled):
        (WebCore::Settings::cssRegionsEnabled):
        (Settings):
        * rendering/RenderFlowThread.cpp:
        (WebCore::RenderFlowThread::RenderFlowThread):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::createObject):
        * rendering/RenderRegion.cpp:
        (WebCore::RenderRegion::RenderRegion):

2012-02-17  Mihnea Ovidenie  <mihnea@adobe.com>

        [CSSRegions]Implement NamedFlow::overflow
        https://bugs.webkit.org/show_bug.cgi?id=78880

        Reviewed by David Hyatt.

        Test: fast/regions/webkit-named-flow-overflow.html

        * dom/WebKitNamedFlow.cpp:
        (WebCore::WebKitNamedFlow::WebKitNamedFlow):
        (WebCore::WebKitNamedFlow::overflow):
        (WebCore):
        * dom/WebKitNamedFlow.h:
        (WebCore):
        (WebCore::WebKitNamedFlow::create):
        (WebKitNamedFlow):
        * dom/WebKitNamedFlow.idl:
        * rendering/RenderFlowThread.cpp:
        (WebCore::RenderFlowThread::RenderFlowThread):
        (WebCore::RenderFlowThread::ensureNamedFlow):
        (WebCore::RenderFlowThread::computeOverflowStateForRegions):
        * rendering/RenderFlowThread.h:

2012-02-17  Joe Thomas  <joethomas@motorola.com>

        flex-wrap:nowrap should be flex-wrap:none
        https://bugs.webkit.org/show_bug.cgi?id=78772

        As per the spec http://dev.w3.org/csswg/css3-flexbox/#flex-wrap0, flex-wrap:nowrap should be changed to flex-wrap:none.

        Reviewed by Ojan Vafai.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue):
        (WebCore::CSSPrimitiveValue::operator EFlexWrap):
        * css/CSSValueKeywords.in:
        * rendering/style/RenderStyle.h:
        * rendering/style/RenderStyleConstants.h:

2012-02-17  Enrica Casucci  <enrica@apple.com>

        Refactor DragData class to use PlatformStrategies in the Mac implementation.
        https://bugs.webkit.org/show_bug.cgi?id=78768

        Reviewed by Darin Adler.

        No new tests. No behavior change.

        * WebCore.exp.in: Added new exported method of the PlatformPasteboard class.
        * platform/DragData.h:
        (WebCore::DragData::pasteboardName): Added pasteboardName and removed pasteboard.
        * platform/PasteboardStrategy.h: Added color() method.
        * platform/PlatformPasteboard.h: Ditto.
        * platform/mac/ClipboardMac.mm:
        (WebCore::Clipboard::create): Changed to use pasteboardName() method.
        * platform/mac/DragDataMac.mm: All the methods below have been changed to use pasteboardName
        and the pasteboardStrategy() methods.
        (WebCore::DragData::DragData):
        (WebCore::DragData::canSmartReplace):
        (WebCore::DragData::containsColor):
        (WebCore::DragData::containsFiles):
        (WebCore::DragData::numberOfFiles):
        (WebCore::DragData::asFilenames):
        (WebCore::DragData::containsPlainText):
        (WebCore::DragData::asPlainText):
        (WebCore::DragData::asColor):
        (WebCore::DragData::containsCompatibleContent):
        (WebCore::DragData::asURL):
        (WebCore::DragData::asFragment):
        * platform/mac/PlatformPasteboardMac.mm:
        (WebCore::PlatformPasteboard::color): Added implementation of the color() method.

2012-02-17  Nate Chapin  <japhet@chromium.org>

        [Chromium mac] Cursors and background images disappear.
        https://bugs.webkit.org/show_bug.cgi?id=78834

        The issue occurs because a CachedImage sees that it has no clients
        and decide it is safe to purge its m_data buffer. However,
        StyleCachedImage is holding a CachedResourceHandle to the
        CachedImage, and it can still add a client later. If it does so,
        the CachedImage says everything is loaded but has no data.

        Reviewed by Adam Barth.

        No new tests, since the known repros have resisted reduction.
        Tested manually with chrome.angrybirds.com, redfin.com and a
        couple of other sites.

        * rendering/style/StyleCachedImage.cpp:
        * rendering/style/StyleCachedImage.h: Ensure the underlying
            CachedImage has a client for the lifetime of the
            StyleCachedImage and doesn't purge its buffer. Call
            addClient(this) in the constructor and removeClient(this) in
            the destructor, then ignore all cache callbacks.

2012-02-17  Julien Chaffraix  <jchaffraix@webkit.org>

        Table cell's anonymous wrappers are left in the tree, impacting our layout
        https://bugs.webkit.org/show_bug.cgi?id=7180

        Reviewed by David Hyatt.

        Tests: fast/table/table-switch-cell-position-bad-layout-expected.html
               fast/table/table-switch-cell-position-bad-layout.html

        This patch implements cell's anonymous wrapper removal at detach time.

        Trimming the render tree when we remove objects from it would be more complex
        to generalize as several objects override the behavior to do their own clean-ups.
        This would also open more potential for programming errors.

        This change is limited to table cells' as a simple step towards fixing bug 52123
        and more generally eliminate some anonymous wrappers from the tree at detach time.

        * dom/Node.cpp:
        (WebCore::Node::detach):
        Patched detach to call destroyAndCleanupAnonymousWrappers. The Document does not need
        to clean up any anonymous wrappers on detach.

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::destroyAndCleanupAnonymousWrappers):
        Added this method to wrap destroy() call and trim the render tree. To avoid slowing down
        detach in some cases, added a fast path.

        * rendering/RenderObject.h: Added destroyAndCleanupAnonymousWrappers.

2012-02-17  Rob Buis  <rbuis@rim.com>

        ASSERT (and crash) with dynamically moved <font-face>
        https://bugs.webkit.org/show_bug.cgi?id=64839

        Reviewed by Antti Koivisto.

        Reset the style declaration when rmeoving the font-face element from the document.

        Test: svg/custom/font-face-move.svg

        * svg/SVGFontFaceElement.cpp:
        (WebCore::SVGFontFaceElement::removedFromDocument):

2012-02-17  Martin Robinson  <mrobinson@igalia.com>

        Fix some warnings encountered during the GTK+ build
        https://bugs.webkit.org/show_bug.cgi?id=78911

        Reviewed by Xan Lopez.

        No new tests. These are just fixes for warnings.

        * page/GestureTapHighlighter.cpp: Avoid using potentially signed operations on
        a size_t type. Use size_t for iterating over members of a vector.
        * platform/graphics/texmap/TextureMapperBackingStore.cpp: Use size_t where necessary.
        (WebCore::TextureMapperTiledBackingStore::createOrDestroyTilesIfNeeded): Ditto.
        * platform/graphics/texmap/TextureMapperLayer.cpp: Ditto.
        (WebCore::TextureMapperLayer::computeTransformsRecursive): Ditto.
        (WebCore::TextureMapperLayer::paintSelfAndChildren): Ditto.
        (WebCore::TextureMapperLayer::intermediateSurfaceRect): Ditto.

2012-02-17  Tim Dresser  <tdresser@chromium.org>

        [chromium] Refactor video drawing to be more data driven
        https://bugs.webkit.org/show_bug.cgi?id=76720

        Reviewed by James Robinson.

        CCVideoLayerImpl no longer handles drawing itself, but produces a list of CCVideoDrawQuads.
        These quads are then drawn by LayerRendererChromium.

        CCLayerImpl::willDraw(LayerRendererChromium*) is called directly before appendQuads.
        CCLayerImpl::didDraw() is called directly after all drawing has been completed.
        CCLayerImpl::draw has been removed.

        willDraw and didDraw are used to handle interaction with the VideoFrameProvider
        in CCVideoLayerImpl. willDraw gets a frame from the VideoFrameProvider, and
        didDraw returns it.

        A unit test has been added: CCLayerTreeHostImplTest.didDrawCalledOnAllLayers.
        This test ensures that CCLayerImpl::didDraw() is called on all layers,
        including layers on different render surfaces.

        As this was a refactor, no other tests were added.

        * platform/graphics/chromium/LayerRendererChromium.cpp:
        (WebCore::LayerRendererChromium::drawYUV):
        (WebCore):
        (WebCore::LayerRendererChromium::drawSingleTextureVideoQuad):
        (WebCore::LayerRendererChromium::drawRGBA):
        (WebCore::LayerRendererChromium::drawNativeTexture):
        (WebCore::LayerRendererChromium::copyFrameToTextures):
        (WebCore::LayerRendererChromium::copyPlaneToTexture):
        (WebCore::LayerRendererChromium::drawVideoQuad):
        * platform/graphics/chromium/LayerRendererChromium.h:
        (LayerRendererChromium):
        * platform/graphics/chromium/cc/CCLayerImpl.cpp:
        * platform/graphics/chromium/cc/CCLayerImpl.h:
        (WebCore::CCLayerImpl::didDraw):
        (CCLayerImpl):
        * platform/graphics/chromium/cc/CCLayerTreeHostImpl.cpp:
        (WebCore::CCLayerTreeHostImpl::calculateRenderPasses):
        (WebCore::CCLayerTreeHostImpl::drawLayers):
        * platform/graphics/chromium/cc/CCLayerTreeHostImpl.h:
        (CCLayerTreeHostImpl):
        * platform/graphics/chromium/cc/CCVideoDrawQuad.cpp:
        (WebCore::CCVideoDrawQuad::create):
        (WebCore::CCVideoDrawQuad::CCVideoDrawQuad):
        * platform/graphics/chromium/cc/CCVideoDrawQuad.h:
        (CCVideoDrawQuad):
        (WebCore::CCVideoDrawQuad::textures):
        (WebCore::CCVideoDrawQuad::frame):
        (WebCore::CCVideoDrawQuad::format):
        * platform/graphics/chromium/cc/CCVideoLayerImpl.cpp:
        (WebCore::CCVideoLayerImpl::willDraw):
        (WebCore::CCVideoLayerImpl::appendQuads):
        (WebCore::CCVideoLayerImpl::didDraw):
        (WebCore::CCVideoLayerImpl::computeVisibleSize):
        * platform/graphics/chromium/cc/CCVideoLayerImpl.h:
        (CCVideoLayerImpl):
        (WebCore::CCVideoLayerImpl::providerMutex):
        (WebCore::CCVideoLayerImpl::provider):
        (Texture):

2012-02-17  Stephen Chenney  <schenney@chromium.org>

        Crash at WebCore::SVGUseElement::expandSymbolElementsInShadowTree
        https://bugs.webkit.org/show_bug.cgi?id=77639

        Reviewed by Nikolas Zimmermann.

        Fix a SVG crash in Release builds, although it still crashes in Debug builds.
        The crash occurred when an SVG use element attempted to reference a style element while the file
        contained an error causing the error banner to display. The fix is to prevent SVGUseElement
        from recalculating style during tree building and return immediately when style is recalculated and
        the tree is building.

        Test: svg/custom/use-referencing-style-crash.svg

        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::willRecalcStyle): Return false if the tree is being built.
        (WebCore::SVGUseElement::didRecalcStyle): Check and return if the tree
        is being built and we are not yet ready for style update.

2012-02-17  Ilya Tikhonovsky  <loislo@chromium.org>

        Unreviewed, rolling out r108077.
        http://trac.webkit.org/changeset/108077
        https://bugs.webkit.org/show_bug.cgi?id=78390

        it broke compilation.

        * inspector/CodeGeneratorInspector.py:
        * inspector/InjectedScript.cpp:
        (WebCore::InjectedScript::evaluateOnCallFrame):
        (WebCore::InjectedScript::getFunctionDetails):
        (WebCore::InjectedScript::getProperties):
        (WebCore::InjectedScript::wrapCallFrames):
        * inspector/InjectedScript.h:
        (InjectedScript):
        * inspector/InspectorDebuggerAgent.cpp:
        (WebCore::InspectorDebuggerAgent::setBreakpointByUrl):
        (WebCore::InspectorDebuggerAgent::resolveBreakpoint):
        (WebCore::InspectorDebuggerAgent::getFunctionDetails):
        (WebCore::InspectorDebuggerAgent::evaluateOnCallFrame):
        (WebCore::InspectorDebuggerAgent::currentCallFrames):
        (WebCore::InspectorDebuggerAgent::didParseSource):
        * inspector/InspectorDebuggerAgent.h:
        (InspectorDebuggerAgent):

2012-02-17  Florin Malita  <fmalita@google.com>

        chrome.dll!WebCore::SVGTRefElement::updateReferencedText ReadAV@NULL (e85cb8e140071fa7790cad215b0109dc)
        https://bugs.webkit.org/show_bug.cgi?id=74858

        Reviewed by Nikolas Zimmermann.

        Tests: svg/custom/tref-remove-target-crash-expected.svg
               svg/custom/tref-remove-target-crash.svg

        Add a DOMNodeRemovedFromDocumentEvent listener to detect when the target element is removed. Upon removal,
        cleanup all listeners and re-activate the pending resource to attach if the referenced ID is added
        at a later time programmatically. Also move the DOMSubtreeModifiedEvent listener from the parent to
        the target element to simplify the implementation and reduce the scope.

        * svg/SVGTRefElement.cpp:
        (WebCore::TargetListener::create):
        (WebCore::TargetListener::cast):
        (WebCore::TargetListener::clear):
        (WebCore::TargetListener::TargetListener):
        (WebCore::TargetListener::operator==):
        (WebCore::TargetListener::handleEvent):
        (WebCore::SVGTRefElement::detachTarget):
        (WebCore::SVGTRefElement::buildPendingResource):
        * svg/SVGTRefElement.h:

2012-02-17  Simon Fraser  <simon.fraser@apple.com>

        Fix the build after r108077.

        * inspector/CodeGeneratorInspector.py:
        (RawTypes.Any.generate_validate_method):

2012-02-17  Simon Fraser  <simon.fraser@apple.com>

        Avoid using a transparency layer for rgba() border drawing when possible
        https://bugs.webkit.org/show_bug.cgi?id=63176

        Reviewed by Dan Bernstein.
        
        The non-radiused border drawing code would use a transparency layer
        when drawing any one or more borders with alpha colors. However,
        we only need to use a transparency layer when there is a corner
        join between the borders being rendered with any one color,
        so add a utility function includesAdjacentEdges() that can tell us
        that, and use it to avoid making extraneous transparency layers.

        Optimization only, no new tests.

        * rendering/RenderBoxModelObject.cpp:
        (WebCore::includesAdjacentEdges):
        (WebCore):
        (WebCore::RenderBoxModelObject::paintTranslucentBorderSides):

2012-02-17  Pavel Feldman  <pfeldman@google.com>

        Not reviewed: Qt minimal build fix.

        * inspector/InjectedScript.h:
        (WebCore):

2012-02-17  Peter Rybin  <peter.rybin@gmail.com>

        Web Inspector: Switch Debugger agent to TypeBuilder
        https://bugs.webkit.org/show_bug.cgi?id=78390

        Reviewed by Vsevolod Vlasov.

        Client code is switched to TypeBuilder.

        * inspector/CodeGeneratorInspector.py:
        * inspector/InjectedScript.cpp:
        (WebCore::InjectedScript::evaluateOnCallFrame):
        (WebCore::InjectedScript::getFunctionDetails):
        (WebCore::InjectedScript::getProperties):
        (WebCore::InjectedScript::wrapCallFrames):
        * inspector/InjectedScript.h:
        (InjectedScript):
        * inspector/InspectorDebuggerAgent.cpp:
        (WebCore::InspectorDebuggerAgent::setBreakpointByUrl):
        (WebCore::InspectorDebuggerAgent::resolveBreakpoint):
        (WebCore::InspectorDebuggerAgent::getFunctionDetails):
        (WebCore::InspectorDebuggerAgent::evaluateOnCallFrame):
        (WebCore::InspectorDebuggerAgent::currentCallFrames):
        (WebCore::InspectorDebuggerAgent::didParseSource):
        * inspector/InspectorDebuggerAgent.h:
        (InspectorDebuggerAgent):

2012-02-17  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: hide color picker on selected node update.
        https://bugs.webkit.org/show_bug.cgi?id=78896

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/Spectrum.js:
        (WebInspector.Spectrum.prototype.get visible):
        (WebInspector.Spectrum.prototype.toggle):
        (WebInspector.Spectrum.prototype.show):
        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylesSidebarPane.prototype.update):
        (WebInspector.StylePropertyTreeElement.prototype.updateTitle.):

2012-02-17  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: check undo-redo boundaries based on current action index, not history size.
        https://bugs.webkit.org/show_bug.cgi?id=78895

        Reviewed by Vsevolod Vlasov.

        Tests: inspector/elements/perform-undo-undo.html
               inspector/styles/perform-undo-perform-of-mergable-action.html

        * inspector/InspectorHistory.cpp:
        (WebCore::InspectorHistory::perform):

2012-02-17  Ilya Tikhonovsky  <loislo@chromium.org>

        Unreviewed, rolling out r108071.
        http://trac.webkit.org/changeset/108071
        https://bugs.webkit.org/show_bug.cgi?id=77155

        chromium-mac compilation failed

        * platform/graphics/chromium/Extensions3DChromium.h:

2012-02-17  Michal Mocny  <mmocny@google.com>

        [chromium] GL_CHROMIUM_gpu_memory_manager extension
        https://bugs.webkit.org/show_bug.cgi?id=77155

        Reviewed by James Robinson.

        * platform/graphics/chromium/Extensions3DChromium.h:
        (GpuMemoryAllocationChangedCallbackCHROMIUM):
        (WebCore::Extensions3DChromium::GpuMemoryAllocationChangedCallbackCHROMIUM::~GpuMemoryAllocationChangedCallbackCHROMIUM):
        (Extensions3DChromium):

2012-02-17  Raphael Kubo da Costa  <kubo@profusion.mobi>

        [CMake, EFL] Unreviewed, fix the build when building with
        SHARED_CORE=ON after r107820.

        RunLoopEfl.cpp has not been upstreamed yet, and building only
        RunLoop.cpp created an .so with some missing, unimplemented
        symbols. The BlackBerry port seems to be in the same situation.

        The best solution for now is to build RunLoop.cpp only on the
        WinCE port.

        * CMakeLists.txt: Remove RunLoop.cpp from the list of files to build.
        * PlatformWinCE.cmake: Add RunLoop.cpp to the list of files to build.

2012-02-17  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: a bit of color picker polish
        https://bugs.webkit.org/show_bug.cgi?id=78892

        - Fixed computed style swatch
        - Removed color: caption
        - Rendered value as source code, user-selectable
        - Removed scroller gap

        Reviewed by Yury Semikhatsky.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/Popover.js:
        (WebInspector.Popover.prototype.setCanShrink):
        (WebInspector.Popover.prototype._positionElement):
        * inspector/front-end/Spectrum.js:
        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertyTreeElement.prototype._resetMouseDownElement):
        (WebInspector.StylePropertyTreeElement.prototype.updateTitle.):
        * inspector/front-end/elementsPanel.css:
        (.spectrum-container):
        (.spectrum-display-value):
        (.spectrum-range-container):
        * inspector/front-end/popover.css:
        (.popover .content.fixed-height):

2012-02-17  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: color picker does not allow changing the color.
        https://bugs.webkit.org/show_bug.cgi?id=78886

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/ElementsPanel.js:
        (WebInspector.ElementsPanel.prototype._showPopover.showPopover):
        * inspector/front-end/Popover.js:
        (WebInspector.Popover.prototype.setCanShrink):
        (WebInspector.Popover.prototype._positionElement):
        * inspector/front-end/Settings.js:
        * inspector/front-end/Spectrum.js:
        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylesSidebarPane):
        (WebInspector.StylePropertyTreeElement.prototype.updateTitle.):

2012-02-17  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: new image preview has poorly positioned popover arrow.
        https://bugs.webkit.org/show_bug.cgi?id=78884

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/Popover.js:
        (WebInspector.Popover.prototype._positionElement):
        * inspector/front-end/utilities.js:
        (Element.prototype.boxInWindow):

2012-02-17  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: enable "Single click CSS editing" experiment by default.
        https://bugs.webkit.org/show_bug.cgi?id=78881

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/elementsPanel.css:
        (.styles-section .properties .enabled-button):

2012-02-17  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: split innerUpdate into rebuildUpdate and refreshUpdate, make computed styles load lazily.
        https://bugs.webkit.org/show_bug.cgi?id=78827

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylesSidebarPane.prototype.update):
        (WebInspector.StylesSidebarPane.prototype._refreshUpdate.computedStyleCallback):
        (WebInspector.StylesSidebarPane.prototype._refreshUpdate):
        (WebInspector.StylesSidebarPane.prototype._rebuildUpdate):
        (WebInspector.StylesSidebarPane.prototype._validateNode):
        (WebInspector.StylesSidebarPane.prototype._styleSheetOrMediaQueryResultChanged):
        (WebInspector.StylesSidebarPane.prototype._attributesModified):
        (WebInspector.StylesSidebarPane.prototype._attributesRemoved):
        (WebInspector.StylesSidebarPane.prototype._styleInvalidated):
        (WebInspector.StylesSidebarPane.prototype._innerRefreshUpdate):
        (WebInspector.StylesSidebarPane.prototype._innerRebuildUpdate):
        (WebInspector.StylesSidebarPane.prototype._nodeStylesUpdatedForTest):
        (WebInspector.StylesSidebarPane.prototype._toggleElementStatePane):
        (WebInspector.StylesSidebarPane.prototype._createElementStatePane.clickListener):
        (WebInspector.StylesSidebarPane.prototype._showUserAgentStylesSettingChanged):
        (WebInspector.ComputedStyleSidebarPane.prototype.expand):
        (WebInspector.StylePropertyTreeElement.prototype):

2012-02-17  No'am Rosenthal  <noam.rosenthal@nokia.com>

        [Qt][WK2] Allow partial updates
        https://bugs.webkit.org/show_bug.cgi?id=78824

        BitmapTextureGL should not zero-fill the textures when resetting.
        This was needed in the previous buffer management system, where texture were not completely
        filled by the backing store.

        Reviewed by Simon Hausmann.

        No new behavior.

        * platform/graphics/opengl/TextureMapperGL.cpp:
        (BitmapTextureGL):
        (WebCore::texSubImage2DResourceSafe):
        (WebCore):
        (WebCore::BitmapTextureGL::reset):

2012-02-17  Yosifumi Inoue  <yosin@chromium.org>

        [Forms] Integrate InputType::dispatchChangeEventInResponseToSetValue into InputType::setValue
        https://bugs.webkit.org/show_bug.cgi?id=78873

        Reviewed by Kent Tamura.

        This patch moves event dispatch logic to InputType and TextFieldInputType from HTMLInputElement
        and merge dispatchChangeEventInResponseToSetValue to setValue.

        No new tests. No change in behavior.

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::setValue): Move dispatch logic to InputType and TextFieldInput.
        * html/InputType.cpp: Remove dispatchChangeEventInResponseToSetValue implementation.
        * html/InputType.h: Remove dispatchChangeEventInResponseToSetValue declaration.
        (WebCore::InputType::setValue): Move code from dispatchChangeEventInResponseToSetValue.
        * html/TextFieldInputType.cpp: Remove dispatchChangeEventInResponseToSetValue implementation.
        * html/TextFieldInputType.h: Remove dispatchChangeEventInResponseToSetValue declaration.
        (WebCore::TextFieldInputType::setValue): Move code from dispatchChangeEventInResponseToSetValue. Stop dispatching event in InputType::setValue.
        * html/HTMLTextFormControlElement.h: Make setTextAsOfLastFormControlChangeEvent to public from protected for accessing from InputType class.

2012-02-17  Yury Semikhatsky  <yurys@chromium.org>

        Unreviewed. Mac build fix after r108047.

        * WebCore.xcodeproj/project.pbxproj:

2012-02-16  Andreas Kling  <awesomekling@apple.com>

        Removing the last presentation attribute should result in a null attributeStyle().
        <http://webkit.org/b/78812>

        Reviewed by Antti Koivisto.

        If the collectStyleForAttribute() pass in updateAttributeStyle() doesn't encounter any
        respected presentation attributes, set a null attributeStyle() instead of an empty one.

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::collectMatchingRulesForList):
        * dom/StyledElement.cpp:
        (WebCore::StyledElement::updateAttributeStyle):

2012-02-16  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: use static counters for estimation of allocated Documents, Nodes and JS EventListeners
        https://bugs.webkit.org/show_bug.cgi?id=78825

        Introduced static counters of allocated Documents, Nodes and JS EventListeners.
        Their values are displayed on the Timeline panel.

        Reviewed by Pavel Feldman.

        * CMakeLists.txt:
        * English.lproj/localizedStrings.js:
        * GNUmakefile.list.am:
        * Target.pri:
        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSEventListener.cpp:
        (WebCore::JSEventListener::JSEventListener):
        (WebCore::JSEventListener::~JSEventListener):
        * bindings/v8/V8AbstractEventListener.cpp:
        (WebCore::V8AbstractEventListener::V8AbstractEventListener):
        (WebCore::V8AbstractEventListener::~V8AbstractEventListener):
        * dom/Document.cpp:
        (WebCore::Document::Document):
        (WebCore::Document::~Document):
        * dom/Document.h:
        (WebCore::Node::Node):
        * dom/Node.cpp:
        (WebCore::Node::~Node):
        * inspector/InspectorAllInOne.cpp:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        * inspector/InspectorCounters.cpp: Added.
        (WebCore):
        (WebCore::InspectorCounters::counterValue):
        * inspector/InspectorCounters.h: Added.
        (WebCore):
        (InspectorCounters):
        (WebCore::InspectorCounters::incrementCounter):
        (WebCore::InspectorCounters::decrementCounter):
        * inspector/InspectorTimelineAgent.cpp:
        (WebCore::InspectorTimelineAgent::didCallFunction):
        (WebCore::InspectorTimelineAgent::didDispatchEvent):
        (WebCore::InspectorTimelineAgent::didWriteHTML):
        (WebCore::InspectorTimelineAgent::didFireTimer):
        (WebCore::InspectorTimelineAgent::didEvaluateScript):
        (WebCore::InspectorTimelineAgent::setHeapSizeStatistic):
        (WebCore::InspectorTimelineAgent::InspectorTimelineAgent):
        * inspector/InspectorTimelineAgent.h:
        (WebCore):
        (WebCore::InspectorTimelineAgent::create):
        (InspectorTimelineAgent):
        * inspector/front-end/MemoryStatistics.js:
        (WebInspector.MemoryStatistics):
        (WebInspector.MemoryStatistics.prototype.addTimlineEvent):
        (WebInspector.MemoryStatistics.prototype._draw.getDocumentCount):
        (WebInspector.MemoryStatistics.prototype._refreshCurrentValues):
        * inspector/front-end/TimelinePanel.js:
        (WebInspector.TimelinePanel.prototype._onTimelineEventRecorded):

2012-02-16  Cris Neckar  <cdn@chromium.org>

        Correct a misleading comment regarding string delimiters in CSS parsing.
        https://bugs.webkit.org/show_bug.cgi?id=78521

        Reviewed by Zoltan Herczeg.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::lex):

2012-02-16  Martin Robinson  <mrobinson@igalia.com>

        Fix the TextureMapper build for GTK+.

        No new tests. This is just a build fix.

        * GNUmakefile.list.am: Add missing files to the build and change spaces to tabs.

2012-02-16  Daniel Bates  <dbates@webkit.org>

        Add ENABLE(STYLE_SCOPED) around HTMLStyleElement::m_isRegisteredWithScopingNode 

        The instance variable HTMLStyleElement::m_isRegisteredWithScopingNode is only
        referenced from within ENABLE(STYLE_SCOPED)-guarded code. We should add this
        guard around its declaration.

        * html/HTMLStyleElement.h:
        (HTMLStyleElement):

2012-02-16  Shinya Kawanaka  <shinyak@chromium.org>

        [v8] v8 doesn't assume to do 'new WebKitShadowRoot(host)'
        https://bugs.webkit.org/show_bug.cgi?id=78875

        Reviewed by Kentaro Hara.

        Since v8 does not assume that we do 'new WebkitShadowRoot(host)', a wrapper object for new WebKitShadowRoot(host)
        was saved in DOMObject storage instead of DOMNode storage.

        CodeGenerator should handle with DOMNode correctly to solve the problem.

        Test: fast/dom/shadow/shadow-root-new.html

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateConstructorCallback):

2012-02-16  Ilya Tikhonovsky  <loislo@chromium.org>

        Unreviewed rollout r107952 because it broke shadow-boundary-events.html and related-target-focusevent.html on mac.
        see http://webkit.org/b/78832

        * CMakeLists.txt:
        * DerivedSources.cpp:
        * DerivedSources.make:
        * DerivedSources.pri:
        * GNUmakefile.list.am:
        * Target.pri:
        * WebCore.gypi:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/DOMAllInOne.cpp:
        * dom/EventDispatchMediator.cpp:
        (WebCore::FocusEventDispatchMediator::create):
        (WebCore):
        (WebCore::FocusEventDispatchMediator::FocusEventDispatchMediator):
        (WebCore::FocusEventDispatchMediator::dispatchEvent):
        (WebCore::BlurEventDispatchMediator::create):
        (WebCore::BlurEventDispatchMediator::BlurEventDispatchMediator):
        (WebCore::BlurEventDispatchMediator::dispatchEvent):
        * dom/EventDispatchMediator.h:
        (FocusEventDispatchMediator):
        (WebCore):
        (BlurEventDispatchMediator):
        * dom/EventFactory.in:
        * dom/FocusEvent.cpp: Removed.
        * dom/FocusEvent.h: Removed.
        * dom/FocusEvent.idl: Removed.
        * dom/Node.cpp:
        (WebCore::Node::dispatchFocusInEvent):
        (WebCore::Node::dispatchFocusOutEvent):
        * dom/UIEvent.cpp:
        (WebCore::FocusInEventDispatchMediator::create):
        (WebCore):
        (WebCore::FocusInEventDispatchMediator::FocusInEventDispatchMediator):
        (WebCore::FocusInEventDispatchMediator::dispatchEvent):
        (WebCore::FocusOutEventDispatchMediator::create):
        (WebCore::FocusOutEventDispatchMediator::FocusOutEventDispatchMediator):
        (WebCore::FocusOutEventDispatchMediator::dispatchEvent):
        * dom/UIEvent.h:
        (FocusInEventDispatchMediator):
        (WebCore):
        (FocusOutEventDispatchMediator):
        * page/DOMWindow.idl:

2012-02-16  Mark Hahnenberg  <mhahnenberg@apple.com>

        Another fix for viewport tests

        No new tests.

        * dom/ViewportArguments.cpp:
        (WebCore::numericPrefix): When we don't parse a number, we could either be 
        trying to parse junk, which returns NaN, or we could get an empty string, 
        which returns 0, so we need to account for that in the assert.

2012-02-16  Mark Hahnenberg  <mhahnenberg@apple.com>

        Another build fix for viewport tests

        No new tests.

        * dom/ViewportArguments.cpp:
        (WebCore::numericPrefix): We now return NaN instead of 0 when we fail to 
        parse a number using charactersToFloatIgnoringJunk, so we need to assert that 
        we have NaN rather than 0.

2012-02-16  Alexandre Elias  <aelias@google.com>

        [chromium] Bundle page scale factor and limits in CCLayerTreeHost
        https://bugs.webkit.org/show_bug.cgi?id=78762

        Setting page scale factor and its limits in separate methods
        may cause clamping bugs if one of them makes it to the
        impl thread before the other.  Change the API to bundle them together,
        which matches the existing impl-side interface.

        Reviewed by James Robinson.

        No new tests (API change will disallow this type of bug).

        * platform/graphics/chromium/cc/CCLayerTreeHost.cpp:
        (WebCore::CCLayerTreeHost::CCLayerTreeHost):
        (WebCore::CCLayerTreeHost::finishCommitOnImplThread):
        (WebCore::CCLayerTreeHost::setPageScaleFactorAndLimits):
        * platform/graphics/chromium/cc/CCLayerTreeHost.h:
        (CCLayerTreeHost):

2012-02-16  Kentaro Hara  <haraken@chromium.org>

        Unreviewed. Rebaselined run-bindings-tests results.

        * bindings/scripts/test/JS/JSTestEventConstructor.cpp:
        (WebCore::JSTestEventConstructorConstructor::finishCreation):
        * bindings/scripts/test/JS/JSTestInterface.cpp:
        (WebCore::JSTestInterfaceConstructor::finishCreation):
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::JSTestObjConstructor::finishCreation):
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp:
        (WebCore::JSTestSerializedScriptValueInterfaceConstructor::finishCreation):

2012-02-16  Sami Kyostila  <skyostil@chromium.org>

        [chromium] LayerChromium::setNeedsDisplay does not apply contents scale correctly
        https://bugs.webkit.org/show_bug.cgi?id=77464

        Use bounds() instead of contentBounds() to calculate the region to mark
        as needing painting in LayerChromium::setNeedsDisplay(). contentBounds()
        includes contents scale, while bounds() does not.

        Since this change also means that TiledLayerChromium::setNeedsDisplayRect() is
        given an unscaled rectangle, modify that function to scale the rectangle before
        using it to invalidate the underlying tiles.

        Reviewed by James Robinson.

        Tests: New tests added to LayerChromium and TiledLayerChromium unit tests.

        * platform/graphics/chromium/LayerChromium.h:
        (WebCore::LayerChromium::setNeedsDisplay):
        * platform/graphics/chromium/TiledLayerChromium.cpp:
        (WebCore::TiledLayerChromium::setNeedsDisplayRect):

2012-02-16  Raymond Liu  <raymond.liu@intel.com>

        Lazy init for DefaultAudioDestinationNode and OfflineAudioDestinationNode
        https://bugs.webkit.org/show_bug.cgi?id=76509

        Reviewed by Eric Seidel.

        No new tests required.

        * webaudio/AudioDestinationNode.h:
        * webaudio/AudioNode.h:
        (WebCore::AudioNode::sampleRate):
        * webaudio/DefaultAudioDestinationNode.cpp:
        (WebCore::DefaultAudioDestinationNode::DefaultAudioDestinationNode):
        * webaudio/DefaultAudioDestinationNode.h:
        * webaudio/OfflineAudioDestinationNode.cpp:
        (WebCore::OfflineAudioDestinationNode::OfflineAudioDestinationNode):
        * webaudio/OfflineAudioDestinationNode.h:
        (WebCore::OfflineAudioDestinationNode::sampleRate):

2012-02-16  Shinya Kawanaka  <shinyak@chromium.org>

        [Refactoring] Remove location from NodeRenderingContext.
        https://bugs.webkit.org/show_bug.cgi?id=78796

        Reviewed by Hajime Morita.

        This is a simple refactoring to remove m_location from NodeRenderingContext.
        TreeLocation is merged into AttachPhase like the following.
            LocationUndertermined -> Calculating
            LocationNotInTree -> AttachingNotInTree
            LocationLightChild -> AttachingStraight / AttachingNotDistributed / AttachingDistributed
            LocationShadowChild -> AttachingStraight / AttachingShadowChild / AttachingFallback

        We have renamed the enum items of AttachPhase, because not only <content> but also
        <shadow> will use the phases. Basically these words are taken from Shadow DOM spec.
        'Calculating' means NodeRenderingContext is used not for attaching but for calculating RenderObject.

        No new tests, no change in behavior.

        * dom/NodeRenderingContext.cpp:
        (WebCore::NodeRenderingContext::NodeRenderingContext):
        (WebCore::NodeRenderingContext::nextRenderer):
        (WebCore::NodeRenderingContext::previousRenderer):
        (WebCore::NodeRenderingContext::parentRenderer):
        (WebCore::NodeRenderingContext::shouldCreateRenderer):
        * dom/NodeRenderingContext.h:
        (NodeRenderingContext):
        (WebCore::NodeRenderingContext::parentNodeForRenderingAndStyle):

2012-02-16  Kent Tamura  <tkent@chromium.org>

        Run sort-Xcode-project-file.

        * WebCore.xcodeproj/project.pbxproj: Sorted.

2012-02-16  Mark Hahnenberg  <mhahnenberg@apple.com>

        Another build fix for viewport tests

        No new tests.

        * dom/ViewportArguments.cpp:
        (WebCore::numericPrefix): We now return NaN instead of 0 when we fail to 
        parse a number using charactersToFloatIgnoringJunk, so we need to assert that 
        we have NaN rather than 0.

2012-02-15  Michael Nordman  <michaeln@google.com>

        [chromium] Fix bugs in the implementation of WebDatabase::closeDatabaseImmediately.
        https://bugs.webkit.org/show_bug.cgi?id=78841

        WebDatabase now delegates this function entirely to DatabaseTracker,
        a new closeDatabasesImmediately() has been added for that purpose. That
        method posts tasks to the appropiate context thread for each database
        instance that should be closed immediately.

        The DatabaseTracker getAllOpenDatabases() method has been removed from
        the chromium impl because it's unsafe, refs cannot be safely taken on
        AbstractDatabase instances in the tracker's collection of open databases.

        Add a message to the console log when a database is forcibly closed.

        Transactions initiated on a database instance that has been forcibly
        closed complete with a transaction error callback.
        
        This is part of resolving http://crbug.com/98939

        Reviewed by David Levin.

        No new layout tests, there is no common code way to closeImmediately.
        We have coverage for this in py automation tests.

        * platform/sql/SQLiteDatabase.cpp:
        The closeImmediately code path can result in the underlying sqlite3 handle being
        closed earlier than usual and trip some assertions. Updated the assertions to no
        longer trigger in this early close case.
        (WebCore::SQLiteDatabase::close):
        (WebCore::SQLiteDatabase::setMaximumSize):
        * platform/sql/SQLiteDatabase.h:
        (WebCore::SQLiteDatabase::sqlite3Handle):

        * storage/Database.cpp:
        (WebCore::Database::closeImmediately): Modified to only be called on the context thread and to log a console message.
        (WebCore::Database::changeVersion): Use the private runTransaction helper method.
        (WebCore::Database::transaction): Pass a new param required by the runTransaction helper.
        (WebCore::Database::readTransaction): Ditto.
        (WebCore::callTransactionErrorCallback): Used to defer invocation of the error callback.
        (WebCore::Database::runTransaction): Modified to detect when the database has been closed, and
        to invoke the error callback in that case. This also avoids creating a reference cycle between
        a newly created transaction and the database that previously existed due to a transction being
        added and never removed from the Q while in this state.
        * storage/Database.h:
        * storage/DatabaseSync.cpp:
        (WebCore::DatabaseSync::closeImmediately): Modified to only be called on the context thread and to log a console message.
        * storage/DatabaseTracker.h:

        * storage/chromium/DatabaseTrackerChromium.cpp:
        Posts tasks to the appropiate context thread for execution without bumping AbstractDatabase refcounts.
        (DatabaseTracker::CloseOneDatabaseImmediatelyTask):
        (WebCore::DatabaseTracker::CloseOneDatabaseImmediatelyTask::create):
        (WebCore::DatabaseTracker::CloseOneDatabaseImmediatelyTask::performTask):
        (WebCore::DatabaseTracker::CloseOneDatabaseImmediatelyTask::CloseOneDatabaseImmediatelyTask):
        (WebCore::DatabaseTracker::closeDatabasesImmediately): 
        (WebCore::DatabaseTracker::closeOneDatabaseImmediately):

2012-02-16  Dana Jansens  <danakj@chromium.org>

        [Chromium] Occlusion tracking with CSS filters
        https://bugs.webkit.org/show_bug.cgi?id=77498

        Reviewed by James Robinson.

        The new CSS filter support within the compositor changes how
        occlusion tracking needs to function. A filter can change the
        alpha value of pixels, making an otherwise opaque pixel no
        longer so. Secondly, a filter may move color values around
        on a surface, which can cause otherwise occluded areas to
        become visible and require painting.

        New unit tests: CCLayerTreeHostTest.cpp

        Tests: compositing/culling/filter-occlusion-alpha-large.html
               compositing/culling/filter-occlusion-alpha.html
               compositing/culling/filter-occlusion-blur-large.html
               compositing/culling/filter-occlusion-blur.html

        * platform/graphics/chromium/RenderSurfaceChromium.cpp:
        (WebCore::RenderSurfaceChromium::RenderSurfaceChromium):
        * platform/graphics/chromium/RenderSurfaceChromium.h:
        (WebCore::RenderSurfaceChromium::setFilters):
        (WebCore::RenderSurfaceChromium::filters):
        (WebCore::RenderSurfaceChromium::setNearestAncestorThatMovesPixels):
        (WebCore::RenderSurfaceChromium::nearestAncestorThatMovesPixels):
        (RenderSurfaceChromium):
        * platform/graphics/chromium/cc/CCLayerTreeHost.cpp:
        (WebCore::enterTargetRenderSurface):
        (WebCore::CCLayerTreeHost::paintLayerContents):
        * platform/graphics/chromium/cc/CCLayerTreeHostCommon.cpp:
        (WebCore::subtreeShouldRenderToSeparateSurface):
        (WebCore::calculateDrawTransformsAndVisibilityInternal):
        (WebCore::CCLayerTreeHostCommon::calculateDrawTransformsAndVisibility):
        * platform/graphics/chromium/cc/CCRenderSurface.cpp:
        (WebCore::CCRenderSurface::CCRenderSurface):
        * platform/graphics/chromium/cc/CCRenderSurface.h:
        (WebCore::CCRenderSurface::setNearestAncestorThatMovesPixels):
        (WebCore::CCRenderSurface::nearestAncestorThatMovesPixels):
        (CCRenderSurface):
        * platform/graphics/filters/FilterOperation.h:
        (FilterOperation):
        (WebCore::FilterOperation::affectsOpacity):
        (WebCore::FilterOperation::movesPixels):
        (WebCore::ReferenceFilterOperation::affectsOpacity):
        (WebCore::ReferenceFilterOperation::movesPixels):
        (ReferenceFilterOperation):
        (WebCore::BasicComponentTransferFilterOperation::affectsOpacity):
        (BasicComponentTransferFilterOperation):
        (WebCore::BlurFilterOperation::affectsOpacity):
        (WebCore::BlurFilterOperation::movesPixels):
        (BlurFilterOperation):
        (WebCore::DropShadowFilterOperation::affectsOpacity):
        (DropShadowFilterOperation):
        * platform/graphics/filters/FilterOperations.cpp:
        (WebCore::FilterOperations::hasFilterThatAffectsOpacity):
        (WebCore):
        (WebCore::FilterOperations::hasFilterThatMovesPixels):
        * platform/graphics/filters/FilterOperations.h:
        (WebCore::FilterOperations::isEmpty):
        (FilterOperations):

2012-02-16  Leo Yang  <leo.yang@torchmobile.com.cn>

        [BlackBerry] Adapt to the removal of WebStringIml.h
        https://bugs.webkit.org/show_bug.cgi?id=78784

        Reviewed by Antonio Gomes.

        WebKit/blackberry/WebCoreSupport/WebStringImpl.h which hasn't been upstreamed
        has been removed internally. We should adapt to this removal for the
        upstreamed part of the BlackBerry port. Actually WebStringImpl is not necessary
        because it just inherits from WTF::StringImpl but adding nothing.

        No functionalities changed, no new tests.

        * platform/text/blackberry/StringBlackBerry.cpp:
        (WTF::String::operator WebString):

2012-02-15  Geoffrey Garen  <ggaren@apple.com>

        Made Weak<T> single-owner, adding PassWeak<T>
        https://bugs.webkit.org/show_bug.cgi?id=78740

        Reviewed by Sam Weinig.

        * bindings/js/JSDOMBinding.cpp:
        (WebCore::jsStringSlowCase): Use PassWeak<T>, as required by our new
        hash map API.

        * bindings/js/JSDOMBinding.h:
        (WebCore::getCachedWrapper):
        (WebCore::cacheWrapper): Use PassWeak<T> and raw pointer, as required by
        our new hash map API.

        * bindings/js/JSEventListener.h:
        (WebCore::JSEventListener::setWrapper):
        * bindings/js/ScriptWrappable.h:
        (WebCore::ScriptWrappable::setWrapper):
        * bridge/jsc/BridgeJSC.cpp:
        (JSC::Bindings::Instance::createRuntimeObject):
        * bridge/runtime_root.cpp:
        (JSC::Bindings::RootObject::addRuntimeObject): Use PassWeak<T>, as
        required by our new hash map and Weak<T> APIs.

2012-02-16  Ryosuke Niwa  <rniwa@webkit.org>

        Crash in visiblePositionForIndex
        https://bugs.webkit.org/show_bug.cgi?id=77683

        Reviewed by Eric Seidel.

        Fixed the crash.

        Test: editing/execCommand/applyblockelement-visiblepositionforindex-crash.html

        * editing/ApplyBlockElementCommand.cpp:
        (WebCore::ApplyBlockElementCommand::doApply):
        * editing/InsertListCommand.cpp:
        (WebCore::InsertListCommand::doApply):
        * editing/htmlediting.cpp:
        (WebCore::indexForVisiblePosition):
        * editing/htmlediting.h:
        (WebCore):

2012-02-16  Matthew Delaney  <mdelaney@apple.com>

        ShadowBlur.cpp's cached content matching needs to consider m_layerSize changes
        https://bugs.webkit.org/show_bug.cgi?id=78765

        Reviewed by Simon Fraser.

        No new tests due to the flaky nature of reproducing the issue.

        * platform/graphics/ShadowBlur.cpp:
        (WebCore::ScratchBuffer::getScratchBuffer): Make sure to call clearScratchBuffer()
        when we create a new ImageBuffer in order to invalidate cached values.
        (WebCore::ScratchBuffer::setCachedShadowValues): Roll together matching and setting
        of cached values into one method to enforce them being the same.
        (WebCore::ScratchBuffer::setCachedInsetShadowValues): Ditto.

        Restructure to use new method described above.
        (WebCore::ShadowBlur::drawRectShadowWithoutTiling): 
        (WebCore::ShadowBlur::drawInsetShadowWithoutTiling):
        (WebCore::ShadowBlur::drawInsetShadowWithTiling):
        (WebCore::ShadowBlur::drawRectShadowWithTiling):
        (WebCore::ShadowBlur::beginShadowLayer):

2012-02-16  Dana Jansens  <danakj@chromium.org>

        [chromium] Empty divs not transforming overflow correctly
        https://bugs.webkit.org/show_bug.cgi?id=78850

        Reviewed by James Robinson.

        Test: compositing/overflow/transform-in-empty-container.html

        * platform/graphics/chromium/GraphicsLayerChromium.cpp:
        (WebCore::GraphicsLayerChromium::setSize):

2012-02-16  Emil A Eklund  <eae@chromium.org>

        Fix use of long long in FractionalLayoutUnit::setRawValue
        https://bugs.webkit.org/show_bug.cgi?id=78835

        Reviewed by Eric Seidel.

        Change setRawValue(long long) to compare against int min and max instead
        of using abs as not all platforms we support implement a long long
        version of abs or llabs.

        No new tests.

        * platform/FractionalLayoutUnit.h:
        (WebCore::FractionalLayoutUnit::setRawValue):
        Compare against int min/max instead of just max with abs.
        
        (WebCore::FractionalLayoutUnit::isInBounds):
        Fix type mismatch warning.
        
        (WebCore::operator==):
        Fix typo.
        
        (WebCore::operator*):
        Use long long version of setRawValue.

2012-02-15  Shinya Kawanaka  <shinyak@chromium.org>

        Add an internal flag to accept multiple shadow roots for the purpose of tests.
        https://bugs.webkit.org/show_bug.cgi?id=78453

        Reviewed by Hajime Morita.

        This patch introduces a flag to enable multiple shadow subtrees.
        This flag is intended to be used for testing purpose for a while.
        We will remove it later.

        No new tests, no change in behavior.

        * WebCore.exp.in:
        * bindings/generic/RuntimeEnabledFeatures.cpp:
        (WebCore):
        * bindings/generic/RuntimeEnabledFeatures.h:
        (RuntimeEnabledFeatures):
        (WebCore::RuntimeEnabledFeatures::multipleShadowSubtreesEnabled):
        (WebCore::RuntimeEnabledFeatures::setMultipleShadowSubtreesEnabled):
        * dom/ShadowRoot.cpp:
        (WebCore::ShadowRoot::create):
        * dom/ShadowRootList.cpp:
        (WebCore::ShadowRootList::pushShadowRoot):
        * testing/Internals.cpp:
        (WebCore::Internals::setMultipleShadowSubtreesEnabled):
        (WebCore):
        * testing/Internals.h:
        (Internals):
        * testing/Internals.idl:

2012-02-16  Mark Hahnenberg  <mhahnenberg@apple.com>

        Fix the broken viewport tests
        https://bugs.webkit.org/show_bug.cgi?id=78774

        Reviewed by Kenneth Rohde Christiansen.

        No new tests.

        * dom/ViewportArguments.cpp:
        (WebCore::numericPrefix): Changed to use the new charactersToFloatWithJunk function(s).

2012-02-16  Cris Neckar  <cdn@chromium.org>

        Very large strings could cause the new quoted string to wrap.
        https://bugs.webkit.org/show_bug.cgi?id=78387

        Reviewed by Eric Seidel.

        * css/CSSParser.cpp:
        (WebCore::quoteCSSString):

2012-02-16  Eric Seidel  <eric@webkit.org>

        Add a themeChromiumAndroid.css file for android-specific default styles
        https://bugs.webkit.org/show_bug.cgi?id=78547

        Reviewed by Adam Barth.

        This includes the themeChromiumAndroid.css file from the Chromium-Android port
        as well as some addidtional changes they had to html.css.  I believe those
        changes were made before themeChromiumAndroid was created, but it's now the better place for this CSS.

        * WebCore.gyp/WebCore.gyp:
        * css/themeChromiumAndroid.css: Added.
        (select[size][multiple]):
        (input[type="date"], input[type="datetime"], input[type="datetime-local"], input[type="time"], input[type="month"]):
        * rendering/RenderThemeChromiumAndroid.cpp:
        (WebCore::RenderThemeChromiumAndroid::extraDefaultStyleSheet):
        (WebCore):
        * rendering/RenderThemeChromiumAndroid.h:
        (RenderThemeChromiumAndroid):
        (WebCore::RenderThemeChromiumAndroid::delegatesMenuListRendering):
        (WebCore::RenderThemeChromiumAndroid::platformTapHighlightColor):

2012-02-16  Brady Eidson  <beidson@apple.com>

        <rdar://problem/10616280> and https://bugs.webkit.org/show_bug.cgi?id=78767
        REGRESSION (r90471) - iAd Producer 2.0.1 produces blank pages

        Reviewed by Sam Weinig.

        No new tests. (Subtle API change attached to a specific application)

        * loader/DocumentLoader.cpp:
        (WebCore::DocumentLoader::isLoadingInAPISense): Return true if the app needs the quirk
        and there are outstanding subresource loads.

        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        * page/Settings.h:
        (WebCore::Settings::setNeedsIsLoadingInAPISenseQuirk):
        (WebCore::Settings::needsIsLoadingInAPISenseQuirk):
        (Settings):

2012-02-16  Kentaro Hara  <haraken@chromium.org>

        Remove [ConvertScriptString] from FileReaderSync.idl
        https://bugs.webkit.org/show_bug.cgi?id=78335

        Reviewed by Eric Seidel.

        The spec says that FileReadSync should throw NOT_FOUND_ERR
        if a given blob is invalid: http://www.w3.org/TR/FileAPI/#FileReaderSync

        By this fix, we can completely remove [ConvertScriptString] from WebKit.

        Tests: fast/files/workers/worker-read-blob-sync.html
               fast/files/workers/worker-read-file-sync.html

        * fileapi/FileReaderSync.cpp: Modified to throw NOT_FOUND_ERR if a blob is invalid.
        (WebCore::FileReaderSync::readAsArrayBuffer):
        (WebCore::FileReaderSync::readAsBinaryString):
        (WebCore::FileReaderSync::readAsText):
        (WebCore::FileReaderSync::readAsDataURL):
        * fileapi/FileReaderSync.idl:

        * bindings/scripts/CodeGeneratorJS.pm: Removed [ConvertScriptString]
        since no one is using it.
        (NativeToJSValue):
        * bindings/scripts/CodeGeneratorV8.pm: Ditto.
        (NativeToJSValue):

        * bindings/scripts/test/TestObj.idl: Removed a test case for [ConvertScriptString].

        * bindings/scripts/test/CPP/WebDOMTestObj.cpp: Updated run-bindings-tests results.
        * bindings/scripts/test/CPP/WebDOMTestObj.h:
        * bindings/scripts/test/GObject/WebKitDOMTestObj.cpp:
        (webkit_dom_test_obj_get_property):
        (webkit_dom_test_obj_class_init):
        * bindings/scripts/test/GObject/WebKitDOMTestObj.h:
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore):
        * bindings/scripts/test/JS/JSTestObj.h:
        (WebCore):
        * bindings/scripts/test/ObjC/DOMTestObj.h:
        * bindings/scripts/test/ObjC/DOMTestObj.mm:
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore):


2012-02-16  Dana Jansens  <danakj@chromium.org>

        [chromium] Clipping/Transforms applied in wrong order in opaque paint tracking
        https://bugs.webkit.org/show_bug.cgi?id=78775

        Reviewed by Stephen White.

        The clip was being applied in device coordinates, before transforming the painted
        rect into device coordinates. This made any translations get doubly represented,
        and gave incorrect paint tracking results.

        Test: compositing/culling/unscrolled-within-boxshadow.html

        Unit test: PlatformContextSkiaTest.cpp

        * platform/graphics/skia/OpaqueRegionSkia.cpp:
        (WebCore::OpaqueRegionSkia::didDraw):

2012-02-16  Abhishek Arya  <inferno@chromium.org>

        Crash with tables in multi-column layout.
        https://bugs.webkit.org/show_bug.cgi?id=78415

        Reviewed by Julien Chaffraix.

        Multi-column code creates anonymous column blocks directly
        under RenderTable, thereby violating table layout assumption.
        E.g. Captions in this testcase gets reparented to these anonymous
        column blocks and when they go away, they are not able to clear
        themselves from table's m_captions list (since RenderTable::removeChild
        is not called).

        Test: fast/multicol/span/table-multi-column-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::containingColumnsBlock):

2012-02-16  ChangSeok Oh  <shivamidow@gmail.com>

        [GTK] File system api build is broken
        https://bugs.webkit.org/show_bug.cgi?id=78479

        Reviewed by Philippe Normand.

        This patch is a small step to support FileSystem API for GTK port.
        As I know, bug58443 also dealt with it, but it looks like the submitted patch
        needs to be updated. To do that, I think I need to discuss with the original author.
        So, I hope to just fix build break issue in this bug.

        No new tests. Implementing the feature is not done yet.

        * GNUmakefile.list.am: Added some missing files.
        * bindings/js/JSDirectoryEntryCustom.cpp: Added Error.h to use its API.
        * platform/AsyncFileSystem.cpp:
        (WebCore):
        (WebCore::AsyncFileSystem::create): The arguments don't match the declaration in AsyncFileSystem.h.
        * platform/gtk/AsyncFileSystemGtk.cpp: Added.
        (WebCore):
        (WebCore::AsyncFileSystem::isAvailable):
        (WebCore::AsyncFileSystem::isValidType):
        (WebCore::AsyncFileSystem::create):
        (WebCore::AsyncFileSystem::openFileSystem):
        (WebCore::AsyncFileSystem::crackFileSystemURL):
        (WebCore::AsyncFileSystemGtk::AsyncFileSystemGtk):
        (WebCore::AsyncFileSystemGtk::~AsyncFileSystemGtk):
        (WebCore::AsyncFileSystemGtk::toURL):
        (WebCore::AsyncFileSystemGtk::move):
        (WebCore::AsyncFileSystemGtk::copy):
        (WebCore::AsyncFileSystemGtk::remove):
        (WebCore::AsyncFileSystemGtk::removeRecursively):
        (WebCore::AsyncFileSystemGtk::readMetadata):
        (WebCore::AsyncFileSystemGtk::createFile):
        (WebCore::AsyncFileSystemGtk::createDirectory):
        (WebCore::AsyncFileSystemGtk::fileExists):
        (WebCore::AsyncFileSystemGtk::directoryExists):
        (WebCore::AsyncFileSystemGtk::readDirectory):
        (WebCore::AsyncFileSystemGtk::createWriter):
        * platform/gtk/AsyncFileSystemGtk.h: Added.
        (WebCore):
        (AsyncFileSystemGtk):

2012-02-16  Adrienne Walker  <enne@google.com>

        Handle dirty descendant visibility status in RenderLayer::updateLayerPositionsAfterScroll
        https://bugs.webkit.org/show_bug.cgi?id=78286

        Reviewed by Julien Chaffraix.

        This is an unfortunate bandaid over a corner case where sometimes the
        visible descendant status dirty flag is true when this function is
        called from FrameView::repaintFixedElementsAfterScrolling. As it
        should be cheap to refresh this flag when dirty in most cases (as it
        early outs after finding any visible descendant), just lazily update
        the dirty flag here to ensure correctness.

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::updateLayerPositionsAfterScroll):

2012-02-16  Adam Barth  <abarth@webkit.org>

        Chrome::*Geolocation* are just useless pass-throughs to ChromeClient and should be removed
        https://bugs.webkit.org/show_bug.cgi?id=78844

        Reviewed by Eric Seidel.

        These function serve no useful purpose and should be removed.

        * page/Chrome.cpp:
        (WebCore):
        * page/Chrome.h:
        (Chrome):
        * page/Geolocation.cpp:
        (WebCore::Geolocation::reset):
        (WebCore::Geolocation::requestPermission):

2012-02-16  Sergio Villar Senin  <svillar@igalia.com>

        [soup] Move important SoupSession feature initialization to WebCore
        https://bugs.webkit.org/show_bug.cgi?id=68602

        Reviewed by Martin Robinson.

        Moved content sniffer and decoder initialization from WebKit to
        WebCore because network stuff will not work as expected without
        them. Added also out-of-the-box proxy support to WebCore.

        No new tests required as we're just moving stuff from WebKit to
        WebCore.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::defaultSession):

2012-02-16  Julien Chaffraix  <jchaffraix@webkit.org>

        thead in table without tbody causes table height doubling
        https://bugs.webkit.org/show_bug.cgi?id=37244

        Reviewed by Ojan Vafai.

        Tests: fast/table/double-height-table-no-tbody-expected.html
               fast/table/double-height-table-no-tbody.html

        The bug is caused by the layout code would wrongly assuming that a
        table without a <tbody> is an empty table. We would set the logical
        height to the style's logical height wrongly before inflating the
        logical height to account for the section(s). This would cause us
        to increase past our needed size thus the bug.

        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::layout):
        A table is empty if it does not have any top section, not just a <tbody>.
        The test uncovered an issue with height distribution in layoutRows where we
        would distribute the extra height to the first <tbody> not section.

2012-02-07  Robert Hogan  <robert@webkit.org>

        CSS 2.1 failure: fixed-table-layout-013 and fixed-table-layout-015 fail
        https://bugs.webkit.org/show_bug.cgi?id=78027

        Reviewed by Julien Chaffraix.

        Both of these test the (slightly implicit) rule that width set on column-groups cannot
        affect the width of columns in a fixed layout table: http://www.w3.org/TR/CSS21/tables.html#fixed-table-layout
        FF, Opera and IE all pass these two tests.

        Tests: css2.1/20110323/fixed-table-layout-013.htm
               css2.1/20110323/fixed-table-layout-015.htm

        * rendering/FixedTableLayout.cpp:
        (WebCore::nextCol): A helper function for finding the next column along.
        (WebCore::FixedTableLayout::calcWidthArray): Ignore width specified by column groups.
        * rendering/RenderTableCol.h:
        (WebCore::RenderTableCol::isTableColGroup): Convenience function for identifying column groups.

2012-02-16  Philippe Normand  <pnormand@igalia.com>

        Unreviewed, rolling out r107941.
        http://trac.webkit.org/changeset/107941
        https://bugs.webkit.org/show_bug.cgi?id=68602

        Broke 23 http tests on GTK

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::defaultSession):

2012-02-16  Tom Sepez  <tsepez@chromium.org>

        XSS Auditor bypass with U+2028/2029
        https://bugs.webkit.org/show_bug.cgi?id=78732

        Reviewed by Adam Barth.

        Test: http/tests/security/xssAuditor/script-tag-with-trailing-comment-U2028.html

        * html/parser/XSSAuditor.cpp:
        (WebCore::isJSNewline):
        (WebCore::XSSAuditor::snippetForJavaScript):

2012-02-15  Mark Rowe  <mrowe@apple.com>

        NPN_GetValueForURL / NPNURLVProxy returns DIRECT when proxy configured via PAC
        <http://webkit.org/b/78766> / <rdar://problem/10729283>

        Reviewed by Anders Carlsson.

        * platform/network/cf/ProxyServerCFNet.cpp:
        (WebCore::proxyAutoConfigurationResultCallback): Stop the runloop, and then process
        the results that we received.
        (WebCore::processProxyServers): Processing of array of proxy configuration information
        moved from addProxyServersForURL. Handling of proxy auto-configuration URLs is now handled
        by calling CFNetworkExecuteProxyAutoConfigurationURL and waiting synchronously on the result
        callback. Doing this synchronously is not great, but it's the best we can do without a lot
        of restructuring of the code that calls this. We arbitrarily time out the execution after five
        seconds to avoid permanently hanging.
        (WebCore::addProxyServersForURL): Call in to our helper function.

2012-02-16  Abhishek Arya  <inferno@chromium.org>

        Fix clone() function to handle descendant classes of RenderBlock.
        https://bugs.webkit.org/show_bug.cgi?id=78273

        Reviewed by Eric Seidel.

        Test: fast/multicol/span/clone-flexbox-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::clone):

2012-02-16  Raul Hudea  <rhudea@adobe.com>

        [CSSRegions]overflowRegion tests are flaky
        https://bugs.webkit.org/show_bug.cgi?id=78761

        Reviewed by Tony Chang.

        The overflowRegion tests were updated.

        * dom/Element.cpp:
        (WebCore::Element::webkitRegionOverflow):

2012-02-16  Raul Hudea  <rhudea@adobe.com>

        [CSS Regions] Repaint issues when changing innerHTML of content
        https://bugs.webkit.org/show_bug.cgi?id=78787

        Reviewed by David Hyatt.

        The calculation of the clipping rectangle is based on the repaint rectangle,
        so it needs to be clipped to the current region, because it might spread over multiple ones.

        Test: fast/repaint/region-painting-invalidation.html

        * rendering/RenderFlowThread.cpp:
        (WebCore::RenderFlowThread::repaintRectangleInRegions):

2012-02-16  Adam Roben  <aroben@apple.com>

        Roll out r107887

        It broke 32-bit builds due to truncation from "long long" to "int".

        Original bug is <http://webkit.org/b/76571> Add FractionalLayoutPoint/Size/Rect for
        sub-pixel layout

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.order:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/FractionalLayoutUnit.h:
        (WebCore::FractionalLayoutUnit::isInBounds):
        (WebCore::operator==):
        (WebCore::operator*):
        * platform/graphics/FloatPoint.cpp:
        * platform/graphics/FloatPoint.h:
        (WebCore):
        (FloatPoint):
        (WebCore::FloatPoint::move):
        (WebCore::FloatPoint::moveBy):
        * platform/graphics/FloatRect.cpp:
        * platform/graphics/FloatRect.h:
        (WebCore):
        * platform/graphics/FloatSize.cpp:
        * platform/graphics/FloatSize.h:
        (WebCore):
        * platform/graphics/FractionalLayoutPoint.h: Removed.
        * platform/graphics/FractionalLayoutRect.cpp: Removed.
        * platform/graphics/FractionalLayoutRect.h: Removed.
        * platform/graphics/FractionalLayoutSize.cpp: Removed.
        * platform/graphics/FractionalLayoutSize.h: Removed.
        * platform/graphics/IntRect.cpp:
        * platform/graphics/IntRect.h:
        (WebCore):
        (IntRect):

2012-02-16  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: cache settings values
        https://bugs.webkit.org/show_bug.cgi?id=78815

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/Settings.js:
        (WebInspector.Setting.prototype.get if):
        (WebInspector.Setting.prototype):
        (WebInspector.Setting.prototype.):
        (WebInspector.Setting.prototype.set this):

2012-02-16  Terry Anderson  <tdanderson@chromium.org>

        WebKit does not support DOM 3 Events FocusEvent
        https://bugs.webkit.org/show_bug.cgi?id=76216

        Created a new FocusEvent class (extends UIEvent) with a relatedTarget attribute.  Moved
        the {Focus,Blur,FocusIn,FocusOut}EventDispatchMediator classes inside FocusEvent.  Now when
        focusin or focusout events are dispatched, a FocusEvent is created with the relatedTarget
        attribute set accordingly.  No other logic changes have been made besides adding the
        FocusEvent class.

        Reviewed by Eric Seidel.

        Test: fast/events/related-target-focusevent.html

        * CMakeLists.txt:
        * DerivedSources.cpp:
        * DerivedSources.make:
        * DerivedSources.pri:
        * GNUmakefile.list.am:
        * Target.pri:
        * WebCore.gypi:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/DOMAllInOne.cpp:
            - Included mention of FocusEvent / JSFocusEvent in the above files to
              allow the patch to build on the different platforms
        * dom/EventDispatchMediator.cpp:
        * dom/EventDispatchMediator.h:
        * dom/EventFactory.in:
        * dom/FocusEvent.cpp: Added.
        (WebCore):
        (WebCore::FocusEvent::FocusEvent):
        (WebCore::FocusEvent::~FocusEvent):
        (WebCore::FocusEvent::initFocusEvent):
        (WebCore::FocusEvent::interfaceName):
        (WebCore::FocusInEventDispatchMediator::create):
        (WebCore::FocusInEventDispatchMediator::FocusInEventDispatchMediator):
        (WebCore::FocusInEventDispatchMediator::dispatchEvent):
        (WebCore::FocusInEventDispatchMediator::event):
        (WebCore::FocusOutEventDispatchMediator::create):
        (WebCore::FocusOutEventDispatchMediator::FocusOutEventDispatchMediator):
        (WebCore::FocusOutEventDispatchMediator::dispatchEvent):
        (WebCore::FocusOutEventDispatchMediator::event):
        (WebCore::FocusEventDispatchMediator::create):
        (WebCore::FocusEventDispatchMediator::FocusEventDispatchMediator):
        (WebCore::FocusEventDispatchMediator::dispatchEvent):
        (WebCore::BlurEventDispatchMediator::create):
        (WebCore::BlurEventDispatchMediator::BlurEventDispatchMediator):
        (WebCore::BlurEventDispatchMediator::dispatchEvent):
        * dom/FocusEvent.h: Copied from Source/WebCore/dom/EventDispatchMediator.h.
        (WebCore):
        (FocusEvent):
        (WebCore::FocusEvent::create):
        (WebCore::FocusEvent::relatedTarget):
        (WebCore::FocusEvent::setRelatedTarget):
        (FocusInEventDispatchMediator):
        (FocusOutEventDispatchMediator):
        (FocusEventDispatchMediator):
        (BlurEventDispatchMediator):
        * dom/FocusEvent.idl: Added.
        * dom/Node.cpp:
        (WebCore::Node::dispatchFocusInEvent):
        (WebCore::Node::dispatchFocusOutEvent):
        * dom/UIEvent.cpp:
        * dom/UIEvent.h:
        * page/DOMWindow.idl:

2012-02-16  No'am Rosenthal  <noam.rosenthal@nokia.com>

        [Texmap] Improve the way we deal with BGRA extension
        https://bugs.webkit.org/show_bug.cgi?id=78822

        Swizzle the RGBA manually only in OpenGL ES, and only if the extension is not available.
        Pass the pixel-format of the images when updating TextureMapperTiledBackingStore.

        Reviewed by Kenneth Rohde Christiansen.

        No new behavior.

        * platform/graphics/opengl/TextureMapperGL.cpp:
        (WebCore):
        (WebCore::hasExtension):
        (WebCore::hasBgraExtension):
        (WebCore::BitmapTextureGL::updateContents):
        * platform/graphics/texmap/TextureMapperBackingStore.cpp:
        (WebCore::TextureMapperTile::updateContents):
        (WebCore::TextureMapperTiledBackingStore::updateContentsFromImageIfNeeded):
        (WebCore::TextureMapperTiledBackingStore::updateContents):
        * platform/graphics/texmap/TextureMapperBackingStore.h:
        (TextureMapperTile):
        (TextureMapperTiledBackingStore):
        (WebCore::TextureMapperTiledBackingStore::updateContents):
        * platform/graphics/texmap/TextureMapperLayer.cpp:
        (WebCore::TextureMapperLayer::updateBackingStore):

2012-02-16  Simon Hausmann  <simon.hausmann@nokia.com>

        [Gtk][Efl][Qt] Move OpenGLShims out of cairo/ subdirectory
        https://bugs.webkit.org/show_bug.cgi?id=78800

        Reviewed by Kenneth Rohde Christiansen.

        The file is not specific to Cairo and used in other ports. Move it into
        common space.

        * GNUmakefile.list.am:
        * PlatformEfl.cmake:
        * Target.pri:
        * platform/graphics/OpenGLShims.cpp: Renamed from Source/WebCore/platform/graphics/cairo/OpenGLShims.cpp.
        (WebCore):
        (WebCore::openGLFunctionTable):
        (WebCore::getProcAddress):
        (WebCore::lookupOpenGLFunctionAddress):
        (WebCore::initializeOpenGLShims):
        * platform/graphics/OpenGLShims.h: Renamed from Source/WebCore/platform/graphics/cairo/OpenGLShims.h.
        (WebCore):
        (_OpenGLFunctionTable):
        * platform/graphics/opengl/Extensions3DOpenGL.cpp:
        * platform/graphics/opengl/GraphicsContext3DOpenGL.cpp:
        * platform/graphics/opengl/GraphicsContext3DOpenGLCommon.cpp:
        * platform/graphics/opengl/TextureMapperGL.cpp:
        * platform/graphics/qt/Extensions3DQt.cpp:
        * platform/graphics/qt/GraphicsContext3DQt.cpp:

2012-02-16  No'am Rosenthal  <noam.rosenthal@nokia.com>

        [Qt][WK2] Allow opaque tiles
        https://bugs.webkit.org/show_bug.cgi?id=78809

        Add a supportsAlpha property to TiledBackingStore.
        We invalidate all the tiles if that property changes, because the buffers need to be
        recreated in a different format.

        Reviewed by Kenneth Rohde Christiansen.

        No behavior changes.

        * platform/graphics/TiledBackingStore.cpp:
        (WebCore::TiledBackingStore::TiledBackingStore):
        (WebCore::TiledBackingStore::setSupportsAlpha):
        (WebCore):
        * platform/graphics/TiledBackingStore.h:
        (TiledBackingStore):
        (WebCore::TiledBackingStore::supportsAlpha):

2012-02-16  Sergio Villar Senin  <svillar@igalia.com>

        [soup] Move important SoupSession feature initialization to WebCore
        https://bugs.webkit.org/show_bug.cgi?id=68602

        Reviewed by Martin Robinson.

        Moved content sniffer and decoder initialization from WebKit to
        WebCore because network stuff will not work as expected without
        them. Added also out-of-the-box proxy support to WebCore.

        No new tests required as we're just moving stuff from WebKit to
        WebCore.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::defaultSession):

2012-02-16  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: remove free flow DOM editing experiment.
        https://bugs.webkit.org/show_bug.cgi?id=78813

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/DOMAgent.js:
        (WebInspector.DOMAgent.prototype._markRevision):

2012-02-16  Patrick Gansterer  <paroga@webkit.org>

        WinCE build fix after r107453.

        * platform/FractionalLayoutUnit.h:
        (WebCore::FractionalLayoutUnit::isInBounds): Use fabs() instead of abs().

2012-02-15  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: explicitly mark undoable state from the front-end.
        https://bugs.webkit.org/show_bug.cgi?id=78716

        Reviewed by Vsevolod Vlasov.

        * inspector/InspectorCSSAgent.cpp:
        (WebCore::InspectorCSSAgent::toggleProperty):
        (WebCore::InspectorCSSAgent::setRuleSelector):
        (WebCore::InspectorCSSAgent::addRule):
        * inspector/InspectorDOMAgent.cpp:
        (WebCore::InspectorDOMAgent::setAttributeValue):
        (WebCore::InspectorDOMAgent::setAttributesAsText):
        (WebCore::InspectorDOMAgent::removeAttribute):
        (WebCore::InspectorDOMAgent::removeNode):
        (WebCore::InspectorDOMAgent::setNodeName):
        (WebCore::InspectorDOMAgent::setOuterHTML):
        (WebCore::InspectorDOMAgent::setNodeValue):
        (WebCore::InspectorDOMAgent::moveTo):
        * inspector/InspectorHistory.cpp:
        (WebCore::InspectorHistory::redo):
        * inspector/InspectorHistory.h:
        (InspectorHistory):
        * inspector/front-end/CSSStyleModel.js:
        (WebInspector.CSSStyleModel.prototype.setRuleSelector.callback):
        (WebInspector.CSSStyleModel.prototype.setRuleSelector):
        (WebInspector.CSSStyleModel.prototype.addRule.callback):
        (WebInspector.CSSStyleModel.prototype.addRule):
        (WebInspector.CSSStyleModel.prototype.setStyleSheetText):
        (WebInspector.CSSProperty.prototype.setText.callback):
        (WebInspector.CSSProperty.prototype.setText):
        (WebInspector.CSSProperty.prototype.setDisabled.callback):
        (WebInspector.CSSProperty.prototype.setDisabled):
        (WebInspector.CSSStyleSheet.prototype.setText):
        * inspector/front-end/DOMAgent.js:
        (WebInspector.DOMAgent.prototype._markRevision):
        (WebInspector.DOMAgent.prototype.get markUndoableState):

2012-02-15  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: revert 'modification of DOM upon single click for selected nodes'.
        https://bugs.webkit.org/show_bug.cgi?id=78717

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/ElementsTreeOutline.js:
        (WebInspector.ElementsTreeElement.prototype.onattach):

2012-02-16  Pavel Feldman  <pfeldman@google.com>

        Web Inspector: move style disable checkboxes to the left
        https://bugs.webkit.org/show_bug.cgi?id=78780

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertiesSection):
        (WebInspector.StylePropertiesSection.prototype._handleSelectorDoubleClick):
        (WebInspector.StylePropertyTreeElement.prototype):
        * inspector/front-end/elementsPanel.css:
        (.styles-section.matched-styles .properties):
        (.styles-section.matched-styles .properties li):
        (.styles-section .properties li.parent::before):
        (.styles-section .properties li.parent.expanded::before):
        (.styles-section.matched-styles .properties li.parent .expand-element):
        (.styles-section.matched-styles .properties li.parent.expanded .expand-element):
        (.styles-section.computed-style .properties li.parent::before):
        (.styles-section.computed-style .properties li.parent.expanded::before):
        (.styles-section.matched-styles:not(.read-only):hover .properties .enabled-button):
        (.styles-section.matched-styles:not(.read-only) .properties li.disabled .enabled-button):
        (.styles-section .properties .enabled-button):
        (.styles-section.matched-styles .properties ol.expanded):
        * inspector/front-end/treeoutline.js:
        (TreeElement.treeElementDoubleClicked):

2012-02-16  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: show memory counter graphics when switching to memory view
        https://bugs.webkit.org/show_bug.cgi?id=78808

        Switching to memory view in timeline will display memory counters. Counter
        graphics know show fair data without approximations between sampling points.

        Reviewed by Pavel Feldman.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/MemoryStatistics.js:
        (WebInspector.MemoryStatistics.prototype._calculateVisibleIndexes):
        (WebInspector.MemoryStatistics.prototype._calculateXValues):
        (WebInspector.MemoryStatistics.prototype._drawPolyline):
        * inspector/front-end/TimelinePanel.js:
        (WebInspector.TimelinePanel.prototype.get statusBarItems):
        (WebInspector.TimelinePanel.prototype._createStatusbarButtons):
        (WebInspector.TimelinePanel.prototype._timelinesOverviewItemSelected):
        (WebInspector.TimelinePanel.prototype._memoryOverviewItemSelected):

2012-02-16  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: [heap snapshot] It could be useful to have access to the selected heap object from the console.
        https://bugs.webkit.org/show_bug.cgi?id=78496

        Reviewed by Yury Semikhatsky.

       * bindings/js/JSInjectedScriptHostCustom.cpp:
        (WebCore::JSInjectedScriptHost::inspectedObject):
        * bindings/v8/custom/V8InjectedScriptHostCustom.cpp:
        (WebCore::V8InjectedScriptHost::inspectedObjectCallback):
        * inspector/InjectedScriptHost.cpp:
        (WebCore::InjectedScriptHost::InjectedScriptHost):
        (WebCore::InjectedScriptHost::InspectableObject::get):
        (WebCore):
        (WebCore::InjectedScriptHost::addInspectedObject):
        (WebCore::InjectedScriptHost::clearInspectedObjects):
        (WebCore::InjectedScriptHost::inspectedObject):
        * inspector/InjectedScriptHost.h:
        (InspectableObject):
        (WebCore::InjectedScriptHost::InspectableObject::~InspectableObject):
        (InjectedScriptHost):
        * inspector/InjectedScriptHost.idl:
        * inspector/InjectedScriptSource.js:
        (.):
        * inspector/Inspector.json:
        * inspector/InspectorAgent.cpp:
        (WebCore::InspectorAgent::domContentLoadedEventFired):
        * inspector/InspectorConsoleAgent.cpp:
        (InspectableHeapObject):
        (WebCore::InspectableHeapObject::InspectableHeapObject):
        (WebCore::InspectableHeapObject::get):
        (WebCore):
        (WebCore::InspectorConsoleAgent::addInspectedHeapObject):
        * inspector/InspectorConsoleAgent.h:
        (InspectorConsoleAgent):
        * inspector/InspectorProfilerAgent.cpp:
        (WebCore::InspectorProfilerAgent::resetState):
        * inspector/PageConsoleAgent.cpp:
        (InspectableNode):
        (WebCore::InspectableNode::InspectableNode):
        (WebCore::InspectableNode::get):
        (WebCore):
        (WebCore::PageConsoleAgent::addInspectedNode):
        * inspector/front-end/DetailedHeapshotView.js:
        (WebInspector.DetailedHeapshotView.prototype._selectionChanged):
        (WebInspector.DetailedHeapshotView.prototype._inspectedObjectChanged):

2012-02-16  Kihong Kwon  <kihong.kwon@samsung.com>

        Add support for unsigned long[] to idl bindings to JSC.
        https://bugs.webkit.org/show_bug.cgi?id=78210

        Reviewed by Kentaro Hara.

        Add support for unsigned long[] parameter type in idl.
        This patch adds support just for unsigned long[] parameter type.
        (support for other types of array should be done in another patch.)

        tests added to TestObj.idl.

        * bindings/js/JSDOMBinding.h:
        (WebCore::jsUnsignedLongArrayToVector):
        * bindings/scripts/CodeGeneratorJS.pm:
        (AddIncludesForType):
        (JSValueToNative):
        (NativeToJSValue):
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore):
        (WebCore::jsTestObjPrototypeFunctionMethodWithUnsignedLongArray):
        * bindings/scripts/test/JS/JSTestObj.h:
        (WebCore):
        * bindings/scripts/test/TestObj.idl:

2012-02-16  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: [InspectorIndexedDB] Add IndexedDB TreeElement to resources panel.
        https://bugs.webkit.org/show_bug.cgi?id=78609

        Reviewed by Yury Semikhatsky.

        Added IndexedDB tree element to resources panel (behind experimental setting).
        Test is currently disabled, since we don't run tests with experiments enabled.

        * English.lproj/localizedStrings.js:
        * WebCore.gypi:
        * inspector/front-end/Images/indexedDB.png: Added.
        * inspector/front-end/Images/indexedDBIndex.png: Added.
        * inspector/front-end/Images/indexedDBObjectStore.png: Added.
        * inspector/front-end/IndexedDBModel.js:
        (WebInspector.IndexedDBModel):
        (WebInspector.IndexedDBModel.prototype.refreshDatabaseNames):
        (WebInspector.IndexedDBModel.prototype.refreshDatabase):
        (WebInspector.IndexedDBModel.prototype._reset):
        (WebInspector.IndexedDBModel.prototype._originAddedToFrame):
        (WebInspector.IndexedDBModel.prototype._originRemoved):
        (WebInspector.IndexedDBModel.prototype._databaseAdded):
        (WebInspector.IndexedDBModel.prototype._databaseRemoved):
        (WebInspector.IndexedDBModel.prototype._loadDatabaseNamesForFrame):
        (WebInspector.IndexedDBModel.prototype._loadDatabase.callback):
        (WebInspector.IndexedDBModel.prototype._loadDatabase):
        (WebInspector.IndexedDBModel.Frame):
        (WebInspector.IndexedDBModel.DatabaseId):
        (WebInspector.IndexedDBModel.DatabaseId.prototype.equals):
        (WebInspector.IndexedDBModel.Database):
        (WebInspector.IndexedDBModel.Index):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.IndexedDBTreeElement):
        (WebInspector.IndexedDBTreeElement.prototype.onexpand):
        (WebInspector.IndexedDBTreeElement.prototype._createIndexedDBModel):
        (WebInspector.IndexedDBTreeElement.prototype.refreshIndexedDB):
        (WebInspector.IndexedDBTreeElement.prototype._indexedDBAdded):
        (WebInspector.IndexedDBTreeElement.prototype._indexedDBRemoved):
        (WebInspector.IndexedDBTreeElement.prototype._indexedDBLoaded):
        (WebInspector.IndexedDBTreeElement.prototype._idbDatabaseTreeElement):
        (WebInspector.IDBDatabaseTreeElement):
        (WebInspector.IDBDatabaseTreeElement.prototype.update):
        (WebInspector.IDBDatabaseTreeElement.prototype.onselect):
        (WebInspector.IDBObjectStoreTreeElement):
        (WebInspector.IDBObjectStoreTreeElement.prototype.update):
        (WebInspector.IDBIndexTreeElement):
        (WebInspector.IDBIndexTreeElement.prototype.update):
        * inspector/front-end/Settings.js:
        (WebInspector.ExperimentsSettings):
        * inspector/front-end/WebKit.qrc:
        * inspector/front-end/resourcesPanel.css:
        (.indexed-db-storage-tree-item .icon):
        (.indexed-db-object-store-storage-tree-item .icon):
        (.indexed-db-index-storage-tree-item .icon):

2012-02-15  Nikolas Zimmermann  <nzimmermann@rim.com>

        REGRESSION (Safari 5.0.5 - 5.1): No animation on svg-wow.org/text-effects/text-effects.xhtml
        https://bugs.webkit.org/show_bug.cgi?id=65072

        Reviewed by Zoltan Herczeg.

        Fix EMS/EXS length resolving, when the target context has no renderer, eg.
        <text display="none" dy="1em">ABC</text>, myText.dy.baseVal.getItem(0).value()
        currently throws, even if <text> has a parent, we could use to resolve the length.

        Always fall-back to parent context, to resolve EMS/EXS units, instead of ignoring it.
        The current behaviour stays the same, if the target element is not in the document,
        then we really can't resolve lengths like this.

        Tests: svg/text/ems-display-none.svg
               svg/text/exs-display-none.svg

        * svg/SVGLengthContext.cpp:
        (WebCore::renderStyleForLengthResolving):
        (WebCore::SVGLengthContext::convertValueFromUserUnitsToEMS):
        (WebCore::SVGLengthContext::convertValueFromEMSToUserUnits):
        (WebCore::SVGLengthContext::convertValueFromUserUnitsToEXS):
        (WebCore::SVGLengthContext::convertValueFromEXSToUserUnits):

2012-02-16  Simon Hausmann  <simon.hausmann@nokia.com>

        Build fix for Qt 5 without QtWidgets.

        Reviewed by Tor Arne Vestbø.

        The reason why QGLContext is included in Extensions3DQt.cpp is to
        achieve an implicit gl.h inclusion (needed for GL_FALSE). This patch
        replaces the inclusion with the OpenGLShims.h inclusions, which has
        the necessary #ifdefs in place to pull in gl.h with Qt 5 without QtWidgets.

        * platform/graphics/qt/Extensions3DQt.cpp:

2012-02-16  Shawn Singh  <shawnsingh@chromium.org>

        [chromium] Refactor CCLayerTreeHostCommon: create helper function for complex boolean condition
        https://bugs.webkit.org/show_bug.cgi?id=78539

        Reviewed by James Robinson.

        This change should introduce no change in behavior, and its
        expected behavior is already covered by existing tests.

        In calculateDrawTransformsAndVisibility, there is a complex
        boolean condition that indicates whether we should create a
        RenderSurface or not. This patch pulls out that boolean logic,
        and wraps it in a helper function for much better readability.

        * platform/graphics/chromium/cc/CCLayerTreeHostCommon.cpp:
        (WebCore::layerShouldBeSkipped):
        (WebCore):
        (WebCore::subtreeShouldRenderToSeparateSurface):
        (WebCore::calculateDrawTransformsAndVisibilityInternal):

2012-02-16  Andrey Kosyakov  <caseq@chromium.org>

        Web Inspector: [refactoring] move timeline overview sidebar creation to TimelineOverviewPane
        https://bugs.webkit.org/show_bug.cgi?id=78782

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/TimelineOverviewPane.js:
        (WebInspector.TimelineOverviewPane):
        (WebInspector.TimelineOverviewPane.prototype.showTimelines):
        (WebInspector.TimelineOverviewPane.prototype.showMemoryGraph):
        (WebInspector.TimelineOverviewPane.prototype.sidebarResized):
        * inspector/front-end/TimelinePanel.js:
        (WebInspector.TimelinePanel):
        (WebInspector.TimelinePanel.prototype.sidebarResized):

2012-02-15  Andreas Kling  <awesomekling@apple.com>

        Share font-family CSS values through CSSValuePool.
        <http://webkit.org/b/78604>

        Reviewed by Darin Adler.

        Cache and share FontFamilyValue instances in the per-document CSSValuePool.
        This reduces memory consumption by 248 kB on the Moz page cycler (64-bit)
        and avoids a bunch of extra work.

        This is a regression from the recent attribute style refactoring; previously
        the mapped attribute declaration table would ensure that multiple 'font'
        elements with the same 'face' value would share the same FontFamilyValue.

        We're not yet sharing the entire CSSValueList returned by parseFontFamily()
        but this is a step on the way there.

        * css/FontFamilyValue.cpp:
        * css/FontFamilyValue.h:

            Removed appendSpaceSeparated(), making FontFamilyValue immutable.

        * css/CSSParser.cpp:
        (FontFamilyValueBuilder):
        (WebCore::FontFamilyValueBuilder::FontFamilyValueBuilder):
        (WebCore::FontFamilyValueBuilder::add):
        (WebCore::FontFamilyValueBuilder::commit):
        (WebCore::CSSParser::parseFontFamily):

            Refactor parseFontFamily() to defer creation of FontFamilyValue until
            the whole family name is known. Added a little helper class to avoid
            code duplication.

        * css/CSSValuePool.h:
        * css/CSSValuePool.cpp:
        (WebCore::CSSValuePool::createFontFamilyValue):

            Added a FontFamilyValue cache to CSSValuePool. All values are tied to
            the lifetime of the pool.

2012-02-16  Simon Hausmann  <simon.hausmann@nokia.com>

        [Qt] Move event conversion functions from WebCore to WebKit
        https://bugs.webkit.org/show_bug.cgi?id=78788

        Reviewed by Kenneth Rohde Christiansen.

        Move QtWidgets dependent mouse event constructors out of WebCore
        into WebKit, similar to the web event conversions of WebKit2.

        * Target.pri:
        * platform/PlatformMouseEvent.h:
        (PlatformMouseEvent):
        * platform/PlatformWheelEvent.h:
        (PlatformWheelEvent):

2012-02-16  Simon Hausmann  <simon.hausmann@nokia.com>

        Unreviewed prospective Qt 4.8/Mac build fix.

        Cast the PlatformWidget from QObject* to QWidget* to gain access
        to QWidget methods.

        * plugins/mac/PluginViewMac.mm:
        (WebCore::nativeWindowFor):
        (WebCore::cgHandleFor):
        (WebCore::topLevelOffsetFor):
        (WebCore::PluginView::setFocus):
        (WebCore::PluginView::invalidateRect):

2012-02-16  Roland Steiner  <rolandsteiner@chromium.org>

        <style scoped>: Implement scoped selector matching in the slow path
        https://bugs.webkit.org/show_bug.cgi?id=77528

        Added scope information to SelectorCheckingContext, SelectorChecker methods and CSSStyleSelector methods.
        Added matchOptions struct to CSSStyleSelector similar to SelectorCheckingContext in SelectorChecker.
        Adapted the calling sites.

        Reviewed by Antti Koivisto.

        No new tests. (extended existing tests)

        * css/CSSStyleSelector.cpp:
        (RuleData):
        (RuleSet):
        (WebCore::CSSStyleSelector::determineScopingElement):
        (WebCore::CSSStyleSelector::collectMatchingRules):
        (WebCore::CSSStyleSelector::collectMatchingRulesForRegion):
        (WebCore::CSSStyleSelector::matchScopedAuthorRules):
        (WebCore::CSSStyleSelector::matchAuthorRules):
        (WebCore::CSSStyleSelector::collectMatchingRulesForList):
        * css/CSSStyleSelector.h:
        (CSSStyleSelector):
        (MatchOptions):
        (WebCore::CSSStyleSelector::MatchOptions::MatchOptions):
        * css/SelectorChecker.cpp:
        (WebCore::SelectorChecker::checkSelector):
        * css/SelectorChecker.h:
        (WebCore::SelectorChecker::SelectorCheckingContext::SelectorCheckingContext):
        (SelectorCheckingContext):
        (SelectorChecker):

2012-02-15  Patrick Gansterer  <paroga@webkit.org>

        Windows build fix for !ENABLE(CSS_FILTERS) after r106593.

        * platform/graphics/ca/win/PlatformCALayerWin.cpp:

2012-02-15  Antti Koivisto  <antti@apple.com>

        Move the context invalidation code out from StylePropertySet
        https://bugs.webkit.org/show_bug.cgi?id=78589

        Reviewed by Ryosuke Niwa.

        StylePropertySet should be independent of its context so that they can in the future
        be shared between documents. The context invalidation code should move to the CSSOM wrapper.
        
        Parent rule and parent element pointers move to the CSSOM wrapper classes. 
        
        The wrapper is responsible of invalidating the element or document style on mutation.
        In case of internal mutation of style attribute, StyledElement takes care of the 
        invalidation.
        
        The StylePropertySet will still have a pointer to the context stylesheet so the patch
        doesn't actually reduce memory usage. That pointer will be factored out later.

        * css/CSSFontFaceRule.cpp:
        (WebCore::CSSFontFaceRule::~CSSFontFaceRule):
        * css/CSSFontFaceRule.h:
        (WebCore::CSSFontFaceRule::style):
        * css/CSSPageRule.cpp:
        (WebCore::CSSPageRule::~CSSPageRule):
        * css/CSSPageRule.h:
        (WebCore::CSSPageRule::style):
        (WebCore::CSSPageRule::setDeclaration):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::createStyleRule):
        (WebCore::CSSParser::createFontFaceRule):
        (WebCore::CSSParser::createPageRule):
        (WebCore::CSSParser::createKeyframeRule):
        * css/CSSStyleRule.cpp:
        (WebCore::CSSStyleRule::~CSSStyleRule):
        * css/CSSStyleRule.h:
        (WebCore::CSSStyleRule::style):
        (WebCore::CSSStyleRule::setDeclaration):
        * css/StylePropertySet.cpp:
        (PropertySetCSSStyleDeclaration):
        (WebCore::PropertySetCSSStyleDeclaration::parentElement):
        (WebCore::PropertySetCSSStyleDeclaration::clearParentRule):
        (WebCore::PropertySetCSSStyleDeclaration::clearParentElement):
        (WebCore::PropertySetCSSStyleDeclaration::setNeedsStyleRecalc):
        (RuleCSSStyleDeclaration):
        (WebCore::RuleCSSStyleDeclaration::RuleCSSStyleDeclaration):
        (WebCore::RuleCSSStyleDeclaration::parentRule):
        (WebCore::RuleCSSStyleDeclaration::clearParentRule):
        (WebCore):
        (InlineCSSStyleDeclaration):
        (WebCore::InlineCSSStyleDeclaration::InlineCSSStyleDeclaration):
        (WebCore::InlineCSSStyleDeclaration::parentElement):
        (WebCore::InlineCSSStyleDeclaration::clearParentElement):
        (WebCore::StylePropertySet::StylePropertySet):
        (WebCore::StylePropertySet::removeShorthandProperty):
        (WebCore::StylePropertySet::removeProperty):
        (WebCore::StylePropertySet::setProperty):
        (WebCore::StylePropertySet::parseDeclaration):
        (WebCore::StylePropertySet::addParsedProperties):
        (WebCore::StylePropertySet::addParsedProperty):
        (WebCore::StylePropertySet::merge):
        (WebCore::StylePropertySet::removePropertiesInSet):
        (WebCore::StylePropertySet::copy):
        (WebCore::StylePropertySet::ensureCSSStyleDeclaration):
        (WebCore::StylePropertySet::ensureRuleCSSStyleDeclaration):
        (WebCore::StylePropertySet::ensureInlineCSSStyleDeclaration):
        (WebCore::StylePropertySet::clearParentRule):
        (WebCore::StylePropertySet::clearParentElement):
        (WebCore::PropertySetCSSStyleDeclaration::setCssText):
        (WebCore::PropertySetCSSStyleDeclaration::setProperty):
        (WebCore::PropertySetCSSStyleDeclaration::removeProperty):
        (WebCore::PropertySetCSSStyleDeclaration::setPropertyInternal):
        (WebCore::RuleCSSStyleDeclaration::setNeedsStyleRecalc):
        (WebCore::InlineCSSStyleDeclaration::setNeedsStyleRecalc):
        * css/StylePropertySet.h:
        (WebCore::StylePropertySet::create):
        (StylePropertySet):
        (WebCore::StylePropertySet::useStrictParsing):
        (WebCore::StylePropertySet::contextStyleSheet):
        (WebCore::StylePropertySet::setContextStyleSheet):
        * css/WebKitCSSKeyframeRule.cpp:
        (WebCore::WebKitCSSKeyframeRule::~WebKitCSSKeyframeRule):
        (WebCore::WebKitCSSKeyframeRule::setDeclaration):
        * css/WebKitCSSKeyframeRule.h:
        (WebCore::WebKitCSSKeyframeRule::style):
        * dom/ElementAttributeData.cpp:
        (WebCore::ElementAttributeData::ensureInlineStyleDecl):
        (WebCore::ElementAttributeData::destroyInlineStyleDecl):
        * dom/ElementAttributeData.h:
        (ElementAttributeData):
        * dom/StyledElement.cpp:
        (WebCore::StyledElement::insertedIntoDocument):
        (WebCore):
        (WebCore::StyledElement::removedFromDocument):
        (WebCore::StyledElement::parseAttribute):
        (WebCore::StyledElement::inlineStyleChanged):
        (WebCore::StyledElement::setInlineStyleProperty):
        (WebCore::StyledElement::removeInlineStyleProperty):
        (WebCore::StyledElement::updateAttributeStyle):
        * dom/StyledElement.h:
        (StyledElement):
        (WebCore::StyledElement::destroyInlineStyleDecl):
        * editing/ApplyStyleCommand.cpp:
        (WebCore::ApplyStyleCommand::applyRelativeFontStyleChange):
        * editing/DeleteButtonController.cpp:
        (WebCore::DeleteButtonController::createDeletionUI):
        (WebCore::DeleteButtonController::show):
        (WebCore::DeleteButtonController::hide):
        * editing/Editor.cpp:
        (WebCore::Editor::applyEditingStyleToElement):
        * editing/RemoveCSSPropertyCommand.cpp:
        (WebCore::RemoveCSSPropertyCommand::doApply):
        (WebCore::RemoveCSSPropertyCommand::doUnapply):
        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::removeRedundantStylesAndKeepStyleSpanInline):
        * html/ColorInputType.cpp:
        (WebCore::ColorInputType::updateColorSwatch):
        * html/HTMLTextFormControlElement.cpp:
        (WebCore::HTMLTextFormControlElement::updatePlaceholderVisibility):
        * html/ImageDocument.cpp:
        (WebCore::ImageDocument::resizeImageToFit):
        (WebCore::ImageDocument::restoreImageSize):
        (WebCore::ImageDocument::windowSizeChanged):
        * html/ValidationMessage.cpp:
        (WebCore::adjustBubblePosition):
        (WebCore::ValidationMessage::buildBubbleTree):
        * html/shadow/MediaControlElements.cpp:
        (WebCore::MediaControlElement::show):
        (WebCore::MediaControlElement::hide):
        (WebCore::MediaControlPanelElement::setPosition):
        (WebCore::MediaControlPanelElement::resetPosition):
        (WebCore::MediaControlPanelElement::makeOpaque):
        (WebCore::MediaControlPanelElement::makeTransparent):
        (WebCore::MediaControlInputElement::show):
        (WebCore::MediaControlInputElement::hide):
        (WebCore::MediaControlTextTrackContainerElement::updateSizes):
        * html/shadow/MeterShadowElement.cpp:
        (WebCore::MeterValueElement::setWidthPercentage):
        * html/shadow/ProgressShadowElement.cpp:
        (WebCore::ProgressValueElement::setWidthPercentage):
        * html/shadow/SliderThumbElement.cpp:
        (WebCore::TrackLimiterElement::create):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::resize):
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::styleDidChange):
        * svg/SVGFontFaceElement.cpp:
        (WebCore::SVGFontFaceElement::SVGFontFaceElement):
        (WebCore::SVGFontFaceElement::insertedIntoDocument):
        (WebCore::SVGFontFaceElement::removeFromMappedElementSheet):

2012-02-15  Daniel Cheng  <dcheng@chromium.org>

        dataTransfer.types (HTML5 drag & drop) should return DOMStringList
        https://bugs.webkit.org/show_bug.cgi?id=30416

        Reviewed by Eric Seidel.

        This change breaks backwards compatibility; however, since Firefox only supported
        event.dataTransfer.types.contains, sites already needed to check whether to use contains or
        indexOf. Therefore, the net compatibility effect of this change should be minimal.

        Test: fast/events/drag-dataTransfer-live-attributes.html

        * bindings/js/JSClipboardCustom.cpp:
        (WebCore):
        * bindings/v8/custom/V8ClipboardCustom.cpp:
        * dom/Clipboard.cpp:
        (WebCore::Clipboard::hasStringOfType):
        * dom/Clipboard.h:
        (WebCore):
        (Clipboard):
        * dom/Clipboard.idl:
        * platform/blackberry/ClipboardBlackBerry.cpp:
        (WebCore::ClipboardBlackBerry::types):
        * platform/blackberry/ClipboardBlackBerry.h:
        (ClipboardBlackBerry):
        * platform/chromium/ChromiumDataObject.cpp:
        (WebCore::ChromiumDataObject::types):
        * platform/chromium/ChromiumDataObject.h:
        (ChromiumDataObject):
        * platform/chromium/ClipboardChromium.cpp:
        (WebCore::ClipboardChromium::types):
        (WebCore::ClipboardChromium::mayUpdateItems):
        * platform/chromium/ClipboardChromium.h:
        (ClipboardChromium):
        * platform/chromium/DragDataChromium.cpp:
        (WebCore::containsHTML):
        (WebCore::DragData::containsURL):
        (WebCore::DragData::asURL):
        (WebCore::DragData::containsPlainText):
        (WebCore::DragData::canSmartReplace):
        (WebCore::DragData::asFragment):
        * platform/efl/ClipboardEfl.cpp:
        (WebCore::ClipboardEfl::types):
        * platform/efl/ClipboardEfl.h:
        (ClipboardEfl):
        * platform/gtk/ClipboardGtk.cpp:
        (WebCore::ClipboardGtk::types):
        * platform/gtk/ClipboardGtk.h:
        (ClipboardGtk):
        * platform/mac/ClipboardMac.h:
        (ClipboardMac):
        * platform/mac/ClipboardMac.mm:
        (WebCore::addHTMLClipboardTypesForCocoaType):
        (WebCore::ClipboardMac::types):
        * platform/qt/ClipboardQt.cpp:
        (WebCore::ClipboardQt::types):
        * platform/qt/ClipboardQt.h:
        (ClipboardQt):
        * platform/win/ClipboardWin.cpp:
        (WebCore::addMimeTypesForFormat):
        (WebCore::ClipboardWin::types):
        * platform/win/ClipboardWin.h:
        (ClipboardWin):
        * platform/wx/ClipboardWx.cpp:
        (WebCore::ClipboardWx::types):
        * platform/wx/ClipboardWx.h:
        (ClipboardWx):

2012-02-15  Bear Travis  <betravis@adobe.com>

        Repaint issues on changing 'viewBox' of inner SVG
        https://bugs.webkit.org/show_bug.cgi?id=77903

        Reviewed by Nikolas Zimmermann.

        Do not update the child viewbox/viewport transform to its parent
        coordinate system until after layout has stored the old bounds for
        repainting purposes.
        
        Test: svg/repaint/inner-svg-change-viewBox-contract.svg

        * rendering/svg/RenderSVGViewportContainer.cpp:
        (WebCore::RenderSVGViewportContainer::RenderSVGViewportContainer):
        (WebCore::RenderSVGViewportContainer::calcViewport):
        (WebCore):
        (WebCore::RenderSVGViewportContainer::calculateLocalTransform):
        (WebCore::RenderSVGViewportContainer::localToParentTransform):
        * rendering/svg/RenderSVGViewportContainer.h:
        (WebCore::RenderSVGViewportContainer::setNeedsTransformUpdate):
        (RenderSVGViewportContainer):
        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::svgAttributeChanged):

2012-02-15  Bear Travis  <betravis@adobe.com>

        Repaint issues on changing 'viewBox' of inner SVG
        https://bugs.webkit.org/show_bug.cgi?id=77903

        Reviewed by Nikolas Zimmermann.

        Do not update the child viewbox/viewport transform to its parent
        coordinate system until after layout has stored the old bounds for
        repainting purposes.
        
        Test: svg/repaint/inner-svg-change-viewBox-contract.svg

        * rendering/svg/RenderSVGViewportContainer.cpp:
        (WebCore::RenderSVGViewportContainer::RenderSVGViewportContainer):
        (WebCore::RenderSVGViewportContainer::calcViewport):
        (WebCore):
        (WebCore::RenderSVGViewportContainer::calculateLocalTransform):
        (WebCore::RenderSVGViewportContainer::localToParentTransform):
        * rendering/svg/RenderSVGViewportContainer.h:
        (WebCore::RenderSVGViewportContainer::setNeedsTransformUpdate):
        (RenderSVGViewportContainer):
        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::svgAttributeChanged):

2012-02-15  Daniel Cheng  <dcheng@chromium.org>

        dataTransfer.types (HTML5 drag & drop) should return DOMStringList
        https://bugs.webkit.org/show_bug.cgi?id=30416

        Reviewed by Eric Seidel.

        This change breaks backwards compatibility; however, since Firefox only supported
        event.dataTransfer.types.contains, sites already needed to check whether to use contains or
        indexOf. Therefore, the net compatibility effect of this change should be minimal.

        Test: fast/events/drag-dataTransfer-live-attributes.html

        * bindings/js/JSClipboardCustom.cpp:
        (WebCore):
        * bindings/v8/custom/V8ClipboardCustom.cpp:
        * dom/Clipboard.cpp:
        (WebCore::Clipboard::hasStringOfType):
        * dom/Clipboard.h:
        (WebCore):
        (Clipboard):
        * dom/Clipboard.idl:
        * platform/blackberry/ClipboardBlackBerry.cpp:
        (WebCore::ClipboardBlackBerry::types):
        * platform/blackberry/ClipboardBlackBerry.h:
        (ClipboardBlackBerry):
        * platform/chromium/ChromiumDataObject.cpp:
        (WebCore::ChromiumDataObject::types):
        * platform/chromium/ChromiumDataObject.h:
        (ChromiumDataObject):
        * platform/chromium/ClipboardChromium.cpp:
        (WebCore::ClipboardChromium::types):
        (WebCore::ClipboardChromium::mayUpdateItems):
        * platform/chromium/ClipboardChromium.h:
        (ClipboardChromium):
        * platform/chromium/DragDataChromium.cpp:
        (WebCore::containsHTML):
        (WebCore::DragData::containsURL):
        (WebCore::DragData::asURL):
        (WebCore::DragData::containsPlainText):
        (WebCore::DragData::canSmartReplace):
        (WebCore::DragData::asFragment):
        * platform/efl/ClipboardEfl.cpp:
        (WebCore::ClipboardEfl::types):
        * platform/efl/ClipboardEfl.h:
        (ClipboardEfl):
        * platform/gtk/ClipboardGtk.cpp:
        (WebCore::ClipboardGtk::types):
        * platform/gtk/ClipboardGtk.h:
        (ClipboardGtk):
        * platform/mac/ClipboardMac.h:
        (ClipboardMac):
        * platform/mac/ClipboardMac.mm:
        (WebCore::addHTMLClipboardTypesForCocoaType):
        (WebCore::ClipboardMac::types):
        * platform/qt/ClipboardQt.cpp:
        (WebCore::ClipboardQt::types):
        * platform/qt/ClipboardQt.h:
        (ClipboardQt):
        * platform/win/ClipboardWin.cpp:
        (WebCore::addMimeTypesForFormat):
        (WebCore::ClipboardWin::types):
        * platform/win/ClipboardWin.h:
        (ClipboardWin):
        * platform/wx/ClipboardWx.cpp:
        (WebCore::ClipboardWx::types):
        * platform/wx/ClipboardWx.h:
        (ClipboardWx):

2012-02-15  Bear Travis  <betravis@adobe.com>

        Repaint issues on changing 'viewBox' of inner SVG
        https://bugs.webkit.org/show_bug.cgi?id=77903

        Reviewed by Nikolas Zimmermann.

        Do not update the child viewbox/viewport transform to its parent
        coordinate system until after layout has stored the old bounds for
        repainting purposes.
        
        Test: svg/repaint/inner-svg-change-viewBox-contract.svg

        * rendering/svg/RenderSVGViewportContainer.cpp:
        (WebCore::RenderSVGViewportContainer::RenderSVGViewportContainer):
        (WebCore::RenderSVGViewportContainer::calcViewport):
        (WebCore):
        (WebCore::RenderSVGViewportContainer::calculateLocalTransform):
        (WebCore::RenderSVGViewportContainer::localToParentTransform):
        * rendering/svg/RenderSVGViewportContainer.h:
        (WebCore::RenderSVGViewportContainer::setNeedsTransformUpdate):
        (RenderSVGViewportContainer):
        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::svgAttributeChanged):

2012-02-15  Anders Carlsson  <andersca@apple.com>

        Fix unused parameter warnings.

        * platform/graphics/ca/mac/WebTileCacheLayer.mm:
        (-[WebTileCacheLayer setContentsScale:]):

2012-02-15  Emil A Eklund  <eae@chromium.org>

        Convert RenderFrameSet to LayoutUnits in preparation for turning on subpixel layout
        https://bugs.webkit.org/show_bug.cgi?id=78526

        Reviewed by Eric Seidel.

        Revert paintColumnBorder and paintRowBorder to IntRect and pixel snap in
        paint before calling them. This way the rounding logic is contained in a
        single place (in paint).

        No new tests, no new functionality.

        * rendering/RenderFrameSet.cpp:
        (WebCore::RenderFrameSet::paintColumnBorder):
        (WebCore::RenderFrameSet::paintRowBorder):
        (WebCore::RenderFrameSet::paint):
        (WebCore::RenderFrameSet::getCursor):
        * rendering/RenderFrameSet.h:
        (RenderFrameSet):

2012-02-15  Emil A Eklund  <eae@chromium.org> and Levi Weintraub  <leviw@chromium.org>

        Add FractionalLayoutPoint/Size/Rect for sub-pixel layout
        https://bugs.webkit.org/show_bug.cgi?id=76571

        Reviewed by Eric Seidel.

        Add fixed point versions of the Point, Size and Rect classes using
        the new FractionalLayoutPoint type and.

        FractionalLayoutPoint, FractionalLayoutSize and FractionalLayoutRect are
        Point, Size and Rect implementations respectively using this new type.

        No new tests.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * WebCore.gypi:
        * WebCore.order:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/FractionalLayoutUnit.h:
        Fixed a couple of typos and signed/unsigned bugs.

        * platform/graphics/FloatPoint.cpp:
        (WebCore::FloatPoint::FloatPoint):
        Add explicit FloatPoint(FractionalLayoutPoint) constructor.
        
        (WebCore::FloatPoint::move):
        Add move(FractionalLayoutSize) implementation.
        
        (WebCore::FloatPoint::moveBy):
        Add moveBy(FractionalLayoutPoint) implementation.

        * platform/graphics/FloatPoint.h:
        * platform/graphics/FloatRect.cpp:
        (WebCore::FloatRect::FloatRect):
        Add explicit FloatRectFractionalLayoutRect) constructor.
        
        * platform/graphics/FloatRect.h:
        (WebCore):
        (FloatRect):
        * platform/graphics/FloatSize.cpp:
        (WebCore::FloatSize::FloatSize):
        Add explicit FloatSize(FractionalLayoutSize) constructor.

        * platform/graphics/FloatSize.h:
        * platform/graphics/FractionalLayoutPoint.h: Added.
        * platform/graphics/FractionalLayoutRect.cpp: Added.
        * platform/graphics/FractionalLayoutRect.h: Added.
        * platform/graphics/FractionalLayoutSize.cpp: Added.
        * platform/graphics/FractionalLayoutSize.h: Added.
        * platform/graphics/IntRect.cpp:
        (WebCore::IntRect::IntRect):
        Add explicit IntRect(FractionalLayoutRect) constructor.

        * platform/graphics/IntRect.h:

2012-02-15  Kentaro Hara  <haraken@chromium.org>

        [Mac] PasteboardMac.mm build fails
        https://bugs.webkit.org/show_bug.cgi?id=78655

        Reviewed by Enrica Casucci.

        This patch fixes the code to make a plain text for pasted file names.
        The code should return a string of concatenated file names.

        Test: editing/pasteboard/drag-files-to-editable-element.html

        * platform/mac/PasteboardMac.mm:
        (WebCore::Pasteboard::plainText):

2012-02-15  Anders Carlsson  <andersca@apple.com>

        Another attempt at fixing the Snow Leopard build.

        * platform/graphics/ca/mac/TileCache.mm:
        (WebCore::TileCache::setContentsScale):

2012-02-15  Pablo Flouret  <pablof@motorola.com>

        Add support for the translate attribute in html elements.
        https://bugs.webkit.org/show_bug.cgi?id=78751

        Reviewed by Adam Barth.

        The translate attribute is used to specify whether an element's
        attribute values and the values of its Text node children are to be
        translated when the page is localized, or whether to leave them
        unchanged.

        Details at http://www.whatwg.org/specs/web-apps/current-work/multipage/elements.html#attr-translate

        Test: fast/dom/HTMLElement/translate.html

        * html/HTMLAttributeNames.in:
        * html/HTMLElement.cpp:
        (WebCore::HTMLElement::translateAttributeMode):
        (WebCore):
        (WebCore::HTMLElement::translate):
        (WebCore::HTMLElement::setTranslate):
        * html/HTMLElement.h:
        (HTMLElement):
        * html/HTMLElement.idl:

2012-02-15  Sami Kyostila  <skyostil@google.com>

        Add -webkit-overflow-scrolling CSS property
        https://bugs.webkit.org/show_bug.cgi?id=78664

        Reviewed by Eric Seidel.

        Add a CSS property indicating that an element with overflow scrolling
        should follow the platform's behavior for touch scrollable user
        interface objects. For instance, this property could enable momentum
        scrolling for the element if that is the platform convention.

        The property has two possible values: auto (default) and touch. The
        former does not alter overflow scrolling behavior, while the latter
        activates touch scrolling.

        As a side effect, enabling touch scrolling also causes an element to
        gain a stacking context. This is to allow the implementation to promote
        the scrolling contents into a render layer, which can be translated more
        efficiently.

        This property was introduced with iOS 5 WebKit. Another implementation
        is in Chrome for Android.

        Test: platform/chromium/compositing/overflow/overflow-scrolling-touch-stacking-context.html

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore):
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        * css/CSSProperty.cpp:
